function HV = htimesv(fun,x,V,Extra)
%
%HtimesV
%
%	HV = HtimesV(fun,x,V,Extra)
%
%	Computes the product H*V. 
%
%       The user's function is identified by a unique identifier
%       fun. See ADMIT users manual for detail.
%
%       HV=HtimesV(fun,x,V) computes J*V at point x.
%
%       Please refer to ADMIT users manual for complete reference.
%
%       ALSO SEE revprod, jacsp
%
%
%       ******************************************************************
%       *              ADMIT Project   10-1-96                           *
%       *              Copyright (c) 1996 Cornell University.            *
%       ******************************************************************
global tape;
global tapecounter;
global varcounter;
global globp;
if nargin < 4 Extra=[]; end
cleanup;
n=length(x); 
fun=deblank(fun);
globp=size(V,2);
xx=derivtapeH(x,V);
y=feval(fun,xx,Extra);
parsetape(eye(globp));
HV=tape(1).W;
