  function[f,Jout] = sfdsub(fun,x,Extra,m,verb,JPI)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% INPUT:
%  fun : handle to the function
%   x: Estimate J at the current point x.
%   J: the sparse matrix structure of the Jacobian
%   Jr: the sparse matrix structure of the J by columns
%   Jc: the sparse matrix structure of the J by rows
%   groups : The groups of columns and rows
%
%   o :    These are some internal information from partition algorithm
%   rc :
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
n=length(x);
if nargin < 6
JPI=[];
end

if isempty(JPI)
JPI= getJPI(fun, m, n,Extra,'s');
end
Jc=JPI.Jc;
Jr=JPI.Jr;
V=JPI.V;
W=JPI.W;
gr=JPI.gr;
gc=JPI.gc;
o=JPI.order;
rc=JPI.roworcol;
rowcons=JPI.rowcons;
colcons=JPI.colcons;
invpermrow=JPI.invpermrow;
invpermrow=JPI.invpermcol;
p=JPI.p;
p1=JPI.p1;
q=JPI.q;
A=JPI.A;
m=size(Jc,1);
ncol=size(V,2);
nrow=size(W,2);


if isempty(verb) verb=0; end
if (verb >=1)
        disp(sprintf('Number of Row groups = %d',max(gr)));
        disp(sprintf('Number of column groups = %d',max(gc)));
        disp(sprintf('Total Number of groups = %d',max(gc)+max(gr)));
end
if (verb >= 2)
        subplot(2,2,1);
        spy(Jr+Jc);
        title 'Sparsity Structure of J'
        subplot(2,2,2);
        spy(Jr);
        title 'Jr: Part computed by reverse AD'
        subplot(2,2,3);
        spy(Jc);
        title 'Jc: Part computed by forward AD'
end
  JV = zeros(m,ncol);
  WJ=zeros(n,nrow);
% Form AD products
   if ncol >0
	[f,JV] =forwprod(fun,x,V,m,Extra);
   end
   if nrow >0
	[f,WJ] =revprod(fun,x,W,Extra);
   end
if ((ncol==0)&(nrow==0)) f=funcvalJ(fun,x,m,Extra); end

if (ncol==0)
gc(find(gc==0))=ones(length(find(gc==0)),1);
  [i, j]=find(Jr);
  Jout = sparse(i,j,WJ((gr(i)-1)*n + j),m,n);
end

if (nrow==0)
gr(find(gr==0))=ones(length(find(gr==0)),1);
  [i, j]=find(Jc);
  Jout = sparse(i,j,JV((gc(j)-1)*m + i),m,n);
end
if (ncol> 0) &(nrow > 0)
JV=JV';
WJ=WJ';
b=[];
if ncol> 0
b=[b;reshape(JV,m*ncol,1)];
end
if nrow > 0
b=[b;reshape(WJ,n*nrow,1)];
end
b=b(p1(p));
Jflat=A\b;
Jflat(q)=Jflat;
[i,j]=find((Jr+Jc)');
Jout=sparse(i,j,Jflat,n,m);
Jout=Jout';
end
