function [val,grad] = funcval(fun,x,Extra)
%
%funcvalJ
%
%       Computes  the value and gradient  of a scalar function
%
%       The user's function is identified by a unique identifier
%       fun. See ADMIT users manual for detail.
%
%       v=funcval(fun,x) 
%       [v,grad]=funcval(fun,x) 
%
%       Please refer to ADMIT users manual for complete reference.
%
%       ALSO SEE HessSP. HtimesV
%
%
%       ******************************************************************
%       *              ADMIT Project   10-1-96                           *
%       *              Copyright (c) 1996 Cornell University.            *
%       ******************************************************************
if nargin < 3 Extra=[]; end
fun=deblank(fun);
	if nargout==1
		val=feval(fun,x,Extra);
	else
		[val,grad]=revprod(fun,x,1,Extra);
	end
