function val = funcvalJ(fun,x,m,Extra)
%
%funcvalJ
%
%       Computes  the value of the (vector) function
%
%       The user's function is identified by a unique identifier
%       fun. See ADMIT users manual for detail.
%
%       f=funcvalJ(fun,x) 
%
%       Please refer to ADMIT users manual for complete reference.
%
%       ALSO SEE revprod, forwprod, funcval, JacSP
%
%
%       ******************************************************************
%       *              ADMIT Project   10-1-96                           *
%       *              Copyright (c) 1996 Cornell University.            *
%       ******************************************************************
n=length(x);
fun=deblank(fun);
if nargin < 3 m=[]; end
if nargin < 4 Extra=[]; end
if isempty(m) m=n; end

fun=deblank(fun);
val=feval(fun,x,Extra);
