function [f,WJ] = forwprod(fun,x,W,Extra)
%
%forwprod
%
%	Computes forward mode product J*V using ADOLC 
%
%       The user's function is identified by a unique identifier
%       fun. See ADMIT users manual for detail.
%
%       [f,JV]=forwprod(fun,x,V) computes J*V at point x.
%
%       Please refer to ADMIT users manual for complete reference.
%
%       ALSO SEE revprod, jacsp
%
%
%       ******************************************************************
%       *              ADMIT Project   10-1-96                           *
%       *              Copyright (c) 1996 Cornell University.            *
%       ******************************************************************
global tape;
global tapecounter;
global varcounter;
global globp;
fun=deblank(fun);
if nargin < 4 Extra=[]; end
cleanup;
n=length(x); 
f=feval(fun,x,Extra);
[p,q]=size(f);
if ((p==1) | (q==1)) globp=size(W,2);
else
globp=size(W,3);
end
tapecounter=1;
varcounter=1;
fun=deblank(fun);
xx=derivtape(x);
y=feval(fun,xx,Extra);
if globp==1
parsetapeS(W);
else
parsetape(W);
end
WJ=tape(1).W;
f=getval(y);
