function [f,HV]=ExtHVDI1(fun,x,V,fdata)
% State estimation
saveV=V;

n=length(x);

p=size(V,2);
        ExtraArg=fdata.py0;
        impl=fdata.impl;
        k=fdata.k;
        kind=fdata.kind;
        numstates=fdata.numstates;
        dims=fdata.dims;
        sizep=dims(1);
        m=dims(2);
        consts=fdata.consts;
        outind = fdata.outind;
        yfinal=fdata.yfinal;

 
 
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Recovery complete
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
total=ceil(abs((k(2)-k(1))/k(3)));
if ((k(2) < k(1)) & (k(3) > 0))
        k(3)=-k(3);
end
 
data=[0;numstates;sizep;k(3);k(1);1;consts];
 
oldf=[zeros((numstates-1)*n,1);x];
 
V=-V;
oldJV=[zeros((numstates-1)*n,p),V];
zz=zeros(sizep,p);
LinvAV=[];
y=zeros(n,total+1);
y(:,1)=x;
accumy=x;
accumJV=V;

for i=1:total-1
        [y(:,i+1),JV]=forwprod(fun(1,:),[ExtraArg;oldf],[zz ; oldJV],n,data);
        data(5)=data(5)+k(3);
        data(6)=data(6)+1;
        oldf=[oldf(n+1:numstates*n);y(:,i+1)];
        oldJV=[oldJV(n+1:numstates*n,:);JV];
	LinvAV=[LinvAV;JV];
	accumy=[accumy;y(:,i+1)];
	accumJV=[accumJV;JV];
end
if total > 0
        data(4)=k(2)-(total-1)*k(3);
        [y(:,total+1),JV]=forwprod(fun(1,:),[ExtraArg;oldf],[zz ; oldJV],n,data);
	LinvAV=[LinvAV;JV];
	accumy=[accumy;y(:,total+1)];
	accumJV=[accumJV;JV];
	f=y(:,total+1);
else
	f=x;
end
outm=n;
outn=n;
datag=sizep;
 
        if length(outind)==1
                if outind==0
                        if size(fun,1) > 1
	outm=m;
        [f,JV]=forwprod(fun(1,:),[ExtraArg;f],[zz ; JV],m,data);
	LinvAV=[LinvAV;JV];
				[f,grad_y]=revprod(fun(2,:),[ExtraArg;f],f,datag);
				grad_y=[zeros(total*n,1);grad_y];
                        else
				grad_y=[zeros(total*n,1);f];
			end
                else
                if size(fun,1) > 1
		outm=m;
		outn=(total+1)*n;
        [f,JV]=forwprod(fun(1,:),[ExtraArg;accumy],[zz ; accumJV],m,data);
	LinvAV=[LinvAV;JV];
                         f=funcvalJ(fun(2,:),[ExtraArg;accumy],datag,m);
			[f,grad_y]=revprod(fun(2,:),[ExtraArg;accumy],f,datag);
                else
		outm=(total+1)*n;
		outn=(total+1)*n;
                f=accumy;
		grad_y=f;
                end
                end
        else
        % outputindex is active
        outindy=[];
        for count=1:size(outind,1)
                outindy=[outindy;y(outind(count,2)),outind(count,1)];
                ind=[ind;outind(count,1)*n+outind(count,2)];
        end
        if size(fun,1) > 1
	outm=m;
	outn=length(outindy);
        [f,JV]=forwprod(fun(2,:),[ExtraArg;outindy],[zz ; accumJV(ind)],m,data);
		[f,g_y]=revprod(fun(2,:),[ExtraArg;outindy],f,datag);
		grad_y=zeros((total+1)*n,1);
		grad_y(ind)=g_y(sizep+1:sizep+n);
        else
		outm=length(outindy);
		outn=length(outindy);
                f=outindy;
		grad_y=zeros((total+1)*n,1);
		grad_y(ind)=f;
        end
        end
% Compute w
p=1;
W=-grad_y(total*n+1:(total+1)*n);
WJaccbig=-grad_y(1:total*n);
if size(fun,1) > 1
myw=[W;-f];
else
myw=W;
end
f=f-yfinal;
f=0.5*(f'*f); 

if total > 0
        [val,W]=revprod(fun(1,:),[ExtraArg; oldf],W,data);
	if numstates > 1
        WJacc=zeros((numstates-1)*n,total*p);
        WJacc(:,(total-1)*p+1:total*p)=W(sizep+1:(numstates-1)*n+sizep,:);
        end
	W=W(sizep+(numstates-1)*n+1:sizep+numstates*n,:)+WJaccbig((total-1)*n+1:total*n,:);
        data(4)=k(3);
	myw=[W;myw];
end
for i=total-1:-1:1
        data(5)=data(5)-k(3);
        data(6)=data(6)-1;
        oldf=[y(:,i-numstates+1);oldf(1:(numstates-1)*n)];
        [val,W]=revprod(fun(1,:),[ExtraArg; oldf],W,data);
        if i < numstates
                if ((i > 1)&(numstates>1))
                        WJacc(1:(i-1)*n,(i-1)*p+1:i*p)=W(sizep+1+(numstates-i)*sizep:(numstates-1)*n+sizep,:);
                end
                W=W(sizep+(i-1)*n+1:sizep+i*n,:)+WJaccbig((i-1)*n+1:i*n,:);
                for j=i+1:min(i+numstates-1,total)
                        W=W+WJacc((2*i-j)*n+1:(2*i-j+1)*n,(j-1)*p+1:j*p);
                end
        else
                if (numstates>1)
                WJacc(:,(i-1)*p+1:i*p)=W(sizep+1:(numstates-1)*n+sizep,:);
                end
		W=W(sizep+(numstates-1)*n+1:sizep+numstates*n,:)+WJaccbig((i-1)*n+1:i*n,:);
                for j=i+1:min(i+numstates-1,total)
                        W=W+WJacc((numstates-j+i-1)*n+1:(numstates-j+i)*n,(j-1)*p+1:j*p);
                end
 
        end
	myw=[W;myw];
end
myw=-myw(n+1:(total+1)*n);


% Compute HtimesV
p=size(V,2);
C=zeros((total+1)*n,p);
ourHV=[zeros((numstates-1)*n,p);saveV];
zz=zeros(sizep,p);
oldf=y(:,1);
data=[0;numstates;sizep;k(3);k(1);1;consts];
accumHV=ourHV;

for i=1:total-1
	temp=tensprod(fun(1,:),[ExtraArg;oldf],[zz;ourHV],myw((i-1)*n+1:i*n),data);
        data(5)=data(5)+k(3);
        data(6)=data(6)+1;
        oldf=[oldf(n+1:numstates*n);y(:,i+1)];
	ourHV=[ourHV(n+1:numstates*n,:);-LinvAV((i-1)*n+1:i*n,:)];
	if i < numstates
		C(1:i*n,:)=C(1:i*n,:)+temp(sizep+1+(numstates-i)*n:sizep+numstates*n,:);
        else
	C((i-numstates)*n+1:i*n,:)=C((i-numstates)*n+1:i*n,:)+temp(sizep+1:sizep+numstates*n,:);
        end
	accumHV=[accumHV;-LinvAV((i-1)*n+1:i*n,:)];
end
if total > 0
        data(4)=k(2)-(total-1)*k(3);
        temp=tensprod(fun(1,:),[ExtraArg;oldf],[zz ; ourHV],myw((total-1)*n+1:total*n),data);
	if total < numstates
	C(1:total*n,:)=C(1:total*n,:)+temp(sizep+1+(numstates-total)*n:sizep+numstates*n,:);
	else
	C((total-numstates)*n+1:total*n,:)=C((total-numstates)*n+1:total*n,:)+temp(sizep+1:sizep+numstates*n,:);
	end
	accumHV=[accumHV;-LinvAV((total-1)*n+1:total*n,:)];
end


datag=sizep;
 
        if length(outind)==1
                if outind==0
                        if size(fun,1) > 1
		temp=tensprod(fun(2,:),[ExtraArg;y(:,total+1)],[zz;ourHV],myw(total*n+1:total*n+outm,datag)); 
		C(total*n+1:(total+1)*n,:)=temp(sizep+1:sizep+n,:);
		[val,W]=revprod(fun(2,:),[ExtraArg;y(:,total+1)],[zz;-LinvAV(total*n+1:total*n+outm)],datag);
		
		W=-C(total*n+1:(total+1)*n,:)-W(sizep+1:sizep+n,:);
			else
		W=-C(total*n+1:(total+1)*n,:)+LinvAV((total-1)*n+1:total*n,:);

			end
                else
                if size(fun,1) > 1
		temp=tensprod(fun(2,:),[ExtraArg;acummy],[zz;accumHV],myw(total*n+1:total*n+outm,datag));
		C=C+temp(sizep+1:sizep+(total+1)*n,:);
		[val,W]=revprod(fun(2,:),[ExtraArg;accumy],[zz;-LinvAV],datag);
		C=C+W;
		W=-C(total*n+1:(total+1)*n,:);
                else
		C=C-LinvAV;
		W=-C(total*n+1:(total+1)*n,:);
                end
                end
        else
        % outputindex is active
        outindy=[];
        for count=1:size(outind,1)
                outindy=[outindy;y(outind(count,2)),outind(count,1)];
                ind=[ind;outind(count,1)*n+outind(count,2)];
        end
        if size(fun,1) > 1
		temp=tensprod(fun(2,:),[ExtraArg;outindy],[zz;accumHV(ind)],myw(total*n+1:total*n+outm,datag));
		C(ind,ind)=C(ind,ind)+temp(sizep+1:sizep+length(outindy),:);
		[val,W]=revprod(fun(2,:),[ExtraArg;outindy],[zz;-LinvAV(ind)],datag);
		C(ind,ind)=C(ind,ind)+W;
		W=-C(total*n+1:(total+1)*n,:);
        else
		C(ind,ind)=C(ind,ind)-LinvAV(ind);
		W=-C(total*n+1:(total+1)*n,:);
        end
        end
if total > 0
        [val,W]=revprod(fun(1,:),[ExtraArg; oldf],W,data);
        if numstates > 1
	WJacc=zeros((numstates-1)*n,total*p);
        WJacc(:,(total-1)*p+1:total*p)=W(sizep+1:(numstates-1)*n+sizep,:);
        end
	W=W(sizep+(numstates-1)*n+1:sizep+numstates*n,:)+C((total-2)*n+1:(total-1)*n,:);
        data(4)=k(3);
end
for i=total-1:-1:1
        data(5)=data(5)-k(3);
        data(6)=data(6)-1;
        oldf=[y(:,i-numstates+1);oldf(1:(numstates-1)*n)];
        [val,W]=revprod(fun(1,:),[ExtraArg; oldf],W,data);
        if i < numstates
                if ((i > 1)&(numstates>1))
                        WJacc(1:(i-1)*n,(i-1)*p+1:i*p)=W(sizep+1+(numstates-i)*n:(numstates-1)*n+sizep,:);
                end
                W=W(sizep+(i-1)*n+1:sizep+i*n,:);
		if (i > 1)	
		W=W+C((i-2)*n+1:(i-1)*n,:);
		end
                for j=i+1:min(i+numstates-1,total)
                        W=W+WJacc((2*i-j)*n+1:(2*i-j+1)*n,(j-1)*p+1:j*p);
                end
        else
		if numstates > 1
                WJacc(:,(i-1)*p+1:i*p)=W(sizep+1:(numstates-1)*n+sizep,:);
                end
		W=W(sizep+(numstates-1)*n+1:sizep+numstates*n,:);
		if (i > 1)	
		W=W+C((i-2)*n+1:(i-1)*n,:);
                end
		for j=i+1:min(i+numstates-1,total)
                        W=W+WJacc((numstates-j+i-1)*n+1:(numstates-j+i)*n,(j-1)*p+1:j*p);
                end
 
        end
end
HV=-W(1:n,1:p);
