function [f,HV]=ExtHVgen(fun,x,V,fdata)

k=fdata(1);
data=0;
n=length(x);
for i=1:k
	implicit(i)=fdata(2*i);
	outdim(i)=fdata(2*i+1);
end

% Initialise 
saveV=V;
V=-V;
inputpt=x;
LinvAV=[];

% Forward Pass
for i=1:k-1
	[f1,JV]=forwprod(fun(i,:),inputpt,V,outdim(i),data);
	inputpt=[inputpt;f1];
	V=[V;JV];
	LinvAV=[LinvAV;JV];
end
inputptsave=inputpt;
% Compute gradient
[f,grad]=funcval(fun(k),inputpt,data);
grad_y=grad(n+1:length(grad));
% Compute w
p=1;
W=-grad_y((k-2)*n+1:(k-1)*n);
WJ=zeros((k-1)*n,k*p);
WJ(:,(k-1)*p+1:k*p)=-grad_y; 
myw=W; 
for i=k-1:-1:1
        inputpt=inputpt(1:i*n);
        [f1,WJ(1:i*n,(i-1)*p+1:i*p)]=revprod(fun(i,:),inputpt,W,data);
        W=WJ((i-1)*n+1:i*n,(k-1)*p+1:k*p);
        for j=i:k-2
        W=W+WJ((i-1)*n+1:i*n,(j-1)*p+1:j*p);
        end
	myw=[W;myw];
end
myw=-myw(n+1:k*n);
% Compute HtimesV
p=size(V,2);
C=zeros(k*n,p);
inputpt=inputptsave;
ourV=saveV;
for i=1:k-1
        inputpt=inputptsave(1:i*n);
	C(1:i*n,:)=C(1:i*n,:)+tensprod(fun(i,:),inputpt,ourV,myw((i-1)*n+1:i*n),data);
	ourV=[ourV;-LinvAV((i-1)*n+1:i*n,:)];
end
C=C+HtimesV(fun(k,:),inputptsave,ourV,data); 
% Compute final H*V

W=-C((k-1)*n+1:k*n,:);
WJ=zeros((k-1)*n,k*p);
WJ(:,(k-1)*p+1:k*p)=-C(n+1:k*n,:); 
inputpt=inputptsave;
for i=k-1:-1:1
        inputpt=inputpt(1:i*n);
        [f1,WJ(1:i*n,(i-1)*p+1:i*p)]=revprod(fun(i,:),inputpt,W,data);
	W=WJ((i-1)*n+1:i*n,(k-1)*p+1:k*p);
        for j=i:k-2
        W=W+WJ((i-1)*n+1:i*n,(j-1)*p+1:j*p);
        end
end
HV=C(1:n,:)-WJ(1:n,1:p);
