function [f,JV] = ExtJV(class,fun,x,V,fdata)
%
%ExtJV
%
%       Compute J*V for structured computation
%
%       [f,JV]=ExtJV(class,fun,x,V)
%
%       Please refer to ADMIT-2 users manual for complete reference.
%
%       ALSO SEE configureExtfun, evalHExt, ExtJV, ExtWJ, ExtHV, ExtVHV
%
%
%       ******************************************************************
%       *              ADMIT-2 Project   1996-97                         *
%       *              Copyright (c) 1996 Cornell University.            *
%       ******************************************************************
 

n=length(x);
if nargin < 5 fdata=[]; end
 
% Make the function data
if isempty(fdata) [fun,fdata]=MakeExtFdata(class,fun,n); end
 
if (class =='GI')
	if fdata.kind ==1
	[f,JV]=ExtJVDI1(fun,x,V,fdata); 
	elseif fdata.kind ==2
	[f,JV]=ExtJVDI2(fun,x,V,fdata); 
	else
	[f,JV]=ExtJVDI3(fun,x,V,fdata); 
	end
elseif class =='GF'
	[f,JV]=ExtJVgen(fun,x,V,fdata); 
elseif class == 'GC'
	if (size(fun,1)==1)
	[f,JV]=ExtJVCF(fun,x,V,fdata); 
	else
	[f,JV]=ExtJVGC(fun,x,V,fdata); 
	end
elseif class =='GP'
	if (size(fun,1)==1)
	[f,JV]=ExtJVPS(fun,x,V,fdata); 
	else
	[f,JV]=ExtJVGP(fun,x,V,fdata); 
	end	
end

