function [a1,a2,a3]=evalJfunc(func,ExtJ,n,m,b1,b2)
%
%evalJfunc
%
%       Computing with Extended Jacobian
%
%       ******************************************************************
%       *              ADMIT-2 Project   1996-97                         *
%       *              Copyright (c) 1996 Cornell University.            *
%       ******************************************************************

if nargin < 4 m=n; end
if nargin < 5 b1=[]; end
if nargin < 6 b2=[]; end

[nrow,ncol]=size(ExtJ);
A=ExtJ(1:nrow-m,1:ncol-nrow+m);
B=ExtJ(nrow-m+1:nrow,1:ncol-nrow+m);
L=ExtJ(1:nrow-m,ncol-nrow+m+1:ncol);
M=ExtJ(nrow-m+1:nrow,ncol-nrow+m+1:ncol);
if func==1
% Compute JV
	if ~isempty(L) 
		a1= B*b1-M*(L\(A*b1));
	else
		a1= B*b1;
	end
elseif func==2
% Compute (J'*W)
	if ~isempty(L) 
	a1= B'*b1-A'*(L'\(M'*b1));
	else
	a1= B'*b1;
	end
 
elseif func==3
% compute J
	if ~isempty(L)
	a1=B-M*(L\A);
	else
	a1=B;
	end

elseif func==4
% Solve Js=f
	if nargin >=6 
		[L,U,P]=lu(ExtJ(:,b2));
		a1= U\(L\(P*[zeros(nrow-m,1);-b1]));
		a1(b1)=a1;
		a1=a1(1:n);
	else
%		[L,U,P]=lu(ExtJ);
%		a1= U\(L\(P*[zeros(nrow-m,1);-b1])); 
%		a1=a1(1:n);
		a1=ExtJ\[zeros(nrow-m,1);-b1];
		a1=a1(1:n);
		
	end
elseif func==5
% Solve (J+C)s=f
	newEJ=[A L; B+b1 M];
%	p=colmmd(newEJ);
%        [L,U,P]=lu(newEJ(:,p));	
%	a1= U\(L\(P*[zeros(nrow-m,1);-b2]));
%        a1=a1(1:n);
	a1=newEJ\[zeros(nrow-m,1);-b2];
	a1=a1(1:n);


elseif func==6
% Solve CJs=f
	[cm,cn]=size(b1);
	 newEJ=[A L sparse(nrow-m,cn); B M -speye(cn); sparse(cm,ncol) b1];
%        p=colmmd(newEJ);
%        [L,U,P]=lu(newEJ(:,p));
%        a1= U\(L\(P*[zeros(nrow,1);-b2]));
%        a1=a1(1:n);
	a1=newEJ\[zeros(nrow-m,1);-b2];
	a1=a1(1:n);

elseif func==7
% Solve J'*Js=-J'f
		newEJ=[-speye(m) sparse(m,nrow-m) M B; 
			sparse(nrow-m,nrow) L A;
		        M' L' sparse(ncol-n,ncol);
			B' A' sparse(n,ncol)];
%		p=colmmd(newEJ);
%		[L,U,P]=lu(newEJ(:,p));
%		a1= U\(L\(P*[zeros(nrow+ncol-n,1);-ExtJfunc(2,ExtJ,n,m,b1)])); 
%		a1=a1(nrow+ncol-n+1:nrow+ncol);
	a1=newEJ\[zeros(nrow+ncol-n,1);-ExtJfunc(2,ExtJ,n,m,b1)];
	a1=a1(nrow+ncol-n+1:nrow+ncol);
	

elseif func==8
% Solve (J'*J+C)s=J'f

                newEJ=[-speye(m) sparse(m,n) M B;
                        sparse(nrow-m,nrow) L A;
                        M' L' sparse(ncol-n,ncol);
                        B' A' sparse(n,ncol-n) b1];
%                p=colmmd(newEJ);
%                [L,U,P]=lu(newEJ(:,p));
%                a1= U\(L\(P*[zeros(nrow+ncol-n,1);-ExtJfunc(2,ExtJ,n,m,b2]));
%                a1=a1(nrow+ncol-n+1:nrow+ncol);
	a1=newEJ\[zeros(nrow+ncol-n,1);-ExtJfunc(2,ExtJ,n,m,b2)];
	a1=a1(nrow+ncol-n+1:nrow+ncol);

elseif func==9
% Solve det(J)
	a1= det([L A; B M])/det(L);
elseif func==10
% Solve LU(J)
	
elseif func==11
% Solve QR(J)

elseif func==12
% Solve eig(J)

elseif func==13
% Solve rank(J)
	a1=rank(ExtJ);
elseif func==14
% Solve null(J)
	Z=null(full(ExtJ));
	a1=Z(1:n,:);
end
