function [f,VHV] = ExtVHV(class,fun,x,V,fdata)
%
%ExtVHV
%
%       Compute V'*H*V for structured computation
%
%       [f,VHV]=ExtVHV(class,fun,x,V)
%
%       Please refer to ADMIT-2 users manual for complete reference.
%
%       ALSO SEE configureExtfun, evalHExt, ExtJV, ExtWJ, ExtHV, ExtVHV
%
%
%       ******************************************************************
%       *              ADMIT-2 Project   1996-97                         *
%       *              Copyright (c) 1996 Cornell University.            *
%       ******************************************************************

n=length(x);
if nargin < 5 fdata=[]; end
 
% Make the function data
if isempty(fdata) [fun,fdata]=MakeExtFdata(class,fun,n); end
 
if class =='GF'
	[f,VHV]=ExtVHVgen(fun,x,V,fdata); 
elseif class == 'GC'
	[f,VHV]=ExtVHVGC(fun,x,V,fdata); 
elseif (class =='GI')
	fdata=fdata(2:length(fdata));

        if fdata.kind ==1
        [f,VHV]=ExtVHVDI1(fun,x,V,fdata);
        elseif fdata.kind ==1
        [f,VHV]=ExtVHVDI1(fun,x,V,fdata);
        else
        [f,VHV]=ExtVHVDI1(fun,x,V,fdata); 
        end
elseif class =='GP'
	[f,VHV]=ExtVHVGP(fun,x,V,fdata); 
elseif class =='DO'
	[f,VHV]=ExtVHVDO(fun,x,V,fdata); 
end

