function [f,WJ] = ExtWJ(class,fun,x,W,fdata)
%
%ExtWJ
%
%       Compute J'*W(=(W'*J)') for structured computation
%
%       [f,WJ]=ExtWJ(class,fun,x,W)
%
%       Please refer to ADMIT-2 users manual for complete reference.
%
%       ALSO SEE configureExtfun, evalHExt, ExtJV, ExtWJ, ExtHV, ExtVHV
%
%
%       ******************************************************************
%       *              ADMIT-2 Project   1996-97                         *
%       *              Copyright (c) 1996 Cornell University.            *
%       ******************************************************************

n=length(x);
if nargin < 5 fdata=[]; end
 
% Make the function data
if isempty(fdata) [fun,fdata]=MakeExtFdata(class,fun,n); end
 
if (class =='GI')
        if fdata.kind ==1
        [f,WJ]=ExtWJDI1(fun,x,W,fdata);
        elseif fdata.kind ==2
        [f,WJ]=ExtWJDI2(fun,x,W,fdata); 
        else
        [f,WJ]=ExtWJDI3(fun,x,W,fdata); 
        end
elseif class == 'GP'
	if size(fun,1)==1
	[f,WJ]=ExtWJPS(fun,x,W,fdata); 
	else
	[f,WJ]=ExtWJGP(fun,x,W,fdata); 
	end
elseif class == 'GC'
	if size(fun,1)==1
	[f,WJ]=ExtWJCF(fun,x,W,fdata); 
	else
	[f,WJ]=ExtWJGC(fun,x,W,fdata); 
	end
else
	[f,WJ]=ExtWJgen(fun,x,W,fdata); 
end

