function [f,WJ]=ExtWJDI1(fun,x,W,fdata)
% State Estimation Problem

p=size(W,2);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Recover
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
 
n=length(x);
        impl=fdata.impl;
        k=fdata.k;
        kind=fdata.kind;
        numstates=fdata.numstates;
        dims=fdata.dims;
        ExtraArg=fdata.py0;
        sizep=dims(1);
        m=dims(2);
        consts=fdata.consts;
        outind = fdata.outind;
        yfinal=fdata.yfinal;

 
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Recovery complete
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
total=ceil(abs((k(2)-k(1))/k(3)));
if ((k(2) < k(1)) & (k(3) > 0))
        k(3)=-k(3);
end

data=[0;numstates;sizep;k(3);k(1);1;consts];
oldf=[zeros((numstates-1)*n,1);x];
y=zeros(n,total+1);
y(:,1)=x;
accumy=x;
for i=1:total-1
	y(:,i+1)=funcvalJ(fun(1,:),[ExtraArg;oldf],n,data);
	data(5)=data(5)+k(3);
	data(6)=data(6)+1;
        oldf=[oldf(n+1:numstates*n);y(:,i+1)];
	accumy=[accumy;y(:,i+1)];
end

if total > 0
	data(4)=k(2)-(total-1)*k(3);
	y(:,total+1)=funcvalJ(fun(1,:),[ExtraArg;oldf],n,data);
	accumy=[accumy;y(:,total+1)];
	f=y(:,total+1);
else
        f=x;
end


	WJaccbig=zeros(total*n,p);
	W=-W;
        datag=sizep;
 
        if length(outind)==1
                if outind==0
		if size(fun,1) > 1
			[f,W]=revprod(fun(2,:),[ExtraArg;y(:,total+1)],W,datag);
			W=W(sizep+1:n+sizep,:);
                end

		else
        % all ys, do it
		if size(fun,1) > 1
		[f,W]=revprod(fun(2,:),[ExtraArg;accumy],W,datag);
		W=W(sizep+total*n+1:(total+1)*n+sizep,:);
		WJaccbig=W(sizep+1:sizep+total*n,:);

		else
		f=accumy;
		end
                end
        else
        % outputindex is active
        for count=1:size(outind,1)
                outindy=[outindy;y(outind(count,2)),outind(count,1)];
        end
	if size(fun,1) > 1
		[f,W]=revprod(fun(2,:),[ExtraArg;outindy],W,datag);
		totalW=zeros((total+1)*n,p);
        	totalW(:,ind)=W(:,sizep+1:sizep+length(outindy));
		W=totalW(sizep+total*n+1:(total+1)*n+sizep,:);
		WJaccbig=totalW(sizep+1:sizep+total*n,:);
        else
		f=outindy;
	end

end
 
if total > 0
	[val,W]=revprod(fun(1,:),[ExtraArg; oldf],W,data);
	if numstates > 1
		WJacc=zeros((numstates-1)*n,total*p);
		WJacc(:,(total-1)*p+1:total*p)=W(sizep+1:(numstates-1)*n+sizep,:);
	end
W=W(sizep+(numstates-1)*n+1:sizep+numstates*n,:)+WJaccbig((total-1)*n+1:total*n,:);
	data(4)=k(3);
end
for i=total-1:-1:1
	data(5)=data(5)-k(3);
        data(6)=data(6)-1;
        oldf=[y(:,i-numstates+1);oldf(1:(numstates-1)*n)];
	[val,W]=revprod(fun(1,:),[ExtraArg; oldf],W,data);
	if i < numstates
		if ((i > 1) & (numstates > 1))
			WJacc(1:(i-1)*n,(i-1)*p+1:i*p)=W(sizep+(numstates-i)*n+1:(numstates-1)*n+sizep,:);
		end
		W=W(sizep+(i-1)*n+1:sizep+i*n,:)+WJaccbig((i-1)*n+1:i*n,:);
		for j=i+1:min(i+numstates-1,total)
        		W=W+WJacc((2*i-j)*n+1:(2*i-j+1)*n,(j-1)*p+1:j*p);
		end
        else
		if (numstates > 1)
		WJacc(:,(i-1)*p+1:i*p)=W(sizep+1:(numstates-1)*n+sizep,:);
		end	
		W=W(sizep+(numstates-1)*n+1:sizep+numstates*n,:)+WJaccbig((i-1)*n+1:i*n,:);
		for j=i+1:min(i+numstates-1,total)
        		W=W+WJacc((numstates-j+i-1)*n+1:(numstates-j+i)*n,(j-1)*p+1:j*p);
		end

	end
end
 
WJ=-W;
f=f-yfinal;
