function [f,WJ]=ExtWJDI1(fun,x,W,fdata)
% State Estimation Problem

p=size(W,2);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Recover
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
n=length(x);
        ExtraArg=fdata.py0;
        impl=fdata.impl;
        k=fdata.k;
        kind=fdata.kind;
        numstates=fdata.numstates;
        dims=fdata.dims;
        sizep=dims(1);
        m=dims(2);
        consts=fdata.consts;
        outind = fdata.outind;
        yfinal=fdata.yfinal;

 
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Recovery complete
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
total=ceil(abs((k(2)-k(1))/k(3)));
if ((k(2) < k(1)) & (k(3) > 0))
        k(3)=-k(3);
end
 
data=[0;numstates;sizep;k(3);k(1);1;consts];
 

y=zeros(n-sizep,total+1);
y(:,1)=x(sizep+1:n);
accumy=x(sizep+1:n);
parm=x(1:sizep);

oldf=[zeros((numstates-1)*(n-sizep),1);x(sizep+1:n)];
f=oldf;

for i=1:total-1
	y(:,i+1)=funcvalJ(fun(1,:),[parm;oldf],n-sizep,data);
	data(5)=data(5)+k(3);
        data(6)=data(6)+1;
        oldf=[oldf(n-sizep+1:numstates*(n-sizep));y(:,i+1)];
	accumy=[accumy;y(:,i+1)];
end
if total > 0
        data(4)=k(2)-(total-1)*k(3);
	y(:,total+1)=funcvalJ(fun(1,:),[parm;oldf],n-sizep,data);
        accumy=[accumy;y(:,total+1)];
        f=y(:,total+1);
else
        f=x(sizep+1:n);
end

W=-W;
outWJacc=W(1:sizep,:);
WJaccbig=zeros(total*(n-sizep),p);
        datag=sizep;
 
        if length(outind)==1
                if outind==0
if size(fun,1) > 1
			[f,W]=revprod(fun(2,:),[parm;y(:,total+1)],W,datag);
			outWJacc=outWJacc+W(1:sizep,:);
			W=W(sizep+1:n,:);
else
			W=W(sizep+1:n,:);
end

                else
        % all ys, do it
if size(fun,1) > 1
		[f,W]=revprod(fun(2,:),[parm;accumy],W,datag);
                WJaccbig=W(sizep+1:sizep+total*n,:);
		outWJacc=outWJacc+W(1:sizep,:);
                W=W(sizep+total*(n-sizep)+1:(total+1)*(n-sizep)+sizep,:);
else
		f=accumy;
		W=W(sizep+1:n,:);
end
                end
        else
        % outputindex is active
        for count=1:size(outind,1)
                outindy=[outindy;y(outind(count,2)),outind(count,1)];
        end
if size(fun,1) > 1
                [f,W]=revprod(fun(2,:),[parm;outindy],W,datag);
                totalW=zeros((total+1)*(n-sizep),p);
                totalW(:,ind)=W(:,sizep+1:sizep+length(outindy));
                W=totalW(sizep+total*(n-sizep)+1:(total+1)*(n-sizep)+sizep,:);
                WJaccbig=totalW(sizep+1:sizep+total*(n-sizep),:);
		outWJacc=outWJacc+totalW(1:sizep,:);
else

		f=outindy;
		W=W(sizep+1:n,:);

end
        end

if total > 0
[val,W]=revprod(fun(1,:),[parm;oldf],W,data);
outWJacc=outWJacc+W(1:sizep,:);
        if numstates > 1
                WJacc=zeros((numstates-1)*(n-sizep),total*p);
                WJacc(:,(total-1)*p+1:total*p)=W(sizep+1:(numstates-1)*(n-sizep)+sizep,:);
        end
W=W(sizep+1:n,:);

data(4)=k(3);

end


for i=total-1:-1:1
	data(5)=data(5)-k(3);
        data(6)=data(6)-1;
        oldf=[y(:,i-numstates+1);oldf(1:(numstates-1)*n)];
	[val,W]=revprod(fun(1,:),[parm; oldf],W,data);
        if i < numstates
                if ((i > 1) & (numstates > 1))
                  WJacc(1:(i-1)*(n-sizep),(i-1)*p+1:i*p)=W(sizep+1+(numstates-i)*(n-sizep):numstates*(n-sizep)+sizep,:);
                end
       		W=W(sizep+(i-1)*(n-sizep)+1:sizep+i*(n-sizep),:)+WJaccbig((i-1)*(n-sizep)+1:i*(n-sizep),:);
                for j=i+1:min(i+numstates-1,total)
                        W=W+WJacc((2*i-j)*(n-sizep)+1:(2*i-j+1)*(n-sizep),(j-1)*p+1:j*p);
                end
        else
                if (numstates > 1)
                WJacc(:,(i-1)*p+1:i*p)=W(sizep+1:(numstates-1)*(n-sizep)+sizep,:);
                end
	W=W(sizep+(numstates-1)*(n-sizep)+1:sizep+numstates*(n-sizep),:)+WJaccbig((i-1)*(n-sizep)+1:i*(n-sizep),:);
                for j=i+1:min(i+numstates-1,total)
			W=W+WJacc((numstates-j+i-1)*(n-sizep)+1:(numstates-j+i)*(n-sizep),(j-1)*p+1:j*p);
                end
 
        end
	outWJacc=outWJacc+W(1:sizep,:);
end

f=f-yfinal; 
WJ=-[outWJacc; W];

