function fdata = MakeFdata(fun,n,k,dims,ydata,py0,kind,numstates,outind,consts,impl)
%
% Check for inconsistencies in Input data
%
if nargin < 3 k=[]; end
if nargin < 4 dims=[]; end
if nargin < 5 ydata=[]; end
if nargin < 6 py0=[]; end
if nargin < 7 kind=[]; end
if nargin < 8 numstates=[]; end
if nargin < 9 outind=[]; end
if nargin < 10 consts=[]; end
if nargin < 11 impl=0; end
 

	if isempty(k)
		k=[0;1;0.1]; 
	elseif length(k)==1
		k=[0;1;k];
	elseif length(k)==2
	 	k=[k;0.1];
	end
	total=ceil(abs((k(2)-k(1))/k(3)));

	if isempty(kind) kind=1; end
	if isempty(numstates) numstates=1; end
	if isempty(outind) outind=0; end
	if isempty(dims) dims=[n;n]; end
	if isempty(py0)
                if kind == 2 py0= zeros(dims(1),1); end
        end
	if kind==1 sizen=n; sizep=length(py0);dims(1)=sizep; end
	if kind==2 sizep=n; sizen=length(py0); end
	if kind==3 sizep=dims(1); sizen=n-sizep; end
	
	if size(fun,1)==2  
		if isempty(ydata)
			ydata=zeros(dims(2),1); 
		else
			if length(ydata) ~=dims(2) error('error in ydata'); end	
		end
	end
	if size(fun,1)==1 
		if size(outind,1)==1
                        if outind(1,1)==0
				outdim=sizen;
                        else
				outdim=(total+1)*sizen;
                        end
                else
				outdim=size(outind,1);
                end
		dims=[dims(1);outdim]; 
		if isempty(ydata)
			ydata=zeros(outdim,1); 
		else
			if length(ydata) ~=outdim error('error in ydata'); end	
		end
	end
% Insert all checks Here
        if length(dims) ~=2 error('dims must have 2 values for Inverse Problems class'); end
%	if (dims(1) <=0 | dims(2) <=0)  error('dims must be strictly positive'); end
        if length(k) ~=3 error('error in k'); end
	if (kind == 2  &  sizen <=0) error('error in py0'); end
	if (kind == 3  &  ~isempty(py0)) error('error in py0'); end
fdata.impl=impl;
fdata.k=k;
fdata.kind=kind;
fdata.numstates=numstates;
fdata.dims=dims;
fdata.py0=py0;
fdata.consts=consts;
fdata.outind=outind;
fdata.yfinal=ydata;
