function JPI=getExtHPI(class,fun,n,fdata)
%
%getExtHPI
%
%       Please refer to ADMIT-2 users manual for complete reference.
%
%       ALSO SEE configureExtfun, evalJExt, ExtJV, ExtWJ, ExtHV, ExtVHV
%
%
%       ******************************************************************
%       *              ADMIT-2 Project   1996-97                         *
%       *              Copyright (c) 1996 Cornell University.            *
%       ******************************************************************
if nargin < 4 fdata=[]; end
 
% Make the function data
if isempty(fdata) [fun,fdata]=MakeExtFdata(class,fun,n); end

if class=='GC'
	JPI{1}=getJPI(fun(1,:),n);
	JPI{2}=getTPI(fun(1,:),n);
	JPI{3}=getHPI(fun(2,:),n);
elseif class=='DO'
        k=fdata.k;
        dims=fdata.dims;
	if k*dims(1)~=n error('mismatch in setting of k, dims parameters'); end
	data=dims(1);
	datagfun=[k;dims(1)];
        JPI{1}=getJPI(fun(1,:),dims(2), dims(1)+dims(2),data);
        JPI{2}=getTPI(fun(1,:),dims(1)+dims(2),dims(2),data);
        JPI{3}=getHPI(fun(2,:),k*dims(1)+(k+1)*dims(2),datagfun);

elseif class=='GP'
	k=fdata.k;
	dims=fdata.dims;
	JPI{1}=getJPI(fun(1,:),k*m,n);
	JPI{2}=getTPI(fun(1,:),n,k*m);
	JPI{3}=getHPI(fun(2,:),k*m);

elseif class=='GI'
        impl=fdata.impl;
        k=fdata.k;
        kind=fdata.kind;
        numstates=fdata.numstates;
        dims=fdata.dims;
        sizep=dims(1);
        m=dims(2);
        consts=fdata.consts;
        outind = fdata.outind;
        yfinal=fdata.yfinal;
	total=ceil(abs((k(2)-k(1))/k(3)));

        datag=sizep;
        data=[0;numstates;sizep;k(3);k(1);numstates;consts];
        dataI=[1;numstates;sizep;k(3);k(1);numstates;consts];
	if kind==1 sizen=n;end
        if kind==2 sizen=sizep; sizep=n; end
        if kind==3 sizen=n-sizep; end

	if impl==0
        	JPI{1}=getJPI(fun(1,:),sizen,sizep+numstates*sizen,data);
		JPI{2}=getTPI(fun(1,:),sizep+numstates*sizen,sizen,data);
        else
		JPI{1}=getJPI(fun(1,:),sizen,sizep+(numstates+1)*sizen,dataI);
		JPI{2}=getTPI(fun(1,:),sizep+(numstates+1)*sizen,sizen,dataI);
        end
	if size(fun,1) > 1
                if size(outind,1)==1
                        if outind(1,1)==0
        			JPI{3}=getJPI(fun(2,:),dims(2),sizen+sizep,datag);
        			JPI{3}=getTPI(fun(2,:),sizen+sizep,dims(2),datag);
                        else
        			JPI{3}=getJPI(fun(2,:),dims(2),(total+1)*sizen+sizep,datag);
        			JPI{3}=getTPI(fun(2,:),(total+1)*sizen+sizep,dims(2),datag);
                        end
		else
        		JPI{3}=getJPI(fun(2,:),dims(2),size(outind,1)+sizep,datag);
        		JPI{4}=getTPI(fun(2,:),size(outind,1)+sizep,dims(2),datag);
                end
        end
elseif class=='GF'
% General Class
        k=fdata(1);
	for i=1:k
       	 	implicit(i)=fdata(2*i);
        	dims(i)=fdata(2*i+1);
	end

	JPI=[];
	sizenext=n;
	for i=1:k-1	
		if (implicit(i)==0)
		JPI{i}=getJPI(fun(i,:),dims(i),sizenext,0); 
		else
		JPI{i}=getJPI(fun(i,:),dims(i),sizenext+dims(i),1); 
		end	
		sizenext=sizenext+dims(i);
	end
	sizenext=n;
        for i=1:k-1
                if (implicit(i)==0)
                JPI{i+k-1}=getTPI(fun(i,:),sizenext,dims(i),0);
                else
                JPI{i+k-1}=getTPI(fun(i,:),sizenext+dims(i),dims(i),1);
                end    
		sizenext=sizenext+dims(i);
        end
	JPI{2*k-1}=getHPI(fun(k,:),n);
		 
end
if length(JPI)==1 JPI=JPI{1}; end
