function JPI=getExtJPI(class,fun,n,fdata,method)
%
%getExtJPI
%
%       Please refer to ADMIT-2 users manual for complete reference.
%
%       ALSO SEE configureExtfun, evalJExt, ExtJV, ExtWJ, ExtHV, ExtVHV
%
%
%       ******************************************************************
%       *              ADMIT-2 Project   1996-97                         *
%       *              Copyright (c) 1996 Cornell University.            *
%       ******************************************************************

if nargin < 4 fdata=[]; end
if nargin < 5 method='d'; end
 
% Make the function data
if isempty(fdata) [fun,fdata]=MakeExtFdata(class,fun,n); end
 
 
if class=='GC'
	k=fdata.k;
	JPI{1}=getJPI(fun(1,:),n,[],[],method);
	if size(fun,1)> 1
		JPI{2}=getJPI(fun(2,:),dims(2),n,[],method);
	end
elseif class=='DO'
        k=fdata.k;
        dims=fdata.dims;
        if k*dims(1)~=n error('mismatch in setting of k, dims parameters'); end
        data=dims(1);
        datagfun=[k;dims(1)];
        JPI{1}=getJPI(fun(1,:),dims(2), dims(1)+dims(2),data);
elseif class=='GP'
	k=fdata.k;
        dims=fdata.dims;
	JPI{1}=getJPI(fun(1,:),k*dims(1),n,[],method);
	if size(fun,1)> 1
	JPI{2}=getJPI(fun(2,:),dims(2),k*dims(1),[],method);
	end

elseif (class=='GI')
	impl=fdata.impl;
	k=fdata.k;
        kind=fdata.kind;
        numstates=fdata.numstates;
        dims=fdata.dims;
        sizep=dims(1);
	m=dims(2);
        consts=fdata.consts;
        outind = fdata.outind;
        yfinal=fdata.yfinal;
 
        total=ceil(abs((k(2)-k(1))/k(3)));

	if kind==1 sizen=n;end
        if kind==2 sizen=sizep; sizep=n;end
        if kind==3 sizen=n-sizep; end
	datag=sizep;	
	data=[0;numstates;sizep;k(3);k(1);numstates;consts];
	dataI=[1;numstates;sizep;k(3);k(1);numstates;consts];

	if impl==0
       		JPI{1}=getJPI(fun(1,:),sizen,sizep+numstates*sizen,data,method);
        else
		JPI{1}=getJPI(fun(1,:),sizen,sizep+(numstates+1)*sizen,dataI,method);
       	end
	if size(fun,1) ==2
		if size(outind,1)==1
			if outind(1,1)==0
        			JPI{2}=getJPI(fun(2,:),dims(2),sizen+sizep,datag,method);
        		else
				JPI{2}=getJPI(fun(2,:),dims(2),sizep+sizen*(total+1),datag,method);
			end
        	else
        		JPI{2}=getJPI(fun(2,:),dims(2),sizep+size(outind,1),datag,method);
		end
	end
elseif class=='GF'
% General Class
        k=fdata(1);
        for i=1:k
                implicit(i)=fdata(2*i);
                dims(i)=fdata(2*i+1);
        end

	sizenext=n;
	for i=1:k	
		if (implicit(i)==0)
		JPI{i}=getJPI(fun(i,:),dims(i),sizenext,0,method); 
		else
		JPI{i}=getJPI(fun(i,:),dims(i),sizenext+dims(i),1,method); 
		end	
		sizenext=sizenext+dims(i);
	end
end
if length(JPI)==1 JPI=JPI{1}; end

