function [fun,fdata] = MakeFdata(class,fun,n,k,dims,ydata,py0,kind,numstates,outind,consts,impl)
%
% Check for inconsistencies in Input data
%
if n <= 0 error('Need Problem size >= 0'); end
if nargin < 4 k=[]; end
if nargin < 5 dims=[]; end
if nargin < 6 ydata=[]; end
if nargin < 7 py0=[]; end
if nargin < 8 kind=[]; end
if nargin < 9 numstates=[]; end
if nargin < 10 outind=[]; end
if nargin < 11 consts=[]; end
if nargin < 12 impl=0; end
 
 

if (class=='GP')

	if isempty(dims)
		fdata=GPFdata(fun,n,k);
	elseif length(dims)==1
		fdata=GPFdata(fun,n,k,dims);
	else
		fdata=GPFdata(fun,n,k,dims(1),dims(2));
	end

elseif (class == 'GC')
		fdata=GCFdata(fun,n,k,dims);
elseif (class=='DO')
		fdata=DOFdata(fun,n,k,dims,py0);

elseif (class =='GI')
		fdata=GIFdata(fun,n,k,dims,ydata,py0,kind,numstates,outind,consts,impl);

elseif class =='GF'
		[fun,fdata]=GFFdata(fun,n,dims);
end

