% Demo initialization ====================
path(path,'/home/verma/LSOT');
if ~exist('SlideShowGUIFlag'), figNumber=0; end;

if ssinit(figNumber),
    str = str2mat(' ',' ',' ',' ','This demo illustrates the working of ADMIT-2 toolbox on ', ...
      ' miscellaneous structured problems', ...
      ' ',...
      ' Press the "Start" button to see the demonstration.');
    ssdisp(figNumber,str);                                      
    drawnow;
if figNumber, return; end;
end
    str = str2mat(...
      ' ADMIT-2 classifies structured problems into 5 classes :',...
      ' ',...
      '     1. Generalised partially separable(GP)', ...
      '     2. Generalised composite(GC)', ...
      '     3. Inverse problems(GI)', ...
      '     4. Discrete-time optimal control(DO)', ...
      '     5. General structured function(GF)', ...
      ' ', ...
      ' Press the "Next" button to choose a sample problem.', ...
      ' ');
ssdisp(figNumber,str);
drawnow;
if get(findobj(figNumber,'string','AutoPlay'),'value') pause(2) ; end ;
if sspause(figNumber), return; end;
 


% Beginning of the demo ==================

% Make sure the figure has black background

%set(gcf,'Color',[0 0 0]) ;

k=menu('Choose a Class of Problem','Generalised Partially separable(GP)','Generalised composite(GC)',...
	'Inverse problems(GI)','Discrete-time optimal control(DO)','General structured function(GF)');
if k==3
	k2=menu('Choose an Inverse problem','A simple BVP','Heat conductivity problem',...
'Reflection seismology problem');
end

if k==1
% Partial separable demo
	psdemo;
elseif k==2
% Composite function
	compdemo;
	
elseif k==3
% Inverse problem
	if k2==1
	% Boundary value problem
	bvpdemo;
	elseif k2==2
	% Heat equation
	heatdemo;
	else
	% Wave equation
	waveeqdemo;
	end
elseif k==4
%Discrete-time optimal control
	dtocdemo;
else
%General structured function
	gendemo;
end


