function argout=admit2ui(action,arg)
%
% ADMIT-2 Graphical User Interface
%
global matlaborc;
global N;
global fun;
global fun1;
global dim;
global dim1;
global numpartsep;
global numcomp;
global numdtoc;
global py0;
global ydata;
global kind;
global timevec;
global numstates;
global consts;
global impl;
global outind;
global x;

global funhandle;
global fdata;
global JPI;
global HPI;

if nargin < 1
	action='initialize';
end

fig=findobj(get(0,'Children'),'Tag','ADMIT2UI');
if ~isempty(fig)
	h=findobj(get(fig,'Children'),'Tag','CLASS');
	class_GP=findobj(get(h,'Children'),'Tag','Class_GP');
	GP=get(class_GP,'checked');
	class_GC=findobj(get(h,'Children'),'Tag','Class_GC');
	GC=get(class_GC,'checked');
	class_GF=findobj(get(h,'Children'),'Tag','Class_GF');
	GF=get(class_GF,'checked');
	class_DO=findobj(get(h,'Children'),'Tag','Class_DO');
	DO=get(class_DO,'checked');
	class_GI=findobj(get(h,'Children'),'Tag','Class_GI');
	GI=get(class_GI,'checked');
end

fig2=findobj(get(0,'Children'),'Tag','SETUPWIN');


if strcmp(action,'initialize')==1
%initialize
	if isempty(fig)
		fig = figure('NumberTitle','off');
		set(fig,'Tag','ADMIT2UI');
		class=uimenu(fig,'Label','Class');
		set(class,'Tag','CLASS');
		setup=uimenu(fig,'Label','Setup','CallBack',['admit2ui(''setupfun'')']);
		set(setup,'Tag','SETUP');
		init=uimenu(fig,'Label','Initialize');
		set(init,'Tag','INIT');
		method=uimenu(fig,'Label','Methods');
		set(method,'Tag','METHOD');
		misc=uimenu(fig,'Label','Misc');
		set(misc,'Tag','MISC');


class_GP=uimenu(class,'Label','Generalised partially sep GP','Separator','on','CallBack','check(1)');
class_GC=uimenu(class,'Label','Generalised Composite func GC','Separator','on','CallBack','check(2)');
class_GI=uimenu(class,'Label','Generalised Inverse probs GI','Separator','on','CallBack','check(3)');
class_DO=uimenu(class,'Label','Discrete-time optimal control DO','Separator','on','CallBack','check(4)');
class_GF=uimenu(class,'Label','General structured func GF','Separator','on','CallBack','check(5)');
set(class_GP,'Tag','Class_GP');
set(class_GC,'Tag','Class_GC');
set(class_GI,'Tag','Class_GI');
set(class_DO,'Tag','Class_DO');
set(class_GF,'Tag','Class_GF');


method_config=uimenu(init,'Label','config','CallBack','admit2ui(''config'');');
method_getfdata=uimenu(init,'Label','getfdata','CallBack','admit2ui(''getfdata'');');
method_getJPI=uimenu(init,'Label','getJPI','CallBack','admit2ui(''getjpi'');');
method_getHPI=uimenu(init,'Label','getHPI','CallBack','admit2ui(''gethpi'');');


method_funcval=uimenu(method,'Label','evaluate f','CallBack','admit2ui(''funcval'');');
method_funcvalJ=uimenu(method,'Label','evaluate F','CallBack','admit2ui(''funcvalJ'');');
method_evalJ=uimenu(method,'Label','evalJ','CallBack','admit2ui(''evalJ'');');
method_evalH=uimenu(method,'Label','evalH','CallBack','admit2ui(''evalH'');');
method_nsJ=uimenu(method,'Label','ns=-J\f','CallBack','ns=admit2ui(''nsJ'');ns');
method_nsH=uimenu(method,'Label','ns=-H\g','CallBack','ns=admit2ui(''nsH'');ns');
method_JV=uimenu(method,'Label','J*V','CallBack','admit2ui(''JV'')');
method_WJ=uimenu(method,'Label','W*J','CallBack','admit2ui(''WJ'')');
method_HV=uimenu(method,'Label','HV','CallBack','admit2ui(''HV'')');
method_VHV=uimenu(method,'Label','VHV','CallBack','admit2ui(''VHV'')');
method_more=uimenu(method,'Label','To be added');

cleanup=uimenu(misc,'Label','cleanup','CallBack','cleanup');

end

elseif strcmp(action,'config')==1
if strcmp(GP,'on')==1
	if ~isempty(fun1)
        funhandle=configEF('GP',MakeFile(fun,fun1),[],matlaborc);
        else
	funhandle=configEF('GP',fun,[],matlaborc);
	end
elseif  strcmp(GC,'on')==1
        funhandle=configEF('GC',fun,[],matlaborc);
elseif  strcmp(GI,'on')==1
        funhandle=configEF('GI',fun,[],matlaborc);
elseif  strcmp(DO,'on')==1
        funhandle=configEF('DO',MakeFile(fun,fun1),[],matlaborc);
else
        funhandle=configEF('GF',MakeFile(fun,fun1),[1;0],matlaborc);
end
argout=funhandle;
elseif strcmp(action,'getfdata')==1
if strcmp(GP,'on')==1
        fdata=GPFdata(funhandle,N,numpartsep,[dim;dim1]);
elseif  strcmp(GC,'on')==1
        fdata=GCFdata(funhandle,N,numcomp,dim);
elseif  strcmp(GI,'on')==1
        fdata=GIFdata(funhandle,N,timevec,dim,ydata,py0,kind,numstates,outind,consts,impl);
elseif  strcmp(DO,'on')==1
	py0=ones(N/numdtoc,1);
        fdata=DOFdata(funhandle,N,numdtoc,[N/numdtoc;N/numdtoc],py0);
else
        [funhandle,fdata]=GFFdata(funhandle,N,[dim;dim1]);
end
argout=fdata;

elseif strcmp(action,'getjpi')==1
if strcmp(GP,'on')==1
	JPI=GetExtJPI('GP',funhandle,N,fdata);
elseif  strcmp(GC,'on')==1
	JPI=GetExtJPI('GC',funhandle,N,fdata);
elseif  strcmp(GI,'on')==1
	JPI=GetExtJPI('GI',funhandle,N,fdata);
elseif  strcmp(DO,'on')==1
	JPI=GetExtJPI('DO',funhandle,N,fdata);
else
	JPI=GetExtJPI('GF',funhandle,N,fdata);
end
argout=JPI;
elseif strcmp(action,'gethpi')==1
if strcmp(GP,'on')==1
	HPI=GetExtHPI('GP',funhandle,N,fdata);
 
elseif  strcmp(GC,'on')==1
	HPI=GetExtHPI('GC',funhandle,N,fdata);
 
elseif  strcmp(DO,'on')==1
	HPI=GetExtHPI('DO',funhandle,N,fdata); 
elseif  strcmp(GI,'on')==1
	HPI=GetExtHPI('GI',funhandle,N,fdata);
else
	HPI=GetExtHPI('GF',funhandle,N,fdata);
end
argout=HPI;
elseif strcmp(action,'funcvalJ')==1
if strcmp(GP,'on')==1
        f=funcvalJExt('GP',funhandle,x,fdata);
elseif  strcmp(GC,'on')==1
        f=funcvalJExt('GC',funhandle,x,fdata);
elseif  strcmp(GI,'on')==1
        f=funcvalJExt('GI',funhandle,x,fdata);
elseif  strcmp(DO,'on')==1
        f=funcvalJExt('DO',funhandle,x,fdata);
else
        f=funcvalJExt('GF',funhandle,x,fdata);
end
argout=f;

elseif strcmp(action,'funcval')==1
if strcmp(GP,'on')==1
        f=funcvalExt('GP',funhandle,x,fdata);
elseif  strcmp(GC,'on')==1
        f=funcvalExt('GC',funhandle,x,fdata);
elseif  strcmp(DO,'on')==1
        f=funcvalExt('DO',funhandle,x,fdata);
elseif  strcmp(GI,'on')==1
        f=funcvalExt('GI',funhandle,x,fdata);
else
        f=funcvalExt('GF',funhandle,x,fdata);
end
argout=f;

elseif strcmp(action,'HV')==1
	if nargin ==2 
		V=arg;
	else
		V=ones(N,1);
	end
if strcmp(GP,'on')==1
        [f,HV]=ExtHV('GP',funhandle,x,V,fdata);
elseif  strcmp(GC,'on')==1
        [f,HV]=ExtHV('GC',funhandle,x,V,fdata);
elseif  strcmp(DO,'on')==1
        [f,HV]=ExtHV('DO',funhandle,x,V,fdata);
elseif  strcmp(GI,'on')==1
        [f,HV]=ExtHV('GI',funhandle,x,V,fdata);
else
        [f,HV]=ExtHV('GF',funhandle,x,V,fdata);
end
argout=HV;

elseif strcmp(action,'VHV')==1
	if nargin ==2 
		V=arg;
	else
		V=ones(N,1);
	end
if strcmp(GP,'on')==1
        [f,VHV]=ExtVHV('GP',funhandle,x,V,fdata);
elseif  strcmp(GC,'on')==1
        [f,VHV]=ExtVHV('GC',funhandle,x,V,fdata);
elseif  strcmp(DO,'on')==1
        [f,VHV]=ExtVHV('DO',funhandle,x,V,fdata);
elseif  strcmp(GI,'on')==1
        [f,VHV]=ExtVHV('GI',funhandle,x,V,fdata);
else
        [f,VHV]=ExtVHV('GF',funhandle,x,V,fdata);
end
argout=VHV;


elseif strcmp(action,'JV')==1
	if nargin ==2 
		V=arg;
	else
		V=ones(N,1);
	end
if strcmp(GP,'on')==1
        [f,JV]=ExtJV('GP',funhandle,x,V,fdata);
elseif  strcmp(GC,'on')==1
        [f,JV]=ExtJV('GC',funhandle,x,V,fdata);
elseif  strcmp(DO,'on')==1
        [f,JV]=ExtJV('DO',funhandle,x,V,fdata);
elseif  strcmp(GI,'on')==1
        [f,JV]=ExtJV('GI',funhandle,x,V,fdata);
else
        [f,JV]=ExtJV('GF',funhandle,x,V,fdata);
end
argout=JV;

elseif strcmp(action,'WJ')==1
	if nargin ==2 
		V=arg;
	else
		V=ones(N,1);
	end
if strcmp(GP,'on')==1
        [f,JV]=ExtWJ('GP',funhandle,x,V,fdata);
elseif  strcmp(GC,'on')==1
        [f,JV]=ExtWJ('GC',funhandle,x,V,fdata);
elseif  strcmp(DO,'on')==1
        [f,JV]=ExtWJ('DO',funhandle,x,V,fdata);
elseif  strcmp(GI,'on')==1
        [f,JV]=ExtWJ('GI',funhandle,x,V,fdata);
else
        [f,JV]=ExtWJ('GF',funhandle,x,V,fdata);
end
argout=JV;

elseif strcmp(action,'evalJ')==1
if strcmp(GP,'on')==1
        [f,extJ]=evalJExt('GP',funhandle,x,fdata,JPI);
        spy(extJ)
elseif  strcmp(GC,'on')==1
        [f,extJ]=evalJExt('GC',funhandle,x,fdata,JPI);
        spy(extJ)
elseif  strcmp(GI,'on')==1
	x=2*rand(N,1);
        [f,extJ]=evalJExt('GI',funhandle,x,fdata,JPI);
        spy(extJ)
elseif  strcmp(DO,'on')==1
        [f,extJ]=evalJExt('DO',funhandle,x,fdata,JPI);
        extJ
	f
	spy(extJ)
else
[f,extJ]=evalJExt('GF',funhandle,ones(N,1),fdata,JPI);
        spy(extJ)
end
	title 'Structure of Extended Jacobian'
argout=extJ;
elseif strcmp(action,'evalH')==1
if strcmp(GP,'on')==1
        [f,g,extH]=evalHExt('GP',funhandle,x,fdata,HPI);
        spy(extH)
 
elseif  strcmp(GC,'on')==1
 
        [f,g,extH]=evalJExt('GC',funhandle,x,fdata,HPI);
        spy(extH)
elseif  strcmp(DO,'on')==1
	x=ones(N,1);
	[f,g,extH]=evalHExt('DO',funhandle,x,fdata,HPI);
	spy(extH) ;
elseif  strcmp(GI,'on')==1
 
        [f,g,extH]=evalHExt('GC',funhandle,x,fdata,HPI);
        spy(extH)
else
[f,g,extH]=evalHExt('GF',funhandle,x,fdata,HPI);
        spy(extH) 
end
	title 'Structure of Extended Hessian'
argout=HPI;
elseif strcmp(action,'nsJ')==1
if strcmp(GP,'on')==1
        [f,extJ,ns]=evalJExt('GP',funhandle,x,fdata,JPI);
	spy(extJ)
elseif  strcmp(GC,'on')==1
        [f,extJ,ns]=evalJExt('GC',funhandle,x,fdata,JPI);
	spy(extJ)
elseif  strcmp(GI,'on')==1
        x=2*rand(N,1);
        [f,extJ,ns]=evalJExt('GI',funhandle,x,fdata,JPI);
        spy(extJ)
elseif  strcmp(DO,'on')==1
        [f,extJ,ns]=evalJExt('DO',funhandle,x,fdata,JPI);
        spy(extJ)
else
[f,extJ,ns]=evalJExt('GF',funhandle,x,fdata,JPI);
        spy(extJ)
end
        title 'Structure of Extended Jacobian'
argout=ns;
elseif strcmp(action,'nsH')==1
if strcmp(GP,'on')==1
        [f,g,extH,ns]=evalHExt('GP',funhandle,x,fdata,HPI);
        spy(extH)
 
elseif  strcmp(GC,'on')==1

        [f,g,extH,ns]=evalJExt('GC',funhandle,x,fdata,HPI);
        spy(extH)
elseif  strcmp(DO,'on')==1
        x=ones(N,1);
        [f,g,extH,ns]=evalHExt('DO',funhandle,x,fdata,HPI);
        spy(extH) ;
elseif  strcmp(GI,'on')==1
 
        [f,g,extH,ns]=evalHExt('GC',funhandle,x,fdata,HPI);
        spy(extH)
else
[f,g,extH,ns]=evalHExt('GF',funhandle,x,fdata,HPI);
        spy(extH)
end
        title 'Structure of Extended Hessian'
 
argout=ns;
elseif strcmp(action,'setupfun')==1


if ~isempty(fig2) close(fig2); end
fig2 = figure('NumberTitle','off');
set(fig2,'Tag','SETUPWIN');


if strcmp(GP,'on')==1
	GPsetup(fig2);
elseif strcmp(GC,'on')==1
	GCsetup(fig2);
elseif  strcmp(GI,'on')==1
	GIsetup(fig2);
elseif  strcmp(DO,'on')==1
	DOsetup(fig2);
else
	GFsetup(fig2);
end

end
