
str = str2mat(...
  '        Consider the following simple ', ...
  '        boundary value problem :', ...  
  ' ',...
  '        Given the ODE :',...
  '             z:=dy/dt=F(y,t)',...
  ' where F is defined by :',...
  '             z(i)=x(i)*x(i)+t*(x(i+1)+x(i-1)), i= 2:n-1',...
  '             z(1)=x(1)*x(1)+t*x(2)',...
  '             z(n)=x(n)*x(n)+t*x(n-1)',' ');
ssdisp(figNumber,str);      

% Delay a little more in the case of AutoPlay

if get(findobj(figNumber,'string','AutoPlay'),'value') pause(3) ; end ;

if sspause(figNumber), return; end;

str = str2mat (...
  ' The first step is to configure the functions', ...
  ' followed by computing the coloring Information',...
  ' once for all using : ',...
   ' ',...
   ' >> fun=configEF(''GI'',''bvp'',[],1);',...
   ' >> fdata=GIFdata(fun,20,[],[],ones(20,1));',...
   ' >> JPI=GetExtJPI(''GI'',fun,20,fdata);',...
   ' ',...
   ' file bvp.m codes the function F(y,t)');

ssdisp(figNumber,str);                                     
drawnow;
fun=configEF('GI','bvp');
fdata=GIFdata(fun,20,[],[],ones(20,1));
JPI=GetExtJPI('GI',fun,20,fdata);

% Delay a little more in the case of AutoPlay
if get(findobj(figNumber,'string','AutoPlay'),'value') pause(3) ; end ;
if sspause(figNumber), return; end;

str = str2mat(' ', ...
  ' ADMIT-2 can be used to compute the extended Jacobian matrix ', ...
  ' ',...
  ' >> [f,extJ]=evalJExt(''GI'',fun,ones(20,1),fdata,JPI);') ;

ssdisp(figNumber,str);      
drawnow;
[f,extJ]=evalJExt('GI',fun,ones(20,1),fdata,JPI);
spy(extJ) ;
title(' Structure of Extended Jacobian Matrix ') ;
drawnow ;

% Delay a little more in the case of AutoPlay
if get(findobj(figNumber,'string','AutoPlay'),'value') pause(3) ; end ;
if sspause(figNumber), return; end;

str = str2mat(' ', ...
  ' ADMIT-2 also lets you compute the true Jacobian matrix ', ...
  ' ',...
  ' >> [f,extJ,ns,J]=evalJExt(''GI'',fun,ones(20,1),fdata,JPI);',...
  ' ',...
  ' ns being the newton step J*ns=-f') ;
 
ssdisp(figNumber,str);
drawnow;
[f,extJ,ns,J]=evalJExt('GI',fun,ones(20,1),fdata,JPI);
spy(J) ;
title(' Structure of true Jacobian Matrix ') ;
drawnow;
 
% Delay a little more in the case of AutoPlay
if get(findobj(figNumber,'string','AutoPlay'),'value') pause(3) ; end ;
if sspause(figNumber), return; end;

str = str2mat(' ', ...
  ' ADMIT-2 also has miscellaneous other drivers', ...
  ' for computing the Jacobian matrix products', ...
  ' e.g. J*V and W''*J',...
  ' ',...
  ' >> V=ones(20,1);',...
  ' >> [f,JV]=ExtJV(''GI'',fun,ones(20,1),V,fdata);',...
  ' ',...
  ' >> W=ones(20,1);',...
  ' >> [f,WJ]=ExtWJ(''GI'',fun,ones(20,1),W,fdata);');
 
ssdisp(figNumber,str);
drawnow ;
V=ones(20,1);
[f,JV]=ExtJV('GI',fun,ones(20,1),V,fdata);
JV
W=ones(20,1);
[f,WJ]=ExtWJ('GI',fun,ones(20,1),W,fdata);
WJ
 
% Delay a little more in the case of AutoPlay
if get(findobj(figNumber,'string','AutoPlay'),'value') pause(3) ; end ;
if sspause(figNumber), return; end;


str = str2mat(' ', ...
  ' You can also do just a function evaluation',...
  ' >> f=funcvalJExt(''GI'',fun,ones(20,1),fdata);');
 
ssdisp(figNumber,str);
drawnow ;
f=funcvalJExt('GI',fun,ones(20,1),fdata);
f 
% Delay a little more in the case of AutoPlay
if get(findobj(figNumber,'string','AutoPlay'),'value') pause(3) ; end ;
if sspause(figNumber), return; end;

str = str2mat(' ', ...
  ' Solving the BVP, use a newton iteration',...
  ' ');
 
ssdisp(figNumber,str);
drawnow ;
x=ones(20,1);
mynorm=1;
it=0;
while mynorm > 1e-5
it=it+1;
[f,extJ,ns]=evalJExt('GI',fun,x,fdata,JPI);
x=x+ns;
mynorm=norm(f);
disp(sprintf('Iteration %d, Error norm %f',it,mynorm));
end
 
% Delay a little more in the case of AutoPlay
if get(findobj(figNumber,'string','AutoPlay'),'value') pause(3) ; end ;
if sspause(figNumber), return; end;

