N=30;
k=3;
x=ones(N,1);
py0=ones(N/k,1);
str = str2mat(' ',' ', ' ', ...
  '        Consider the following discrete-time ', ...
  '        optimal control problem.', ...  
  ' ',...
  '        min F(y,x) = L1(y1,x1)+....+L_k-1(y_{k-1},x_{k-1})+Lk(yk)',...
  '        subject to : y_{i+1}=T(yi,xi), i=1:k-1',...
  '        given y1 and x=[x1;x2;...xk]');
ssdisp(figNumber,str);      

% Delay a little more in the case of AutoPlay

if get(findobj(figNumber,'string','AutoPlay'),'value') pause(3) ; end ;

if sspause(figNumber), return; end;

str = str2mat (...
  ' The first step is to configure the functions', ...
  ' followed by computing the coloring Information',...
  ' once for all using : ',...
   ' ',...
   ' >> fun=configEF(''DO'',[''dtoc'';''gfun'']);',...
   ' >> fdata=DOFdata(fun,N,k,[N/k;N/k],py0);',...
   ' >> HPI=GetExtHPI(''GP'',fun,N,fdata);',...
   ' ',...
   ' dtoc.m codes the mapping T and gfun codes F(y,x)',...
   ' For the sample run , k=3, and N=length(x)=30' );

ssdisp(figNumber,str);                                     
drawnow;
fun=configEF('DO',['dtoc';'gfun']);
%fun=configEF('DO',['dtoc';'gfun']);
fdata=DOFdata(fun,N,k,[N/k;N/k],py0);
HPI=GetExtHPI('DO',fun,N,fdata);

% Delay a little more in the case of AutoPlay
if get(findobj(figNumber,'string','AutoPlay'),'value') pause(3) ; end ;
if sspause(figNumber), return; end;

str = str2mat(' ', ...
  ' evalHExt can be used to compute the extended Jacobian matrix ', ...
  ' ',...
  ' >> [f,g,extH]=evalHExt(''DO'',fun,x,fdata,HPI);') ;

ssdisp(figNumber,str);      
drawnow;
[f,g,extH]=evalHExt('DO',fun,x,fdata,HPI);
spy(extH) ;
title(' Structure of Extended Hessian Matrix ') ;
drawnow ;

% Delay a little more in the case of AutoPlay
if get(findobj(figNumber,'string','AutoPlay'),'value') pause(3) ; end ;
if sspause(figNumber), return; end;

str = str2mat(' ', ...
  ' ADMIT-2 also lets you compute the true Jacobian matrix ', ...
  ' ',...
  ' >> [f,g,extH,ns,H]=evalHExt(''DO'',fun,x,fdata,HPI);',...
  ' ',...
  ' ns being the newton step H*ns=-g') ;
 
ssdisp(figNumber,str);
drawnow;
[f,g,extH,ns,H]=evalHExt('DO',fun,x,fdata,HPI);
spy(H)
title(' Structure of true Hessian Matrix ') ;
drawnow;
 
% Delay a little more in the case of AutoPlay
if get(findobj(figNumber,'string','AutoPlay'),'value') pause(3) ; end ;
if sspause(figNumber), return; end;

str = str2mat(' ', ...
  ' You can also do just a function evaluation',...
  ' >> f=funcvalExt(''DO'',fun,x,fdata);');
 
ssdisp(figNumber,str);
drawnow ;
f=funcvalExt('DO',fun,x,fdata);
 
% Delay a little more in the case of AutoPlay
if get(findobj(figNumber,'string','AutoPlay'),'value') pause(3) ; end ;
if sspause(figNumber), return; end;

str = str2mat(' ', ...
  ' Solving the problem using a newton iteration',...
  ' ',...
  ' After each iteration gradient vector is plotted');

mynorm=1;
it=0;
plot([1:N],g);
title 'gradient';
drawnow;
while mynorm > 1e-5
it=it+1;
[f,g,extH,ns,H]=evalHExt('DO',fun,x,fdata,HPI);
x=x+ns;
mynorm=norm(g);
disp(sprintf('Iteration %d, Error norm %f',it,mynorm));
plot([1:N],g);
title 'gradient';
drawnow;
end
% Delay a little more in the case of AutoPlay
if get(findobj(figNumber,'string','AutoPlay'),'value') pause(3) ; end ;
if sspause(figNumber), return; end;

