
str = str2mat(' ',' ', ' ', ...
  '        Consider the following very two step ', ...
  '        structured function.', ...  
  ' ',...
  '        y=A\x;',...
  '        f(x):=z=g(x,y)');
ssdisp(figNumber,str);      

% Delay a little more in the case of AutoPlay

if get(findobj(figNumber,'string','AutoPlay'),'value') pause(3) ; end ;

if sspause(figNumber), return; end;

str = str2mat (...
  ' The first step is to configure the functions', ...
  ' followed by computing the coloring Information',...
  ' once for all using : ',...
   ' ',...
   ' >> file=MakeFile(''implicit'',''genexamp'');',...
   ' >> fun=configEF(''GF'',file,[1;0]);',...
   ' >> [fun,fdata]=GFFdata(fun,20);',...
   ' >> JPI=GetExtJPI(''GF'',fun,20,20);',...
   ' ',...
   ' Problem is of size 20, implicit.m codes y=A\x',...
   ' and genexamp.m codes z=g(x,y)');

ssdisp(figNumber,str);                                     
drawnow;
file=MakeFile('implicit','genexamp');
fun=configEF('GF',file,[1;0]);
[fun,fdata]=GFFdata(fun,20);
JPI=GetExtJPI('GF',fun,20,fdata);

% Delay a little more in the case of AutoPlay
if get(findobj(figNumber,'string','AutoPlay'),'value') pause(3) ; end ;
if sspause(figNumber), return; end;

str = str2mat(' ', ...
  ' ADMIT-2 can be used to compute the extended Jacobian matrix ', ...
  ' ',...
  ' >> [f,extJ]=evalJExt(''GF'',fun,ones(20,1),fdata,JPI);') ;

ssdisp(figNumber,str);      
drawnow;
[f,extJ]=evalJExt('GF',fun,ones(20,1),fdata,JPI);
spy(extJ) ;
title(' Structure of Extended Jacobian Matrix ') ;
drawnow ;

% Delay a little more in the case of AutoPlay
if get(findobj(figNumber,'string','AutoPlay'),'value') pause(3) ; end ;
if sspause(figNumber), return; end;

str = str2mat(' ', ...
  ' ADMIT-2 also lets you compute the true Jacobian matrix ', ...
  ' ',...
  ' >> [f,extJ,ns,J]=evalJExt(''GF'',fun,ones(20,1),fdata,JPI);',...
  ' ',...
  ' ns being the newton step J*ns=-f') ;
 
ssdisp(figNumber,str);
drawnow;
[f,extJ,ns,J]=evalJExt('GF',fun,ones(20,1),fdata,JPI);
spy(J) ;
title(' Structure of true Jacobian Matrix ') ;
drawnow;
 
% Delay a little more in the case of AutoPlay
if get(findobj(figNumber,'string','AutoPlay'),'value') pause(3) ; end ;
if sspause(figNumber), return; end;

str = str2mat(' ', ...
  ' ADMIT-2 also has miscellaneous other drivers', ...
  ' for computing the Jacobian matrix products', ...
  ' e.g. J*V and W''*J',...
  ' ',...
  ' >> V=ones(20,1);',...
  ' >> [f,JV]=ExtJV(''GF'',fun,ones(20,1),V,fdata);',...
  ' ',...
  ' >> W=ones(20,1);',...
  ' >> [f,WJ]=ExtWJ(''GF'',fun,ones(20,1),W,fdata);');
 
ssdisp(figNumber,str);
drawnow ;
V=ones(20,1);
[f,JV]=ExtJV('GF',fun,ones(20,1),V,fdata);
JV
W=ones(20,1);
[f,WJ]=ExtWJ('GF',fun,ones(20,1),W,fdata);
WJ
 
% Delay a little more in the case of AutoPlay
if get(findobj(figNumber,'string','AutoPlay'),'value') pause(3) ; end ;
if sspause(figNumber), return; end;


str = str2mat(' ', ...
  ' You can also do just a function evaluation',...
  ' >> f=funcvalJExt(''GF'',fun,ones(20,1),fdata);');
 
ssdisp(figNumber,str);
drawnow ;
f=funcvalJExt('GF',fun,ones(20,1),fdata);
f
 
% Delay a little more in the case of AutoPlay
if get(findobj(figNumber,'string','AutoPlay'),'value') pause(3) ; end ;
if sspause(figNumber), return; end;
