N=10;
py0=linspace(1,N,N)';
yfinal=1.1*linspace(1,N,N)';
k=[0;N;1];
x=2*rand(N,1);
deltaz=2;
f=ones(N,1);
deltaz=[deltaz;f];

str = str2mat(' ',' ', ' ', ...
  '        Consider the heat conductivity  ', ...
  '        inverse  problem.', ...  
  ' ',...
  '        You have a bar with initial temperature u_0',...
  '        The evolution satisfies the PDE : ',...
  '        du/dt = d/dz(x(z)du/dz)');
ssdisp(figNumber,str);      

% Delay a little more in the case of AutoPlay

if get(findobj(figNumber,'string','AutoPlay'),'value') pause(3) ; end ;

if sspause(figNumber), return; end;

str = str2mat (...
  ' The first step is to configure the functions', ...
  ' followed by computing the coloring Information',...
  ' once for all using : ',...
   ' ',...
   ' >> fun=configEF(''GI'',''heat'',[],1);',...
   ' >> fdata=GIFdata(fun,N,k,N,yfinal,py0,2,[],[],deltaz);',...
   ' >> JPI=GetExtJPI(''GI'',fun,N,fdata);');

ssdisp(figNumber,str);                                     
drawnow;
fun=configEF('GI','heat');
fdata=GIFdata(fun,N,k,N,yfinal,py0,2,[],[],deltaz);
JPI=GetExtJPI('GI',fun,N,fdata);

% Delay a little more in the case of AutoPlay
if get(findobj(figNumber,'string','AutoPlay'),'value') pause(3) ; end ;
if sspause(figNumber), return; end;

str = str2mat(' ', ...
  ' ADMIT-2 can be used to compute the extended Jacobian matrix ', ...
  ' ',...
  ' >> [f,extJ]=evalJExt(''GI'',fun,x,fdata,JPI);') ;

ssdisp(figNumber,str);      
drawnow;
[f,extJ]=evalJExt('GI',fun,x,fdata,JPI);
spy(extJ) ;
title(' Structure of Extended Jacobian Matrix ') ;
drawnow ;

% Delay a little more in the case of AutoPlay
if get(findobj(figNumber,'string','AutoPlay'),'value') pause(3) ; end ;
if sspause(figNumber), return; end;

str = str2mat(' ', ...
  ' ADMIT-2 also lets you compute the true Jacobian matrix ', ...
  ' ',...
  ' >> [f,extJ,ns,J]=evalJExt(''GI'',fun,x,fdata,JPI);',...
  ' ',...
  ' ns being the newton step J*ns=-f') ;
 
ssdisp(figNumber,str);
drawnow;
[f,extJ,ns,J]=evalJExt('GI',fun,x,fdata,JPI);
spy(J) ;
title(' Structure of true Jacobian Matrix ') ;
drawnow;
% Delay a little more in the case of AutoPlay
if get(findobj(figNumber,'string','AutoPlay'),'value') pause(3) ; end ;
if sspause(figNumber), return; end;

str = str2mat(' ', ...
  ' ADMIT-2 also has miscellaneous other drivers', ...
  ' for computing the Jacobian matrix products', ...
  ' e.g. J*V and W''*J',...
  ' ',...
  ' >> V=ones(N,1);',...
  ' >> [f,JV]=ExtJV(''GI'',fun,x,V,fdata);',...
  ' ',...
  ' >> W=ones(N,1);',...
  ' >> [f,WJ]=ExtWJ(''GI'',fun,x,W,fdata);');
 
ssdisp(figNumber,str);
drawnow ;
V=ones(N,1);
[f,JV]=ExtJV('GI',fun,x,V,fdata);
JV
W=ones(N,1);
[f,WJ]=ExtWJ('GI',fun,x,W,fdata);
WJ
 
% Delay a little more in the case of AutoPlay
if get(findobj(figNumber,'string','AutoPlay'),'value') pause(3) ; end ;
if sspause(figNumber), return; end;


str = str2mat(' ', ...
  ' You can also do just a function evaluation',...
  ' >> f=funcvalJExt(''GI'',fun,x,fdata);');
 
ssdisp(figNumber,str);
drawnow ;
f=funcvalJExt('GI',fun,x,fdata);
f
 
% Delay a little more in the case of AutoPlay
if get(findobj(figNumber,'string','AutoPlay'),'value') pause(3) ; end ;
if sspause(figNumber), return; end;

str = str2mat(' ', ...
  ' Solving the Inverse problem, using the nonlinear',...
  ' least-squares solver from LSOT...',...
  ' ',...
  ' It takes about 20 iterations',...
  ' ',...
  ' Initial x(z) is chosen at random, in particular',...
  ' xstart=2*rand(N,1);',...
  ' and initial state u0 is chosen as u0=linspace(1,N,N);',...
  ' Press Next to start LSOT iterations');
 
ssdisp(figNumber,str);
drawnow ;
plot([1:N],f+yfinal,'-',[1:N],yfinal,'--');
title 'solid : current final state, dashed : desired';
drawnow;
% Delay a little more in the case of AutoPlay
if get(findobj(figNumber,'string','AutoPlay'),'value') pause(3) ; end ;
if sspause(figNumber), return; end;
 
options=lsotset('lowerbound',zeros(N,1),'tol',1e-5);
xopt=nlslsot('GI',fun,x,options,fdata,JPI);
 
xopt
f=funcvalJExt('GI',fun,xopt,fdata);
figure(figNumber);
plot([1:N],f+yfinal,'-',[1:N],yfinal,'--');
title 'solid : current final state, dashed : desired';
drawnow;
% Delay a little more in the case of AutoPlay
if get(findobj(figNumber,'string','AutoPlay'),'value') pause(3) ; end ;
if sspause(figNumber), return; end;

