N=10;
py0=linspace(1,N,N)';
yfinal=1.1*linspace(1,N,N)';
k=[0;N;1];
x=2*ones(N,1);
deltaz=2;
f=ones(N,1);
deltaz=[deltaz;f];

str = str2mat(' ',' ', ' ', ...
  '        Consider the heat conductivity  ', ...
  '        inverse  problem.', ...  
  ' ',...
  '        You have a bar with initial temperature u_0',...
  '        The evolution satisfies the PDE : ',...
  '        du/dt = d/dz(x(z)du/dz)');
ssdisp(figNumber,str);      

% Delay a little more in the case of AutoPlay

if get(findobj(figNumber,'string','AutoPlay'),'value') pause(3) ; end ;

if sspause(figNumber), return; end;

str = str2mat (...
  ' The first step is to configure the functions', ...
  ' followed by computing the coloring Information',...
  ' once for all using : ',...
   ' ',...
   ' >> fun=configEF(''GI'',''heat'',[],1);',...
   ' >> JPI=GetExtJPI(''GI'',fun,N,k,N,yfinal,py0,2,[],[],deltaz);');

ssdisp(figNumber,str);                                     
drawnow;
fun=configEF('GI','heat',[],1);
JPI=GetExtJPI('GI',fun,N,k,N,yfinal,py0,2,[],[],deltaz);

% Delay a little more in the case of AutoPlay
if get(findobj(figNumber,'string','AutoPlay'),'value') pause(3) ; end ;
if sspause(figNumber), return; end;

str = str2mat(' ', ...
  ' ADMIT-2 can be used to compute the extended Jacobian matrix ', ...
  ' ',...
  ' >> [f,extJ]=evalJExt(''GI'',fun,x,k,N,JPI,[],yfinal,py0,2,[],[],deltaz);') ;

ssdisp(figNumber,str);      
drawnow;
[f,extJ]=evalJExt('GI',fun,x,k,N,JPI,[],yfinal,py0,2,[],[],deltaz);
spy(extJ) ;
title(' Structure of Extended Jacobian Matrix ') ;
drawnow ;

% Delay a little more in the case of AutoPlay
if get(findobj(figNumber,'string','AutoPlay'),'value') pause(3) ; end ;
if sspause(figNumber), return; end;

str = str2mat(' ', ...
  ' ADMIT-2 also lets you compute the true Jacobian matrix ', ...
  ' ',...
  ' >> [f,extJ,ns,J]=evalJExt(''GI'',fun,x,k,N,JPI,[],yfinal,py0,2,[],[],deltaz);',...
  ' ',...
  ' ns being the newton step J*ns=-f') ;
 
ssdisp(figNumber,str);
drawnow;
[f,extJ,ns,J]=evalJExt('GI',fun,x,k,N,JPI,[],yfinal,py0,2,[],[],deltaz);
spy(J) ;
title(' Structure of true Jacobian Matrix ') ;
drawnow;
% Delay a little more in the case of AutoPlay
if get(findobj(figNumber,'string','AutoPlay'),'value') pause(3) ; end ;
if sspause(figNumber), return; end;

str = str2mat(' ', ...
  ' ADMIT-2 also has miscellaneous other drivers', ...
  ' for computing the Jacobian matrix products', ...
  ' e.g. J*V and W''*J',...
  ' ',...
  ' >> V=ones(N,1);',...
  ' >> [f,JV]=ExtJV(''GI'',fun,x,V,k,N,yfinal,py0,2,[],[],deltaz);',...
  ' ',...
  ' >> W=ones(N,1);',...
  ' >> [f,WJ]=ExtWJ(''GI'',fun,x,W,k,N,yfinal,py0,2,[],[],deltaz);');
 
ssdisp(figNumber,str);
drawnow ;
V=ones(N,1);
[f,JV]=ExtJV('GI',fun,x,V,k,N,yfinal,py0,2,[],[],deltaz);
JV
W=ones(N,1);
[f,WJ]=ExtWJ('GI',fun,x,W,k,N,yfinal,py0,2,[],[],deltaz);
WJ
 
% Delay a little more in the case of AutoPlay
if get(findobj(figNumber,'string','AutoPlay'),'value') pause(3) ; end ;
if sspause(figNumber), return; end;


str = str2mat(' ', ...
  ' You can also do just a function evaluation',...
  ' >> f=funcvalJExt(''GI'',fun,x,k,N,yfinal,py0,2,[],[],deltaz);');
 
ssdisp(figNumber,str);
drawnow ;
f=funcvalJExt('GI',fun,x,k,N,yfinal,py0,2,[],[],deltaz);
f
 
% Delay a little more in the case of AutoPlay
if get(findobj(figNumber,'string','AutoPlay'),'value') pause(3) ; end ;
if sspause(figNumber), return; end;

str = str2mat(' ', ...
  ' Solving the inverse problem using a newton iteration',...
  ' ');
 
ssdisp(figNumber,str);
drawnow ;
mynorm=1;
it=0;
plot([1:N],f+yfinal,'-',[1:N],yfinal,'--');
title 'solid : current final state, dashed : desired';
drawnow;
while mynorm > 1e-5
it=it+1;
[f,extJ,ns,J]=evalJExt('GI',fun,x,k,N,JPI,[],yfinal,py0,2,[],[],deltaz);
x=x+ns;
x
mynorm=norm(f);
disp(sprintf('Iteration %d, Error norm %f',it,mynorm));
plot([1:N],f+yfinal,[1:N],yfinal);
title 'solid : current final state, dashed : desired';
drawnow;
end
% Delay a little more in the case of AutoPlay
if get(findobj(figNumber,'string','AutoPlay'),'value') pause(3) ; end ;
if sspause(figNumber), return; end;

