N=4;
M=3*N;
outind=[linspace(1,M,M)' ones(M,1)];
py0=zeros(N,1);
x=0.5*ones(N,1);
deltaz=1;
k=[0;M;1];
f=-ones(M,1);
yfinal=2*linspace(1,M,M)';
deltaz=[deltaz;f];
str = str2mat(' ',' ', ' ', ...
  '        Consider the Reflection seismology  ', ...
  '        inverse  problem.', ...  
  ' ',...
  '        The problem is to measure sound speeds inside',...
  '        the earth, using the PDE :',...
  '        d^2(u)/dt^2 = d/dz(x(z)du/dz), 0 < z < 1');
ssdisp(figNumber,str);      

% Delay a little more in the case of AutoPlay

if get(findobj(figNumber,'string','AutoPlay'),'value') pause(3) ; end ;

if sspause(figNumber), return; end;

str = str2mat (...
  ' The first step is to configure the functions', ...
  ' followed by computing the coloring Information',...
  ' once for all using : ',...
   ' ',...
   ' >> fun=configEF(''GI'',''wave'',[],1);',...
   ' >> JPI=GetExtJPI(''GI'',fun,N,k,N,yfinal,py0,2,2,outind,deltaz);');

ssdisp(figNumber,str);                                     
drawnow;
fun=configEF('GI','wave',[],1);
JPI=GetExtJPI('GI',fun,N,k,N,yfinal,py0,2,2,outind,deltaz);

% Delay a little more in the case of AutoPlay
if get(findobj(figNumber,'string','AutoPlay'),'value') pause(3) ; end ;
if sspause(figNumber), return; end;

str = str2mat(' ', ...
  ' ADMIT-2 can be used to compute the extended Jacobian matrix ', ...
  ' ',...
  ' >> [f,extJ]=evalJExt(''GI'',fun,x,k,N,JPI,[],yfinal,py0,2,2,outind,deltaz);') ;

ssdisp(figNumber,str);      
drawnow;
[f,extJ]=evalJExt('GI',fun,x,k,N,JPI,[],yfinal,py0,2,2,outind,deltaz);
spy(extJ) ;
title(' Structure of Extended Jacobian Matrix ') ;
drawnow ;

% Delay a little more in the case of AutoPlay
if get(findobj(figNumber,'string','AutoPlay'),'value') pause(3) ; end ;
if sspause(figNumber), return; end;

str = str2mat(' ', ...
  ' ADMIT-2 also lets you compute the true Jacobian matrix ', ...
  ' ',...
  ' >> [f,extJ,ns,J]=evalJExt(''GI'',fun,x,k,N,JPI,[],yfinal,py0,2,2,outind,deltaz);',...
  ' ',...
  ' ns being the newton step J*ns=-f') ;
 
ssdisp(figNumber,str);
drawnow;
[f,extJ,ns,J]=evalJExt('GI',fun,x,k,N,JPI,[],yfinal,py0,2,2,outind,deltaz);
rank(full(J))
spy(J) ;
title(' Structure of true Jacobian Matrix ') ;
drawnow;
 
% Delay a little more in the case of AutoPlay
if get(findobj(figNumber,'string','AutoPlay'),'value') pause(3) ; end ;
if sspause(figNumber), return; end;

str = str2mat(' ', ...
  ' ADMIT-2 also has miscellaneous other drivers', ...
  ' for computing the Jacobian matrix products', ...
  ' e.g. J*V and W''*J',...
  ' ',...
  ' >> V=ones(N,1);',...
  ' >> [f,JV]=ExtJV(''GI'',fun,x,V,k,N,yfinal,py0,2,2,outind,deltaz);',...
  ' ',...
  ' >> W=ones(M,1);',...
  ' >> [f,WJ]=ExtWJ(''GI'',fun,x,W,k,N,yfinal,py0,2,2,outind,deltaz);');
 
ssdisp(figNumber,str);
drawnow ;
V=ones(N,1);
[f,JV]=ExtJV('GI',fun,x,V,k,N,yfinal,py0,2,2,outind,deltaz);
JV
W=ones(M,1);
[f,WJ]=ExtWJ('GI',fun,x,W,k,N,yfinal,py0,2,2,outind,deltaz);
WJ
 
% Delay a little more in the case of AutoPlay
if get(findobj(figNumber,'string','AutoPlay'),'value') pause(3) ; end ;
if sspause(figNumber), return; end;


str = str2mat(' ', ...
  ' You can also do just a function evaluation',...
  ' >> f=funcvalJExt(''GI'',fun,x,k,N,yfinal,py0,2,2,outind,deltaz);');
 
ssdisp(figNumber,str);
drawnow ;
f=funcvalJExt('GI',fun,x,k,N,yfinal,py0,2,2,outind,deltaz);
f
 
% Delay a little more in the case of AutoPlay
if get(findobj(figNumber,'string','AutoPlay'),'value') pause(3) ; end ;
if sspause(figNumber), return; end;

str = str2mat(' ', ...
  ' Solving the BVP, use a newton iteration',...
  ' ');
 
ssdisp(figNumber,str);
drawnow ;
mynorm=1;
it=0;
plot([1:M],f+yfinal,[1:M],yfinal);
title 'solid : current final state, dashed : desired';
drawnow;
while mynorm > 1e-5
it=it+1;
[f,extJ]=evalJExt('GI',fun,x,k,N,JPI,[],yfinal,py0,2,2,outind,deltaz);
ns=ExtJfunc(7,extJ,N,M,f);
mynorm=norm(f);
x=x+ns;
disp(sprintf('Iteration %d, Error norm %f',it,mynorm));
plot([1:M],f+yfinal,[1:M],yfinal);
title 'solid : current final state, dashed : desired';
drawnow;
end
 
% Delay a little more in the case of AutoPlay
if get(findobj(figNumber,'string','AutoPlay'),'value') pause(3) ; end ;
if sspause(figNumber), return; end;

