
str = str2mat(' ', ' ', ...
  '        Consider the following very simple ', ...
  '        partially separable problem : ', ...  
' ',...
  '       y=f(x), where ',...
  '       y(i)= x(1)^i + x(2)^i + ... +x(n)^i',...
  ' ');
ssdisp(figNumber,str);      

% Delay a little more in the case of AutoPlay

if get(findobj(figNumber,'string','AutoPlay'),'value') pause(2) ; end ;

if sspause(figNumber), return; end;


str = str2mat(' ', ' ', ...
  '       Above problem can be pharsed in partially ', ...  
  '       separable form as : ',...
  ' ', ...
  '       y=y_1+y_2,...,y_n, where ',...
  '       y_j(i)= x(j)^i',...
  ' ',...
  '       Hence each y_j, a vector function depends only',...
  '       on one input variable ');
ssdisp(figNumber,str);
 
% Delay a little more in the case of AutoPlay
 
if get(findobj(figNumber,'string','AutoPlay'),'value') pause(2) ; end ;
 
if sspause(figNumber), return; end;


str = str2mat (...
  ' The first step is to configure the functions', ...
  ' followed by computing the coloring Information',...
  ' once for all using : ',...
   ' ',...
   ' >> fun=configEF(''GP'',''psexamp'');',...
   ' >> fdata=GPFdata(fun,20,20,20);',...
   ' >> JPI=GetExtJPI(''GP'',fun,20,fdata);',...
   ' ',...
   'file psexamp.m contains the function in ADMIT format.',...
   'The problem we consider is of size 20.');
ssdisp(figNumber,str);                                     
drawnow;
fun=configEF('GP','psexamp');
fdata=GPFdata(fun,20,20,20);
JPI=GetExtJPI('GP',fun,20,fdata);

% Delay a little more in the case of AutoPlay
if get(findobj(figNumber,'string','AutoPlay'),'value') pause(3) ; end ;
if sspause(figNumber), return; end;

str = str2mat(' ', ...
  ' evalJExt can be used to compute the extended Jacobian matrix ', ...
  ' ',...
  ' >> [f,extJ]=evalJExt(''GP'',fun,ones(20,1),fdata,JPI);') ;

ssdisp(figNumber,str);      
drawnow;
[f,extJ]=evalJExt('GP',fun,ones(20,1),fdata,JPI);
spy(extJ) ;
title(' Structure of Extended Jacobian Matrix ') ;
drawnow ;

% Delay a little more in the case of AutoPlay
if get(findobj(figNumber,'string','AutoPlay'),'value') pause(3) ; end ;
if sspause(figNumber), return; end;

str = str2mat(' ', ...
  ' ADMIT-2 also lets you compute the true Jacobian matrix ', ...
  ' ',...
  ' >> [f,extJ,ns,J]=evalJExt(''GP'',fun,ones(20,1),fdata,JPI);',...
  ' ',...
  ' ns being the newton step J*ns=-f') ;
 
ssdisp(figNumber,str);
drawnow;
[f,extJ,ns,J]=evalJExt('GP',fun,ones(20,1),fdata,JPI);
spy(J) ;
title(' Structure of true Jacobian Matrix ') ;
drawnow;
 
% Delay a little more in the case of AutoPlay
if get(findobj(figNumber,'string','AutoPlay'),'value') pause(3) ; end ;
if sspause(figNumber), return; end;

str = str2mat(' ', ...
  ' ADMIT-2 also has miscellaneous other drivers', ...
  ' for computing the Jacobian matrix products', ...
  ' e.g. J*V and W''*J',...
  ' ',...
  ' >> V=ones(20,1);',...
  ' >> [f,JV]=ExtJV(''GP'',fun,ones(20,1),V,fdata);',...
  ' ',...
  ' >> W=ones(20,1);',...
  ' >> [f,WJ]=ExtWJ(''GP'',fun,ones(20,1),W,fdata);');
 
ssdisp(figNumber,str);
drawnow ;
V=ones(20,1);
[f,JV]=ExtJV('GP',fun,ones(20,1),V,fdata);
JV
W=ones(20,1);
[f,WJ]=ExtWJ('GP',fun,ones(20,1),W,fdata);
WJ
 
% Delay a little more in the case of AutoPlay
if get(findobj(figNumber,'string','AutoPlay'),'value') pause(3) ; end ;
if sspause(figNumber), return; end;


str = str2mat(' ', ...
  ' You can also do just a function evaluation',...
  ' >> f=funcvalJExt(''GP'',fun,ones(20,1),fdata);');
 
ssdisp(figNumber,str);
drawnow ;
f=funcvalJExt('GP',fun,ones(20,1),fdata);
f
 
% Delay a little more in the case of AutoPlay
if get(findobj(figNumber,'string','AutoPlay'),'value') pause(3) ; end ;
if sspause(figNumber), return; end;
