function[value] = sec(lambda,eigval,alpha,delta);
%SEC	Secular equation
%
%	[value] = sec(lambda,eigval,alpha,delta);
%
% EVALUATES THE SECULAR EQUATION  AT A SET OF m POINTS lambda.  
%
%	******************************************************************
%	*              Thomas F. Coleman, 7-1-96                         *
%	*              Copyright (c) 1996 by The Mathworks, Inc.         *
%	******************************************************************
%
  m = length(lambda); n = length(eigval);
  unn = ones(n,1); unm = ones(m,1);
  M = eigval*unm' + unn*lambda'; MC = M;
  MM = alpha*unm';
  M(M~=0) = MM(M~=0) ./ M(M~=0);
  M(MC==0) = Inf*ones(size(MC(MC==0))); 
  M = M.*M;
  value = sqrt(unm ./ (M'*unn));
  value(value==NaN) = zeros(length(value(value==NaN)),1);
  value = (1/delta)*unm - value;
