function [f,J,ns]=compJ(class,fun,x,fdata)
%
%funcvalJExt
%
%       compute the function value.
%
%       f=funcvalJExt(class,fun,x)
%
%       Please refer to ADMIT-2 users manual for complete reference.
%
%       ALSO SEE configureExtfun, evalHExt, ExtJV, ExtWJ, ExtHV, ExtVHV
%
%
%       ******************************************************************
%       *              ADMIT-2 Project   1996-97                         *
%       *              Copyright (c) 1996 Cornell University.            *
%       ******************************************************************

n=length(x);
if nargin < 4 fdata=[]; end
 
if isempty(fdata)
        [fun,fdata]=MakeExtFdata(class,fun,n);
end
 

f=funcvalJExt(class,fun,x,fdata);
step=1e-5;
outm=length(f);
J=zeros(outm,n);
for i=1:n
	y=x;
	y(i)=x(i)+step;
	ff=funcvalJExt(class,fun,y,fdata); 
	J(:,i)=(ff-f)./step;
end

if nargout==3
ns=-J\f;
end
