function [f,g,extH]=evalHDI1(fun,fdata,x,PartInfo)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Recover
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

n=length(x);
k=fdata.k;
dims=fdata.dims;
ExtraArg=fdata.py0;
sizep=dims(1);
sizestate=dims(2);
 
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Recovery complete
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
Identity=-speye(sizestate);
extH=sparse(0,k*sizep+sizestate);

[JPI,HPI1,HPI2]=ExtractJPI(PartInfo);
y=zeros(sizep,k+1);
y(:,1)=ExtraArg;
accumy=ExtraArg;
data=sizep; 
index=1;
for i=1:k
        [y(:,i+1),J]=evalJ(fun(1,:),[x((i-1)*sizep+1:i*sizep);y(:,i)],data,sizestate,JPI);
       extH=[extH sparse((i-1)*sizestate,sizestate); 
sparse(sizestate,(i-1)*sizep) J(:,1:sizep) sparse(sizestate,(k-i)*sizep+(i-1)*sizestate) J(:,sizep+1:sizestate+sizep) Identity];
	accumy=[accumy;y(:,i+1)];
end
datag=[k;sizep];
[nrows,ncols]=size(extH);
[f,grad_y]=evalH(fun(2,:),[x;accumy],datag);
L=extH(:,n+1+sizestate:ncols);
w= -L'\grad_y(n+1+sizestate:ncols);
g=grad_y(1:n)+extH(:,1:n)'*w;
windex=1;

% Do Hessians Now
% Extract all HPIs and compute evalH	

HessP=sparse(ncols,ncols);
for i=1:k
        [val,H]=evalHTens(fun(1,:),[x((i-1)*sizep+1:i*sizep);y(:,i)],w(windex:windex+sizestate-1),data,HPI1);
HessP=HessP+[sparse((i-1)*sizep,ncols);
sparse(sizep, (i-1)*sizep) H(1:sizep,1:sizep) sparse(sizep,(k-i)*sizep+(i-1)*sizestate) H(1:sizep, sizep+1:sizep+sizestate) sparse(sizep,(k+1-i)*sizestate);
sparse((k-i)*sizep+(i-1)*sizestate,ncols);
sparse(sizestate, (i-1)*sizep) H(sizep+1:sizep+sizestate,1:sizep) sparse(sizestate,(k-i)*sizep+(i-1)*sizestate) H(sizep+1:sizep+sizestate,sizep+1:sizep+sizestate) sparse(sizestate,(k+1-i)*sizestate);
sparse((k+1-i)*sizestate,ncols)];
	windex=windex+sizestate;
end
	[f,temp,H2]=evalH(fun(2,:),[x;accumy],datag,HPI2);
	HessP=HessP+H2;
        extH=[extH sparse(nrows,nrows); HessP(n+1:ncols,:) extH(1:nrows,n+1:ncols)';
             HessP(1:n,:) extH(1:nrows,1:n)'];
	extH=extH([1:nrows nrows+sizestate+1:size(extH,1)],[1:n n+sizestate+1:size(extH,1)]);
