function [f,g]=funcvalExt(class,fun,x,fdata,EJPI)
%
%funcvalExt
%
%       compute the function and gradient value
%
%       f=funcvalExt(class,fun,x)
%       [f,g]=funcvalExt(class,fun,x)
%
%       Please refer to ADMIT-2 users manual for complete reference.
%
%       ALSO SEE configureExtfun, evalHExt, ExtJV, ExtWJ, ExtHV, ExtVHV
%
%
%       ******************************************************************
%       *              ADMIT-2 Project   1996-97                         *
%       *              Copyright (c) 1996 Cornell University.            *
%       ******************************************************************

n=length(x);
 
% Initialize
 
if nargin < 4 fdata=[]; end
if nargin < 5 EJPI=[]; end
if isempty(EJPI)
                EJPI=GetExtJPI(class,fun,n,fdata);
end
 
% Make the function data
if isempty(fdata) [fun,fdata]=MakeExtFdata(class,fun,n); end
 
if (class=='GI')
	if nargout==1
	if fdata.kind==1
		f=funcvalJDI1(fun,x,fdata);
	elseif fdata.kind==2
		f=funcvalJDI2(fun,x,fdata);
	else
		f=funcvalJDI3(fun,x,fdata);
	end
	else
	if fdata.kind==1
                [f,g]=ExtWJDI1(fun,x,f,fdata);
        elseif fdata.kind==2
                [f,g]=ExtWJDI2(fun,x,f,fdata);
        else
                [f,g]=ExtWJDI3(fun,x,f,fdata);
        end
	end
	if length(f)~=1
		f=0.5*(f'*f);
	end
end

if class=='GC'
	if nargout==1
        f=funcvalJGC(fun,x,fdata);
	else
	[f,g]=ExtWJGC(fun,x,1,fdata);
	end
end
if class=='GP'
	if nargout==1
        f=funcvalJGP(fun,x,fdata);
	else
	[f,g]=ExtWJGP(fun,x,1,fdata);
	end
end
if class=='DO'
	if nargout==1
        f=funcvalJDO(fun,x,fdata);
	else
	[f,g]=ExtWJDO(fun,x,1,fdata);
	end
end
if class=='GF'
	if nargout==1
	f=funcvalJgen(fun,x,fdata);
	else
	[f,g]=ExtWJgen(fun,x,1,fdata);
	end
end

