function [f,g]=funcvalExt(class,fun,x,fdata)
%
%funcvalExt
%
%       compute the function and gradient value
%
%       f=funcvalExt(class,fun,x)
%       [f,g]=funcvalExt(class,fun,x)
%
%       Please refer to ADMIT-2 users manual for complete reference.
%
%       ALSO SEE configureExtfun, evalHExt, ExtJV, ExtWJ, ExtHV, ExtVHV
%
%
%       ******************************************************************
%       *              ADMIT-2 Project   1996-97                         *
%       *              Copyright (c) 1996 Cornell University.            *
%       ******************************************************************

n=length(x);
 
% Initialize
 
if nargin < 4 fdata=[]; end
 
% Make the function data
if isempty(fdata) [fun,fdata]=MakeExtFdata(class,fun,n); end

JPI=GetExtJPI(class,fun,n,fdata,'c');
 
if (nargout==2)
[f,ExtJ]=evalJExt(class,fun,x,fdata,JPI);
if class=='GI'
	g=ExtJfunc(2,ExtJ,n,length(f),f);
	if length(f)~=1
                f=0.5*(f'*f);
        end
else
	g=ExtJfunc(2,ExtJ,n,length(f),1);

end

g=g(1:n);
else

	f=funcvalExt(class,fun,x,fdata);
end
