if ~exist('SlideShowGUIFlag'), figNumber=0; end;

global globp
global tape;
global tapecounter;
global varcounter;
global funtens
N=10;
str = str2mat(' ',' ', ' ', ...
 '        First example function is the broyden nonlinear vector function', ...
 '        broy1a.m. Here is the M-code for this function', ...
 '        ', ...
 '        First few steps in this demo deal with this function. ', ...
 '        Press next to continue ...');
ssdisp(figNumber,str);      
drawnow;
type broy1a;

% Delay a little more in the case of AutoPlay

if get(findobj(figNumber,'string','AutoPlay'),'value') pause(2) ; end ;

if sspause(figNumber), return; end;

str = str2mat (...
   '      1. Forward mode of AD -- compute J*V', ...
 '        ', ...
   '      Steps involved :', ...
   '            a. Define input point -- x=ones(N,1);', ...
   '            b. Make x belong to deriv class, and Initialize the seed matrix', ...
   '                    xdot=eye(N); x=deriv(x,xdot);', ...
   '            c. Compute the function (as well as the derivatives via overloading) :', ...
   '                    y=broy1a(x);', ...
   ' ');
   
ssdisp(figNumber,str);                                     
drawnow;
% define input point x

x = ones(N,1);

% Make x belong to deriv class
% and set the derivative (seed matrix) of independent vector x

xdot=eye(N); 
x=deriv(x,xdot);

% Now compute the function along with the derivatives (using overloading)
y=broy1a(x);

% Value of y
echo on
%Done ...

%Value of the function
getval(y)

% Derivative (or product JV) = J since V =eye(N)
getydot(y)

% same result computed by finite differences -- step size 0.001
echo off
J=zeros(N,N);
x=ones(N,1);
for i=1:N
J(:,i)=(broy1a(x+0.001*[zeros(i-1,1);1;zeros(N-i,1)])-broy1a(x))./0.001;
end
J
% Delay a little more in the case of AutoPlay
if get(findobj(figNumber,'string','AutoPlay'),'value') pause(3) ; end ;
if sspause(figNumber), return; end;

str = str2mat(' ', ...
              '  Lets now compute Jacobian for a random input point', ...
              '  ', ...
   '      Steps involved :', ...
   '            a. Define random input point -- x=rand(N,1);', ...
   '            b. Make x belong to deriv class, and Initialize the seed matrix', ...
   '                    xdot=eye(N); x=deriv(x,xdot);', ...
   '            c. Compute the function (as well as the derivatives via overloading) :', ...
   '                    y=broy1a(x);', ...
   ' ');
ssdisp(figNumber,str);      
drawnow;

x=rand(N,1);
V=eye(N);
x=deriv(x,V);
V=eye(N); 

% Now compute the function along with the derivatives (using overloading)
y=broy1a(x);
echo on
%Done ...

%Value of the function
getval(y)

% Jacobian
getydot(y)
echo off


% Delay a little more in the case of AutoPlay
if get(findobj(figNumber,'string','AutoPlay'),'value') pause(3) ; end ;
if sspause(figNumber), return; end;

str = str2mat(' ', ...
              '     Compute first two columns of Jacobian by choosing xdot = eye(N,2)');

ssdisp(figNumber,str);
drawnow;

x =ones(N,1);
V=eye(N,2); 
x=deriv(x,V);

y=broy1a(x);

echo on
% product JV
getydot(y)
echo off

% Delay a little more in the case of AutoPlay
if get(findobj(figNumber,'string','AutoPlay'),'value') pause(3) ; end ;
if sspause(figNumber), return; end;

str = str2mat(' ', ...
   '     2. Reverse Mode : Compute J^T*W', ...
 '        ', ...
   '      Steps involved :', ...
   '            a. Define input point -- x=ones(N,1);', ...
   '            b. Make x belong to derivtape class -- x=derivtape(x);', ...
   '            c. Compute the function and create tape (taping every intermediate via overloading) :', ...
   '                    y=broy1a(x);', ...
   '            d. Initialize the adjoint seed matrix W = eye(N); ', ...
   '            e. Parse and process the tape backwards to compute J^T*W', ...
   '                    parsetape(W);', ...
   '            f. Grab the adjoint from the front end of the tape', ...
   '                    JtW=tape(1).W;', ...
   ' ');
 
ssdisp(figNumber,str);
drawnow;

cleanup;
x=ones(N,1);globp=N;
x=derivtape(x);
y=broy1a(x);
W=eye(N);

% Intialises the adjoint to 1 for computation of gradient 1'*J
parsetape(W);

echo on
% Transpose of Jacobian (J'*W = J' since W=eye(N))
Jt=tape(1).W
echo off
 
% Delay a little more in the case of AutoPlay
if get(findobj(figNumber,'string','AutoPlay'),'value') pause(3) ; end ;
if sspause(figNumber), return; end;

str = str2mat (...
   '      3. Sparsity Pattern of the Jacobian', ...
 '        ', ...
   '      Steps involved :', ...
   '            a. Define dimension M =10, N=10;', ...
   '            b. create a dummy input point x= rand(N,1);', ...
   '            c. Make x belong to derivspj class and Initialize the seed matrix :', ...
   '                    xdot=speye(N); x=derivspj(x,xdot)', ...
   '            d. Compute the function (as well as the sparsity pattern via overloading) :', ...
   '                    y=broy1a(x);', ...
   '            e. Grab the sparsity pattern off y : SPJ=getydot(y) ', ...
   ' ');
 
ssdisp(figNumber,str);
drawnow ;

x =ones(N,1);
% Make x belong to derivspj class

x=derivspj(x,speye(N));

% Now compute the function along with the sparsity pattern (using overloading)

y=broy1a(x);

echo on
% The sparsity pattern of the Jacobian
spy(spones(getydot(y)))
echo off
title 'Sparsity pattern of the Jacobian'

 
% Delay a little more in the case of AutoPlay
if get(findobj(figNumber,'string','AutoPlay'),'value') pause(3) ; end ;
if sspause(figNumber), return; end;

str = str2mat(' ',' ', ' ', ...
 '        Second example function is the brown nonlinear scalar function', ...
 '        brown1.m. Here is the M-code for this function', ...
 '        ', ...
 '        Rest of the  demo deals with this function. ', ...
 '        Press next to continue ...');

 
ssdisp(figNumber,str);
drawnow ;

type brown1


 
% Delay a little more in the case of AutoPlay
if get(findobj(figNumber,'string','AutoPlay'),'value') pause(3) ; end ;
if sspause(figNumber), return; end;

str = str2mat(' ', ...
   '     1. Compute the Gradient -- Using full reverse mode', ...
   '      Steps involved are exactly similar to computing J^T*W using', ...
   '      reverse mode -- for gradient case W=1(scalar).', ...
   ' ');


ssdisp(figNumber,str);
drawnow ;
cleanup;
x=ones(N,1);x=derivtape(x);globp=1;
y=brown1(x);

% Intialises the adjoint to 1 for computation of gradient 1'*J
parsetape(1);

echo on
% function value
f=getval(y)

% gradient
grad=tape(1).W

echo off

if get(findobj(figNumber,'string','AutoPlay'),'value') pause(3) ; end ;
if sspause(figNumber), return; end;


str = str2mat(' ', ...
   '     2. Hessian times Matrix -- Using combination of forward and reverse modes', ...
 '          H*V is the gradient of (grad(f)^T*V), where grad(f) is the gradient of f', ...
  ' ', ....
   '      Steps involved :', ...
   '            a. Define input point -- x=ones(N,1);', ...
   '            b. Make x belong to derivtapeH class -- x=derivtapeH(x);', ...
   '            c. Forward mode : Compute the function+first derivatives and create tape :', ...
   '                y=brown1(x); -- computes (grad(f)^T*V) and creates tape for subsequent reverse mode', ...
   '            d. Reverse Mode : Parse and process the tape backwards to compute H*V', ...
   '                parsetape(eye(size(V,2))) -- since the output of forward mode is same size as # cols in V;', ...
   '            e. Grab the adjoint from the front end of the tape', ...
   '                    HV=tape(1).W;', ...
   ' ');

ssdisp(figNumber,str);
drawnow ;
cleanup;
V=eye(N);
x=ones(N,1);
globp=size(V,2);
x=derivtapeH(x,V);
y=brown1(x);
parsetape(eye(globp));


echo on
% Hessian vector product -- in this case the full hessian since V=I
HV=tape(1).W
echo off
if get(findobj(figNumber,'string','AutoPlay'),'value') pause(3) ; end ;
if sspause(figNumber), return; end;


str = str2mat(' ', ...
              '     First two columns of Hessian by choosing V = eye(N,2)')

ssdisp(figNumber,str);
drawnow ;
cleanup;

V=eye(N,2);
x=ones(N,1);
globp=size(V,2);
x=derivtapeH(x,V);
y=brown1(x);
parsetape(eye(globp));

echo on
% First 2 columns of the Hessian
HV=tape(1).W
echo off

if get(findobj(figNumber,'string','AutoPlay'),'value') pause(3) ; end ;
if sspause(figNumber), return; end;


str = str2mat (...
   '      3. Sparsity Pattern of the Hessian (this is just the forward mode)', ...
 '        ', ...
   '      Steps involved :', ...
   '            a. Define dimension N=10;', ...
   '            b. create a dummy input point x= rand(N,1);', ...
   '            c. Make x belong to derivsph class -- x=derivsph(x,speye(N));', ...
   '                (Sets xdot = I, xdoubledot = 0) ', ...
   '            d. Compute the function (as well as the sparsity pattern via overloading) :', ...
   '                    y=brown1(x);', ...
   '            e. Grab the sparsity pattern off y : SPH=getydot(y) ', ...
   ' ');


ssdisp(figNumber,str);
drawnow ;
x=ones(N,1);
globp=N;
x=derivsph(x,speye(N));
y=brown1(x);

echo on
% Sparsity structure of Hessian
H=spones(getydot(y));
spy(H)
echo off
title 'Sparsity pattern of the Hessian'


if get(findobj(figNumber,'string','AutoPlay'),'value') pause(3) ; end ;
if sspause(figNumber), return; end;

str = str2mat (...
   '       An application -- 1-D wave propagation', ...
   ' ', ...
   '          First the forward solve ...', ...
   ' ');


ssdisp(figNumber,str);
drawnow ;
type forwardsolve

forwardsolve;


if get(findobj(figNumber,'string','AutoPlay'),'value') pause(3) ; end ;
if sspause(figNumber), return; end;

str = str2mat (...
   '       An application -- 1-D wave propagation', ...
   ' ', ...
   '          Computation of field adjoint -- using the data to feedback the adjoint  ...', ...
   ' ');


ssdisp(figNumber,str);
drawnow ;
solve_rev;
subplot(2,1,3);
plot(c);

if get(findobj(figNumber,'string','AutoPlay'),'value') pause(3) ; end ;
if sspause(figNumber), return; end;
