function solveopt
%
% Make the transformation etc.
%
global K
global r
global q
global T
global sigma
global N
global M

global k1
global k2
global dx
global dt
global x
global A

sigma =0.5;
K=95;
r=0.1;
q=0.0;
T=0.25;
N=20;
M=10;
x2=2;
x1=-5;
x=linspace(x1,x2,N); x=x(:);

dx = (x2-x1)/(N-1);

dt = T/(M-1);

halfsigmasqr = 0.5*sigma*sigma;
k1=r/halfsigmasqr; k2=(r-q)/halfsigmasqr;

a=(1+2*sigma).*ones(N-2,1);
b=sigma.*ones(N-2,1);

A=spdiags([-[b(1:N-3);1;0] [a;1] -[b;0]],-1:1,N-1,N-1);

u=max(0,exp(0.5*(k2+1)*x)-exp(0.5*(k2-1)*x));
tau=0;

V=zeros(N,M);
V(:,1)=K*exp(-0.5*(k2-1)*x-(0.25*(k2-1)*(k2-1)+k1)*tau).*u;
S=K*exp(x);
hold on
plot(S,V(:,1));
count=1;
for i = dt : dt : T
	tau=tau+dt*halfsigmasqr;
	u1=timestep(u,tau);
	u=u1;
count=count+1;
V(:,count)=K*exp(-0.5*(k2-1)*x-(0.25*(k2-1)*(k2-1)+k1)*tau).*u;
plot(S,V(:,count))
end

hold off
%surf(V)
%V=K*exp(-0.5*(k2-1)*x-(0.25*(k2-1)*(k2-1)+k1)*T).*u;
