function fvec= broy1b(x,Extra);
%
% Evaluate  the first n/2 Broyden nonlinear equations.
% See ?/ for more details on this function.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% INPUT:
%     x - The current point (column vector).
% dummy - dummy variable.
%
% OUTPUT:
%  fvec - The (vector) function value at x.
%  A    - The (sparse) rectangular Jacobian matrix.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Evaluate the vector function
  n = length(x); m = floor(n/2);
  i=2:(n-1);
  fvec(i)= (3-2*x(i)).*x(i)-x(i-1)-2*x(i+1)+ones(n-2,1);
  fvec(n)= (3-2*x(n)).*x(n)-x(n-1)+1;
  fvec(1)= (3-2*x(1)).*x(1)-2*x(2)+1;
  fvec = fvec(1:m);
