function HV = HtimesV(fun,x,V,Extra,stepsize)
if nargin < 5 stepsize=[]; end
if nargin < 4 Extra=[]; end
if isempty(stepsize) stepsize=1e-5.*ones(size(V,2),1); end

if ~isstr(fun)
if isempty(Extra)
HV=maindriver(11,fun,x,V,stepsize);
else
HV=maindriver(11,fun,x,V,stepsize,Extra);
end
else
        fun=deblank(fun);
        n=length(x);
        [f,g]=feval(fun,x,Extra);
        HV=zeros(n,size(V,2));
        for i=1:size(V,2)
                [val,valg]=feval(fun,x+stepsize(i).*V(:,i),Extra);
                HV(:,i)=(valg-g)./stepsize(i);
        end
end

