function HV = HtimesV(fun,x,V,Extra,stepsize)
%
%HtimesV
%
%       Computes the Hessian Matrix product H*V 
%
%       The user's function is identified by a unique identifier
%       fun. See ADMIT users manual for detail.
%
%
%       HV=HtimesV(fun,x,V) 
%
%       Please refer to ADMIT users manual for complete reference.
%
%       ALSO SEE funcval, HessSP
%
%
%       ******************************************************************
%       *              ADMIT Project   10-1-96                           *
%       *              Copyright (c) 1996 Cornell University.            *
%       ******************************************************************
if nargin < 4 Extra=[]; end

if ~isstr(fun)
if isempty(Extra)
	HV=maindriver(8,fun,x,V);
else
	HV=maindriver(8,fun,x,V,Extra);
end

else
	fun=deblank(fun);
	n=length(x);
        [f,g]=feval(fun,x,Extra);
        HV=zeros(n,size(V,2));
        for i=1:size(V,2)
                [val,valg]=feval(fun,x+stepsize.*V(:,i),Extra);
                HV(:,i)=(valg-g)./stepsize;
        end
end
