  function[f,Jout] = sfdsub(fun,x,Extra,m,verb,JPI)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% INPUT:
%  fun : handle to the function
%   x: Estimate J at the current point x.
%   J: the sparse matrix structure of the Jacobian
%   Jr: the sparse matrix structure of the J by columns
%   Jc: the sparse matrix structure of the J by rows
%   groups : The groups of columns and rows
%
%   o :    These are some internal information from partition algorithm
%   rc :
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
n=length(x);
if nargin < 6
JPI=[];
end

if isempty(JPI)
JPI= getJPI(fun, m, n,Extra,'s');
end
PartInfo=JPI(2:length(JPI));

[PartInfo1,A,p1,p,q]=ExtractSubJPI(PartInfo);
m=PartInfo1(size(PartInfo1,1),n+1);
Jc=PartInfo1(1:m,1:n);
Jr=PartInfo1(1:m,n+1:2*n);
gr=full(PartInfo1(1:m,2*n+1));
gc=full(PartInfo1(m+1,1:n));
gc=gc';
o=full([PartInfo1(1:m,2*n+2); PartInfo1(m+1,n+1:2*n)']);
rc=full([PartInfo1(1:m,2*n+3); PartInfo1(m+2,1:n)']);
rowcons=full(PartInfo1(1:m,2*n+4));
colcons=full(PartInfo1(m+2,n+1:2*n));
invpermrow=full(PartInfo1(1:m,2*n+5));
invpermcol= full(PartInfo1(m+3,1:n));
nrow=size(PartInfo1,2)-5-2*n;
W=PartInfo1(1:m,2*n+6:2*n+5+nrow);
W=full(W);
ncol=size(PartInfo1,1)-3-m;
V=PartInfo1(m+4:m+3+ncol,1:n);
V=V';
V=full(V);
if isempty(verb) verb=0; end
if (verb >=1)
        disp(sprintf('Number of Row groups = %d',max(gr)));
        disp(sprintf('Number of column groups = %d',max(gc)));
        disp(sprintf('Total Number of groups = %d',max(gc)+max(gr)));
end
if (verb >= 2)
        subplot(2,2,1);
        spy(Jr+Jc);
        title 'Sparsity Structure of J'
        subplot(2,2,2);
        spy(Jr);
        title 'Jr: Part computed by reverse AD'
        subplot(2,2,3);
        spy(Jc);
        title 'Jc: Part computed by forward AD'
end
  JV = zeros(m,ncol);
  WJ=zeros(n,nrow);
% Form AD products
   if ncol >0
	[f,JV] =forwprod(fun,x,V,m,Extra);
   end
   if nrow >0
	[f,WJ] =revprod(fun,x,W,Extra);
   end
if ((ncol==0)&(nrow==0)) f=funcvalJ(fun,x,m,Extra); end

if (ncol==0)
gc(find(gc==0))=ones(length(find(gc==0)),1);
  [i, j]=find(Jr);
  Jout = sparse(i,j,WJ((gr(i)-1)*n + j),m,n);
end

if (nrow==0)
gr(find(gr==0))=ones(length(find(gr==0)),1);
  [i, j]=find(Jc);
  Jout = sparse(i,j,JV((gc(j)-1)*m + i),m,n);
end
if (ncol> 0) &(nrow > 0)
JV=JV';
WJ=WJ';
b=[];
if ncol> 0
b=[b;reshape(JV,m*ncol,1)];
end
if nrow > 0
b=[b;reshape(WJ,n*nrow,1)];
end
b=b(p1(p));
Jflat=A\b;
Jflat(q)=Jflat;
[i,j]=find((Jr+Jc)');
Jout=sparse(i,j,Jflat,n,m);
Jout=Jout';
end
