function fun = configFv(mainfilename,sourcedir)
%
%configFv
%	configures ``Vectorized'' programs. Vectorized programs
%       are easier to write for the user using a convenient
%       MATLAB-like notation, and are usually more efficient.
%
%       fun=configFv(filename) 
%           configures the ``vectorized'' function 'filename'.c in  current
%           working directory with ADMIT.
%
%       fun=configFv(filename,sourcedir)
%           configures the functions in directory sourcedir(relative to
%           current working directory). 'filename'.c is assumed
%           to be the top level file with ADMIT ``vectorized'' design.
%
%       Please refer to ADMIT users manual for complete reference.
%
%       ALSO SEE evalJ, evalH, configF
%
%
%       ******************************************************************
%       *              ADMIT Project   10-1-96                           *
%       *              Copyright (c) 1996 Cornell University.            *
%       ******************************************************************
currdir=cd;
cd(getenv('ADMIT_HOME'));
solaris=getenv('SOLARIS');
disp('Configuring ..')
cd FUNCINTERNALS
load counter;

if nargin > 1
	newdir = sprintf('%s/%s',currdir,sourcedir);
	cd ../FUNCDIR/EXTRASRC;
	unix(sprintf('cp %s/* .',newdir));
	%%%% DO ADOLCIFY HERE

	Csrc=ls ; 
	lenCsrc=length(Csrc);

	notdone=1;
	index=1;
	while (notdone)
		while abs(Csrc(index)==10) index=index+1; if index > lenCsrc break; end 
		end
		if (index <= lenCsrc) 
			newindex=index+1;
			while abs(Csrc(newindex)~=10) newindex=newindex+1; end
			filename=Csrc(index:newindex-1);
			if (length(filename)-2==length(mainfilename))
				if (Csrc(index:newindex-3)==mainfilename)
					unix(sprintf('mv %s fun%d.c',filename,counter));
					filename2=sprintf('fun%d.c',counter);
					filename=filename2;
				end
			end

			%%% Do this file
			unix(sprintf('../../FUNCINTERNALS/exscript %d  >! ../../FUNCINTERNALS/adolcify',counter));
	unix(sprintf('../../FUNCINTERNALS/exscriptfun %d  >! ../../FUNCINTERNALS/valify',counter));
			unix(sprintf('../../FUNCINTERNALS/valify < %s >! tmp',filename));
			unix(sprintf('mv tmp val_%s', filename));
			unix(sprintf('../../FUNCINTERNALS/adolcify < %s >! tmp',filename));
			unix(sprintf('mv tmp %s', filename));
			%%% Create ad_ file
			if (Csrc(newindex-2:newindex-1)=='.c')	
			disp(sprintf('Adding module %s',filename));
			unix(sprintf('../../FUNCINTERNALS/makeadcfile \\"%s\\" >! ad_%s',filename,filename));
			unix(sprintf('../../FUNCINTERNALS/makeadcfileval \\"val_%s\\" >! adv_%s',filename,filename));
				
			end
		else
			notdone=0;
		end
		index=newindex;
	end


	cd ../../FUNCINTERNALS
        if (solaris=='1')
                unix(sprintf('jacconfigurevec %d ',counter));
        else
                unix(sprintf('jacconfiguresunosvec %d ',counter));
        end

else
	unix(sprintf('cp %s/%s.c ../FUNCDIR/EXTRASRC/.',currdir,mainfilename));
	cd ../FUNCDIR/EXTRASRC/
	unix(sprintf('../../FUNCINTERNALS/exscript %d  >! ../../FUNCINTERNALS/adolcify',counter));
	unix(sprintf('../../FUNCINTERNALS/exscriptfun %d  >! ../../FUNCINTERNALS/valify',counter));
	unix(sprintf('../../FUNCINTERNALS/adolcify < %s.c >! tmp',mainfilename));
	unix(sprintf('mv tmp fun%d.c', counter));
	unix(sprintf('../../FUNCINTERNALS/valify < %s.c >! tmp',mainfilename));
	unix(sprintf('mv tmp val_fun%d.c', counter));
	%%% Create ad_ file
	disp(sprintf('Adding module %s',mainfilename));
	unix(sprintf('../../FUNCINTERNALS/makeadcfile \\"fun%d.c\\" >! ad_fun%d.c',counter,counter));
	unix(sprintf('../../FUNCINTERNALS/makeadcfileval \\"val_fun%d.c\\" >! adv_fun%d.c',counter,counter));
	cd ../../FUNCINTERNALS
        if (solaris=='1')
                unix(sprintf('jacconfigurevec %d ',counter));
        else
                unix(sprintf('jacconfiguresunosvec %d ',counter));
        end

end

fun=counter;
counter =counter+1;
save counter counter -ascii
cd ..
disp('done..');
cd(currdir);
