function fun = configmc(mainfilename,sourcedir)
%
%configmc
%
%	
%       fun=configF(filename) 
%           configures the function 'filename'.c in  current
%           working directory with ADMIT.
%
%       fun=configF(filename,sourcedir) 
%           configures the functions in directory sourcedir(relative to
%           current working directory). 'filename'.c is assumed
%           to be the top level file with ADMIT design.
%
%       Please refer to ADMIT users manual for complete reference.
%
%       ALSO SEE evalJ, evalH, configFv
%
%
%       ******************************************************************
%       *              ADMIT Project   10-1-96                           *
%       *              Copyright (c) 1996 Cornell University.            *
%       ******************************************************************
currdir=cd;
cd(getenv('ADMIT_HOME'));
load FUNCINTERNALS/counter;
!cp examplemc.c matcomex/. 
cd matcomex;
if nargin > 1
	if (sourcedir(1)=='/') | (sourcedir(1)=='~')
	newdir = sourcedir;
	else
	newdir = sprintf('%s/%s',currdir,sourcedir);
	end
	unix(sprintf('cp %s/*.m .',newdir));
	unix(sprintf('mv %s.m matcomfunc.m',mainfilename));
else
	unix(sprintf('cp %s/%s.m matcomfunc.m',currdir,mainfilename));
end

!matcom matcomfunc.m -x
!/bin/rm *.r *.rsp g_* *.m

Csrc=ls ;
        lenCsrc=length(Csrc);

        notdone=1;
        index=1;
        while (notdone)
                while abs(Csrc(index)==10) 
			index=index+1; 
			if index > lenCsrc break; end
                end
                if (index <= lenCsrc)
                        newindex=index+1;
                        while abs(Csrc(newindex)~=10) newindex=newindex+1;
			end
                        filename=Csrc(index:newindex-1);

                        if (Csrc(newindex-4:newindex-1)=='.cxx')
                        unix(sprintf('mv %s %s',filename,Csrc(index:newindex-3)));
                        end
                else
                        notdone=0;
                end
                index=newindex;
        end

unix(sprintf('mv matcomfunc.c matcomfunc%d.c',counter));
unix(sprintf('mv matcomfunc.h matcomfunc%d.h',counter));
cd ..
fun=configf('examplemc','matcomex');
!/bin/rm matcomex/*
cd(currdir);
