function [s,it,normres]=cg(fun,x,m,tol,P,J,JPI)

% Initializations
n=length(x);
if nargin < 3 m =[]; end
if nargin < 4 tol =[]; end
if nargin < 5 P =[]; end
if nargin < 6 J =[]; end
if nargin < 7 JPI =[]; end

if isempty(m) m =n; end
if isempty(tol) tol =1e-6; end
if isempty(P)  P =speye(n); end

if isempty(J)
if isempty(JPI) JPI =getJPI(fun,m,n); end
	[f,J]=evalJ(fun,x,[],m,JPI);
else
	f=funcvalJ(fun,x,m);
end

k=0;
s=zeros(n,1);
r=-J'*f;
normb=norm(r);
rho=normb;

% Main loop
while (rho > tol*normb) 
	z=P\r;
	k=k+1;
	if k==1
		p=z;
	else
		beta=r'*z/(rprev'*zprev);
		p=z+beta.*p;
	end
	temp=J*p;
	alpha=r'*z/(temp'*temp);
	s=s+alpha.*p;
	zprev=z;
	rprev=r;
	r=r-alpha.*J'*temp;
	rho=norm(r);
end

it=k;
normres=rho;
	
