function []=example(fun1,verb)
if nargin < 2 verb =0; end

disp('First a 10x10 example ...');
disp('-------------------------');
n=10;
x=ones(10,1);
JPI=getJPI(fun1,n,[],[],'d');
disp('First evaluating by Direct BiColoring ...');
[f,Jd]=evalJ(fun1,x,[],[],JPI,verb);
disp(' ');
disp('Done..Press any key to continue ...');
pause
JPI=getJPI(fun1,n,[],[],'s');
disp('Now evaluating by Substitution BiColoring ...');
[f,Js]=evalJ(fun1,x,[],[],JPI,verb);
disp(' ');
disp('Done..Press any key to continue ...');
pause
JPI=getJPI(fun1,n,[],[],'f');
disp('Now evaluating by Finite differences ...');
[f,Jf]=evalJ(fun1,x,[],[],JPI,verb,1e-4);
disp(' ');
disp('Done..Press any key to continue ...');

disp(sprintf('Error in Direct and substitution Methods = %e',norm(full(Jd-Js))));
disp(sprintf('Error in Direct and Finite Diff Methods = %e',norm(full(Jd-Jf))));
disp(' ');
disp(' ');
disp(' ');
pause


disp('Now a 100x100 example..');
disp('-----------------------');
n=100;
x=ones(n,1);
JPI=getJPI(fun1,n,[],[],'d');
disp('First evaluating by Direct BiColoring ...');
[f,Jd]=evalJ(fun1,x,[],[],JPI,verb);
disp(' ');
disp('Done..Press any key to continue ...');
pause
JPI=getJPI(fun1,n,[],[],'s');
disp('Now evaluating by Substitution BiColoring ...');
[f,Js]=evalJ(fun1,x,[],[],JPI,verb);
disp(' ');
disp('Done..Press any key to continue ...');
pause
JPI=getJPI(fun1,n,[],[],'f');
disp('Now evaluating by Finite differences ...');
[f,Jf]=evalJ(fun1,x,[],[],JPI,verb,1e-4);
disp(' ');
 
disp(sprintf('Error in Direct and substitution Methods = %e',norm(full(Jd-Js))));
disp(sprintf('Error in Direct and Finite Diff Methods = %e',norm(full(Jd-Jf))));

