function [f,JV] = FDapprox(fun,x,V,m,epsvec,Extra)
%
%FDapprox
%
%       Computes the J*V product using Finite difference
%
%       The user's function is identified by a unique identifier
%       fun. See ADMIT users manual for detail.
%
%       [f,JV]=FDapprox(fun,x,V)
%
%       Please refer to ADMIT users manual for complete reference.
%
%       ALSO SEE funcvalJ, revprod, forwprod, JacSP
%
%
%       ******************************************************************
%       *              ADMIT Project   10-1-96                           *
%       *              Copyright (c) 1996 Cornell University.            *
%       ******************************************************************

if nargin < 4 m=length(x);
if nargin < 5 epsvec=[]; end
if nargin < 6 Extra=[]; end
end
if isempty(epsvec) epsvec=1e-5.*ones(size(V,2),1); end

if ~isstr(fun)
if isempty(Extra)
[f,JV]=maindriver_val(3,fun,x,V,m,epsvec);
else
[f,JV]=maindriver_val(3,fun,x,V,m,epsvec,Extra);
end

else
	fun=deblank(fun);
	f=feval(fun,x,m,Extra);
	JV=zeros(m,size(V,2));
	for i=1:size(V,2)
		val=feval(fun,x+epsvec(i).*V(:,i),m,Extra);
		JV(:,i)=(val-f)./epsvec(i);
	end

end
