function [Jout]=fdjac(fun,SPJ,x,ConstStepSize,verb)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%       Returns Jacobian at x, given structure J
%
%	USES Sparse Finite Differences
%
%	fun : Handle to the function
%       x= Current Point
%       SPJ=Sparsity Pattern
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

[m,n]=size(SPJ);

H=spones(SPJ'*SPJ);
p=id(H,full(sum(H)));
g=color(H,p);
if isempty(verb) verb=0; end
if (verb >=1)
        disp(sprintf('Number of SFD groups = %d',max(g)));
end
if (verb >= 2)
	subplot(1,1,1)
        spy(SPJ);
        title 'Sparsity Structure of J'
end
Jout=sparse(n,n);
Jout=JacRecoverSFD(fun,x,SPJ,g,ConstStepSize);
end
