function [val,grad] = funcval(fun,x,Extra)
%
%funcvalJ
%
%       Computes  the value and gradient  of a scalar function
%
%       The user's function is identified by a unique identifier
%       fun. See ADMIT users manual for detail.
%
%       v=funcval(fun,x) 
%       [v,grad]=funcval(fun,x) 
%
%       Please refer to ADMIT users manual for complete reference.
%
%       ALSO SEE HessSP. HtimesV
%
%
%       ******************************************************************
%       *              ADMIT Project   10-1-96                           *
%       *              Copyright (c) 1996 Cornell University.            *
%       ******************************************************************
if nargin < 3 Extra=[]; end

if ~isstr(fun)

if isempty(Extra)
	if nargout==1
		val=maindriver_val(1,fun,x);
	else
		[val,grad]=maindriver(10,fun,x);
	end
else
	if nargout==1
		val=maindriver_val(1,fun,x,Extra);
	else
		[val,grad]=maindriver(10,fun,x,Extra);
	end
end

else
	fun=deblank(fun);

	if nargout==1
		val=feval(fun,x,Extra);
	else
		[val,grad]=feval(fun,x,Extra);
	end
end
