function SPH = HessSP(fun,n,Extra)
%
%HessSP
%
%       Computes  the sparsity structure of Hessian matrix
%
%       The user's function is identified by a unique identifier
%       fun. See ADMIT users manual for detail.
%      
%       SPH=HessSP(fun,x) 
%
%       Please refer to ADMIT users manual for complete reference.
%
%       ALSO SEE funcval, HtimesV
%
%
%       ******************************************************************
%       *              ADMIT Project   10-1-96                           *
%       *              Copyright (c) 1996 Cornell University.            *
%       ******************************************************************
if nargin < 3 Extra=[]; end

if ~isstr(fun)
if isempty(Extra)
SPH=maindriver(5,fun,n);
else
SPH=maindriver(5,fun,n,Extra);
end

else
fun=deblank(fun);
[f,grad,SPH]=feval(fun,ones(n,1),Extra);
end
