function SPJ = JacSP(fun,m,n,Extra)
%
%JacSP
%
%       Computes  the sparsity structure of Jacian matrix
%
%       The user's function is identified by a unique identifier
%       fun. See ADMIT users manual for detail.
%      
%
%       SP=JacSP(fun,x) 
%
%       Please refer to ADMIT users manual for complete reference.
%
%       ALSO SEE funcvalJ, revprod, forwprod
%
%
%       ******************************************************************
%       *              ADMIT Project   10-1-96                           *
%       *              Copyright (c) 1996 Cornell University.            *
%       ******************************************************************

if nargin < 3 n=[]; end
if nargin < 4 Extra=[]; end;
if isempty(n) n=m; end

if ~isstr(fun)
	if isempty(Extra)
		SPJ=maindriver(4,fun,m,n);
	else
		SPJ=maindriver(4,fun,m,n,Extra);
	end
else
	fun=deblank(fun);
	[f,SPJ]=feval(fun,ones(n,1),m,Extra);
end

