#include <string.h>
#include <malloc.h>
#include <stdio.h>
#include <stream.h>
#include <math.h>
 
#include "adouble.h"
#include "adutils.h"
#include "createPat.h"
#include "mex.h"
 
void trace_proc(int,double *,double *, int, int,double *, int, int);
void trace_proc_rev(int, double *,double *, int, int, double *, int, int);
void trace_proc_wthess(int, double *,double *, int, int, double *,double *, int, int);

#define FORWPROD 1 
#define REVPROD  2 
#define JacSP    4
#define HessSP  5
#define HTIMESV  8
#define FDHTIMESV  11
#define WTHTIMESV  12
#define WTHESSSP  13
#define INITTAPE  9
#define FUNCVALG  10
#define eps 0.0001
 

void
mexFunction(int nlhs,mxArray *plhs[],int nrhs,const mxArray *prhs[])
{
	int k,n,m,p,j,i,funtag,count[11];
        double *ExtraArg=NULL,*epsilon;
	int newm,newn;
	int op;
	op=(int)*mxGetPr(prhs[0]);
	switch(op){
	case REVPROD : 
{
#include "myrevprod.c"
}
	break;
	case FORWPROD : 
{
#include "myforwprod.c"
}
	break;
	case JacSP : 
{
#include "myJacSP.c"
}
	break;
	case HessSP : 
{
#include "myHessSP.c"
}
	break;
	case HTIMESV : 
{
#include "myHtimesV.c"
}
	break;
	case INITTAPE : 
{
#include "myinittape.c"
}
	break;
	case FUNCVALG : 
{
#include "myfuncvalg.c"
}
	break;
        case FDHTIMESV :
{
#include "myFDHtimesV.c"
}
	break;
        case WTHTIMESV :
{
#include "mywtHtimesV.c"
}
	break;

        case WTHESSSP :
{
#include "mywtHessSP.c"
}
	break;


	}
}
