function [x,it,nf]= newton(fun, xstart, tol, itbnd, JPI)

% Initializations
n=length(xstart);
if (nargin < 3) tol=1e-5; end
if (nargin < 4) itbnd=60; end
if (nargin < 5) 
% Get the Coloring Info Once and for all
	JPI= getJPI(fun,n);
end

n=length(xstart);
x=xstart;

% First Evaluation
[f,J]=evalJ(fun,x,[],[],JPI);
it=0;

% The Newton Iteration
while ((norm(f) > tol) & (it < itbnd))

	delta= -J\f;
	x=x+delta;
	[f,J]=evalJ(fun,x,[],[],JPI);
	it=it+1;	
end

nf=norm(f);
