function [x,it,nf]= newton(fun, xstart, tol, itbnd, HPI)

% Initializations
n=length(xstart);
if (nargin < 3) tol=1e-5; end
if (nargin < 4) itbnd=60; end
if (nargin < 5) 
% Get the Coloring Info Once and for all
	HPI= getHPI(fun,n);
end

n=length(xstart);
x=xstart;

% First Evaluation
[val,f,H]=evalH(fun,x,[],HPI);
it=0;

% The Newton Iteration
while ((norm(f) > tol) & (it < itbnd))

	delta= -H\f;
	x=x+delta;
	[val,f,H]=evalH(fun,x,[],HPI);
	it=it+1;	
end

nf=norm(f);
