function [numg]=numgrJ(PartInfo,method,n)
%
%numgrJ
%
%       Returns the total number of groups used in the partition
%       PartInfo returned by GetJPI
%
%       numg=numgrJ(PartInfo,'d',10) 
%
%       Please refer to ADMIT users manual for complete reference.
%
%       ALSO SEE evalJ, GetJPI
%
%
%       ******************************************************************
%       *              ADMIT Project   10-1-96                           *
%       *              Copyright (c) 1996 Cornell University.            *
%       ******************************************************************

if nargin < 2 method ='d'; end
if nargin < 3 n=size(PartInfo,2)/2; end
if isempty(method) method ='d'; end
if isempty(n) n=size(PartInfo,2)/2; end


if (method=='s')
m=PartInfo(size(PartInfo,1),n+1);
nrow=size(PartInfo,2)-5-2*n;
ncol=size(PartInfo,1)-3-m;
numg=ncol+nrow;
 
elseif (method =='d')
m=PartInfo(size(PartInfo,1),n+1);
nrow=size(PartInfo,2)-1-2*n;
ncol=size(PartInfo,1)-1-m;
numg=ncol+nrow;

 
else

[m,n]=size(PartInfo);
m=m-1;
group=PartInfo(m+1,:);
numg=max(group);
end
numg=full(numg);
