function [f,WJ] = revprod(fun,x,W,Extra)
%
%revprod
%
%       Computes forward mode product J'*W using ADOLC 
%
%       The user's function is identified by a unique identifier
%       fun. See ADMIT users manual for detail.
%
%       [f,WJ]=revprod(fun,x,W) computes J*V at point x.
%
%       Please refer to ADMIT users manual for complete reference.
%
%       ALSO SEE forwprod, funcvalJ, JacSP
%
%
%       ******************************************************************
%       *              ADMIT Project   10-1-96                           *
%       *              Copyright (c) 1996 Cornell University.            *
%       ******************************************************************

if nargin < 4 Extra=[]; end

if isempty(Extra)
[f,WJ]=maindriver(2,fun,x,W);
else
[f,WJ]=maindriver(2,fun,x,W,Extra);
end

