function SPH = HessSP(fun,n,m,Extra)
%
%TensP
%
%       Computes  the sparsity structure of Hessian matrix of 
%	 (F(x)'*w), where w is a general multiplier, and F is a vector function.
%
%       The user's function is identified by a unique identifier
%       fun. See ADMIT users manual for detail.
%      
%       HSP=TensSP(fun,n) 
%       HSP=TensSP(fun,n,m) 
%
%       Please refer to ADMIT users manual for complete reference.
%
%       ALSO SEE funcval, HtimesV, HessSP
%
%
%       ******************************************************************
%       *              ADMIT Project   10-1-96                           *
%       *              Copyright (c) 1996 Cornell University.            *
%       ******************************************************************
if nargin < 4 Extra=[]; end
if nargin < 3 m=[]; end

if isempty(m) m=n; end

if ~isstr(fun)
if isempty(Extra)
SPH=maindriver(13,fun,n,rand(m,1));
else
SPH=maindriver(13,fun,n,rand(m,1),Extra);
end

else
        fun=deblank(fun);
        [f,SPJ,SPH]=feval(fun,ones(n,1),m,Extra);
end

