/*
   ----------------------------------------------------------------------------
   Author  : Uwe Geitner
   Hardware: IBM-compatible PC 386/40
   Software: g++-GNU-Compiler (v2.4) under Linux
   Date    : 18/07/95
   Content : - Implementation of friend function from structure 
               MatLab_output_
   ----------------------------------------------------------------------------
*/


#define _MATLAB_CPP

#include <stdio.h>
#include <memory.h>
#include "MatLab.h"

MatLab_output* alloc4MatLab(unsigned int size1, unsigned int size2)
{
  MatLab_output*   help = new MatLab_output ;

  help->size_array_elem = size1 ;
  help->elem_cnt        = new int[help->size_array_elem+1] ;
  memset(help->elem_cnt, 0, (help->size_array_elem+1) * sizeof(int)) ;

  help->size_array_row  = size2 ;
  help->row_indices     = new int[help->size_array_row] ;
  memset(help->row_indices, 0, help->size_array_row * sizeof(int)) ;

  return help ;
}

void destrMatLab(MatLab_output* name)
{
  if (name->elem_cnt    != NULL)  delete[] name->elem_cnt ;
  if (name->row_indices != NULL)  delete[] name->row_indices ;
}

#undef MATLAB_CPP
