/*
   ----------------------------------------------------------------------------
   Author  : Uwe Geitner
   Hardware: IBM-compatible PC 386/40
   Software: g++-GNU-Compiler (v2.4) under Linux
   Date    : 14/07/95
   Content : - Definition of the base class myBitPattern
   ----------------------------------------------------------------------------
*/

#ifndef _BITFELD_H
#define _BITFELD_H

enum flag2   { falze = 0 , truu = 1 , arror = 2 } ;

class myBitPattern
{
  protected:
    unsigned int  arr_size ;     // size of the bitpattern array 
    unsigned int  pat_size ;     // bits in one pattern
    unsigned int  blocks ;       // pattern size in blocks of integer
    unsigned int  NNZinMat ;     // number of nonzeros in matrix
    int**         bits ;         // the bitpattern array

  public :
    myBitPattern() ;                                 
    ~myBitPattern() ;
    inline unsigned int  getArrSize(void)   const  { return arr_size ; } ;
    inline unsigned int  getPatSize(void)   const  { return pat_size ; } ;
    inline unsigned int  getBlocks(void)    const  { return blocks ; } ;
    inline void          incNNZinMat(void)         { NNZinMat++ ; } ;
    inline void          setNNZinMat(unsigned int number)
                         { NNZinMat = number ; } ;   
    inline unsigned int  getNNZinMat(void)  const  { return NNZinMat ; } ; 
    inline unsigned int  getNumber(int row, int pos) const
                         { return bits[row][pos] ; } ;
    void TRANS     (const myBitPattern*, unsigned int) ;
       // TRANSLATE FROM hessbitpat to Hessian
    void ADD     (unsigned int, unsigned int, unsigned int,const myBitPattern*) ;
    void ADD     (unsigned int, unsigned int,const myBitPattern*) ;
    void ADD_EQ     (unsigned int, unsigned int,const myBitPattern*) ;
    void ADD_EQ     (unsigned int, unsigned int,unsigned int,const myBitPattern*) ;
    void OR     (unsigned int, unsigned int, unsigned int) ;
       // realize for one bitpattern array  the operation a(i) = a(j) | a(k) 
    void OR_EQ  (unsigned int, unsigned int) ;
       // realize for one bitpattern array  the operation a(i) |= a(j)
    void OR_EQ  (unsigned int, const myBitPattern*, unsigned int) ;
       // realize for two bitpattern arrays the operation a(i) |= b(j)
    flag2 AND    (unsigned int, const myBitPattern*, unsigned int) ;
       // realize for two bitpattern arrays the operation a(i) & b(j)
       // return value is from type flag2
    flag2 AND    (unsigned int, unsigned int) ;
       // realize for one bitpattern array  the operation a(i) & a(j)
    void AND_EQ (unsigned int, unsigned int) ;
       // realize for one bitpattern array  the operation a(i) &= a(j)
    void EQUAL  (unsigned int, const myBitPattern*, unsigned int) ;
       // realize for two bitpattern arrays the operation a(i) = b(j)
    void EQUAL  (unsigned int, unsigned int) ;
       // realize for one bitpattern array  the operation a(i) = a(j)
    void setBit (unsigned int, unsigned int) ;
       // set one bit in the bitpattern array  
    flag2 readBit(unsigned int, unsigned int) const ;
       // read one bit in the bitpattern array
    void showBitPattern(unsigned int) const ;
       // show the structure of the bitpattern array under using "0" and "1"
} ;

#endif





