/*
   ----------------------------------------------------------------------------
   Author  : Uwe Geitner
   Hardware: IBM-compatible PC 386/40
   Software: g++-GNU-Compiler (v2.4) under Linux
   Date    : 13/07/95
   Content : - Implementation of the methods for class Liste:
               Liste::Liste(),
               Liste::~Liste(),
               Liste::addElement(int),
               Liste::remElement(int),
               Liste::getElememt(int),
               Liste::remListe(void),
   ----------------------------------------------------------------------------
*/

#define _LISTE_CPP

#include <iostream.h>
#include <stdio.h>
#include "liste.h"
#include "error.h"

Liste::Liste()
{
  num_elem = 0 ;
  first    = NULL ;
  actual   = NULL ;
  last     = NULL ;
}

Liste::~Liste()
{
  if (first != NULL)   remListe();
}

void Liste::addElement(int spa_nr)
{
  listelement*  neues ;
  neues = new listelement ;

  neues->succ = NULL ;
  neues->pred = NULL ;
  neues->nachbarspa = spa_nr ;

  if (num_elem == 0)
    {
      first = neues ;
      last  = neues ;
    }
  else
  {
    last ->succ = neues ;
    neues->pred = last ;
    last        = neues ;
  }
  num_elem++ ;
}
/*
int Liste::remElement(int spa_nr)
{
  if (num_elem != 0)
    {
      listelement*  help ;
      actual = first ;

      while ( (actual->nachbarspa != spa_nr) && (actual != last) )
        actual = actual->succ ;
      if (actual->nachbarspa == spa_nr)
        {
          if (actual == first)   first = actual->succ ;
          if (actual == last )
            {
              last  = actual->pred ;
              last->succ = NULL ;
            }
          else
          {
            help = (*actual).pred ;
            help->succ = actual->succ ;
            help = actual->succ ;
            help->pred = actual->pred ;
          }
          delete actual ;
          num_elem-- ;
          return 1 ;
        }
        else return 0 ;
    }
  else
  {
    cout << "Die Liste ist zur Zeit leer. \n" ;
    return 0 ;
  }
}
*/

int Liste::getElement(int index)
{
  if (index > num_elem)
  {
    error_report(11) ; 
    return  -1 ;
  }
  else
  {
    actual = first ;
    for (int i=0; i<index; i++)
      actual = actual->succ ;
  }
  return actual->nachbarspa ;
}

void Liste::remListe(void)
{
  while ( last != first )
  {
    actual = last->pred ;
    actual->succ = NULL ;
    delete last ;
    last = actual ;
  }
  if (first != NULL)  delete first ;

  num_elem = 0 ;
  first  = NULL ;
  actual = NULL ;
  last   = NULL ;
}

#undef _LISTE_CPP


