/*
   ----------------------------------------------------------------------------
   Author  : Uwe Geitner
   Hardware: IBM-compatible PC 386/40
   Software: g++-GNU-Compiler (v2.4) under Linux
   Date    : 13/07/95
   Content : - Definition of struct listelement and class Liste
   ----------------------------------------------------------------------------
*/

#ifndef _LISTE_H
#define _LISTE_H

#include <iostream.h>

struct listelement
{
  int          nachbarspa ;     // 
  listelement* succ ;           // pointer to the successor
  listelement* pred ;           // pointer to the predecessor
} ;

class Liste
{
  private :
    int            num_elem ;   // number of elements in the list
    listelement*   first ;      // pointer to the first element
    listelement*   actual ;     // pointer to the actual element
    listelement*   last ;       // pointer to the last element

  public :
    Liste() ;
    ~Liste() ;
    void addElement(int) ;     
         // adds a new element to the list, 
         // the value of the parameter defines the value nachbar_spa
    int  getElement(int i) ;      // return the i-th element of the list
    void remListe(void) ;         // removes the hole list
    inline int getNumbElem(void) const        { return num_elem ; } ;
    inline listelement* getActual(void) const { return actual ; } ;
    inline listelement* getFirst(void)  const { return first ; } ;
    inline listelement* getLast(void)   const { return last ; } ;
} ;


#endif


