/*
   ----------------------------------------------------------------------------
   Author  : Uwe Geitner
   Hardware: IBM-compatible PC 386/40
   Software: g++-GNU-Compiler (v2.4) under Linux
   Date    : 13/07/95
   Content : - Definition of class RowBitPattern, derived from the base
               class myBitPattern
   ----------------------------------------------------------------------------
*/

#ifndef _ROWBITP_H
#define _ROWBITP_H

#include "colBitPat.h"

class RowBitPattern : public myBitPattern
{
  private :
    int*  row_nnz ;    // array for the number of nonzeros (nnz/NNZ)

  public :
    RowBitPattern() ;
    RowBitPattern(unsigned int, unsigned int) ;
    ~RowBitPattern() ;
    inline void incNNZinRow(int row)        { row_nnz[row]++ ; } ;
    inline void decNNZinRow(int row)        { row_nnz[row]-- ; } ;
    inline int  getNNZinRow(int row) const  { return row_nnz[row] ; } ;
    ColBitPattern* row2col(void) ;
       // realize the step from a row orientate bitpattern to 
       // a column orientate bitpattern
    friend RowBitPattern* allocRowBP(unsigned int, unsigned int) ;
       // set the static variables (inherit from class myBitPattern) to 
       // the right size and allocate the dynamic memory
} ;

#endif




