/*
   ----------------------------------------------------------------------------
   Author  : Uwe Geitner
   Hardware: IBM-compatible PC 386/40
   Software: g++-GNU-Compiler (v2.4) under Linux
   Date    : 18/07/95
   Content : - Menue for the 3 Methods
             - Definition ot the Function F: R(n) --> R(n) ;
               Simplified form of the neutron kinetics problem by Carver
               and MacEwen ; see e.g. the paper "Software for estimating
               sparse jacobian matrices" by Coleman/Mor
             - Call to the corresponding Function 
   ----------------------------------------------------------------------------
*/

#include "adouble.h"
#include "adutils.h"
#include "createPat.h"
#include "MatLab.h"
#include <stream.h>

main() 
{
  int i, n ;                  // Size for jacobian matrix (nxn)                    
  n=5;
   double*  py = new  double[1] ;   // decleare dep. passive variable pointer
  adouble*   y = new adouble[1] ;   // decleare dep. active  variable pointer 
   double*  px = new  double[n] ;   // decleare ind. passive variable pointer
  adouble*   x = new adouble[n] ;   // decleare ind. active  variable pointer

  trace_on(1) ;                     // start tracing
  
  for(i=0; i<n; i++)
  {
    px[i] = i ;                     // values for passive variables
     x[i] <<= px[i] ;               // select independent variables
  }

  for (i=0; i<n; i++)
    y[0] = y[0]+x[i]*x[i] ;                 // select dependent variables

    y[0] >>= py[0] ;                 // select dependent variables

  trace_off() ;                     // complete tape on adoltape
  
  delete[] px ;
  delete[] py ;
  delete[]  x ;
  delete[]  y ;

  MatLab_output*   two_arrays4you ;
  two_arrays4you = createPatternH(1,1,n) ;

  cout << "Values of the first array \n\n" ;
  for (i=0; i<two_arrays4you->size_array_elem+1; i++)
    cout << "elem[" << i << "] :\t" << two_arrays4you->elem_cnt[i] << "\n" ;

  cout << "Values of the second array \n\n" ;
  for (i=0; i<two_arrays4you->size_array_row; i++)
    cout << "inedx_row[" << i << "] :\t" << two_arrays4you->row_indices[i] << "\n" ;

  destrMatLab(two_arrays4you) ;
}





