format long e
rand('uniform')
rand('seed',sum(100*clock));
ngrid = [ 0 0 0]';
%
% To create a structure of H based on a 3 - dimensional grid (unit cube)
% set ngrid(3) = m > 0. A m x m x m mesh will be used and so
% n = m^3. A 5-point difference scheme is used to define the structure
% of H. 
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 3-dimensional grid structure
%ngrid(3) = 5; n = ngrid(3)^3; fracnz = 6/n;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%
%
%
% To create a structure of H based on a 2 - dimensional grid (unit
% square) set ngrid(3) = 0 and ngrid(2) = m > 0
% and ngrid(1) = p = 5,7, or 9. A p-point difference scheme
% will be used on the m x m grid.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 2-dimensional grid structure
ngrid(2) = 10; n = ngrid(2)^2; ngrid(1) = 9; fracnz = ngrid(1)/n;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%
% To create a random structure with density = fracnz
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Random structure.
%n = 1000;
%n=2
%fracnz = 5/n;
%fracnz = .9;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
pctneg = 0.1; % pctneg is the percentage of negative e-values in H
condn = 0   %condition number of Hessian matrix is 10^condn%
lbonly = 0
tol=1d-12    %typically tol = 1d-12%
tol1 = 100*eps;
tol2 = 10^(-10);
tol3 = sqrt(eps);
itbound=50    %typically itbound = 50 %
pctbnd=0.2    %percentage of variables at their bounds at solution (approx.)%
degen = 0  %many nonzero components of y will have values 10^-degen or less%
degen2 =0%many free variables will be close to a bound: 10^-degen2 %
l = zeros(n,1);
pctinf = 0 %percentage of upper bounds set to inf%
w = rand(n,1);
%u=ones(n,1)*1000;
u = (10^3)*rand(n,1);
for i = 2:2:n
 u(i) = 1;
end
u = ones(n,1);
%xstart = (u+l)/2;
w = 1.3; %used for relax algorithm
A = [];
b = [];
%
%
  if pctneg == 0
    [H,c,u,soln,opt,xstart]=mgen(condn,n,pctbnd,degen,degen2,u,pctinf,lbonly,fracnz,ngrid);
   else
[H,c,u,soln,opt,xstart,dd]=indmgen(condn,n,pctbnd,degen,degen2,u,pctinf,lbonly,fracnz,pctneg,ngrid);
  end
%
%
vub = u;
vlb = zeros(n,1);
%HH = H;
cc=c;
newprime = 1; % if newprime = 1 then the new diagonal matrix in QPprimal1 is used.
justone = 0;
overide = 0;
%
typx = max(ones(n,1),floor(abs(soln)));
w =  floor(abs(log10(max(abs(soln),ones(n,1)))));
typx = (10*ones(n,1)).^w;
nbr = 20;

%
b=c;
usave = u; lsave = l;
    xstart(l > -inf) = xstart(l > -inf) - l(l > -inf);
    u(l > -inf) = u(l > -inf) - l(l > -inf);
    l(l > -inf) = zeros(length(l(l > -inf)),1);
    w = lsave; w(w==-inf) = zeros(length(w(w==-inf)));
    b = b+H*w;
%
%   SCALE
%
    ds = max(abs(typx),ones(n,1)); ds(u < inf) = u(u<inf);
    DS = sparse(1:n,1:n,ds); b = DS * b; H = DS*H*DS;
    u(u<inf) = ones(length(u(u<inf)),1);
    xstart = xstart./ds;

c=b;
save /usr/fsys/amma/a/yuying/matlab/nonlinear/Trust/QPs/qpdata H c l u xstart;
