function[it,valpha,ex,vtheta,vval,y,x,vpos,vdelta,vratio,cholerr,vdigits,sizez,TOTM,TOTLS,vyneg,vfnrm,vcross]=Sqpbox(b,H,tol,itbound,xstart,tol2,u,l,fracnz,justone,newprime,overide,typx,nbr)
%  
% A REFLECTIVE NEWTON METHOD, DESCRIBED IN COLEMAN AND LI [??], TO SOLVE
% THE BOX CONSTRAINED QUADRATIC PROGRAMMING PROBLEM:
%
%        min { q(x) = .5x'Hx + b'x :  l <= x <= u}. 
% WHERE H IS SYMMETRIC. H IS ASSUMED TO BE IN SPARSE FORMAT.
%  COMPONENTS OF l ARE EITHER FINITE OR EQUAL TO -inf. COMPONENTS OF
%  u ARE EITHER FINITE OR EQUAL TO +inf. A LOCAL MIN. IS SOUGHT.
%
    n = length(b); it = 1; TOTM = 0; TOTLS = 0; tsub = 2; opt = 1;
    dellow = 1.; delup = 10^3;
%
%   SHIFT
    usave = u; lsave = l;
    xstart(l > -inf) = xstart(l > -inf) - l(l > -inf);
    u(l > -inf) = u(l > -inf) - l(l > -inf);
    l(l > -inf) = zeros(length(l(l > -inf)),1);
    w = lsave; w(w==-inf) = zeros(length(w(w==-inf)));
    b = b+H*w;
%
%   SCALE
    ds = max(abs(typx),ones(n,1)); ds(u < inf) = u(u<inf);
    DS = sparse(1:n,1:n,ds); b = DS * b; H = DS*H*DS;
    u(u<inf) = ones(length(u(u<inf)),1);
    xstart = xstart./ds; 
%
%   INITIALIZATIONS
    digits = inf; ex = 0;
    v = zeros(n,1); dv = ones(n,1);
    p = symmmd(H); del = 10*eps;
    posdef = 0; 
    if overide == 0
       tol = 100*eps;
       tol2 = sqrt(eps);
    end
    x = xstart; y = x; sigma = ones(n,1); oval = inf;
    w = H*x; g = b + w; val = x'*((.5*w) + b); vval(it,1) = val;
%
%   MAIN LOOP: GENERATE FEAS. SEQ.  x(it) S.T. q(x(it)) IS DECREASING.
    while ex == 0,
      arg1 = (g < 0) & (u == 1); arg2 = (g >= 0) & (l == 0);
      arg3 = (g < 0) & (u == inf); arg4 = (g >=0) & (l == -inf);
      v(arg1) = x(arg1) - u(arg1); dv(arg1) = ones(length(arg1(arg1>0)),1);
      v(arg2) = x(arg2) - l(arg2); dv(arg2) = ones(length(arg2(arg2>0)),1);
      v(arg3)=-ones(length(arg3(arg3>0)),1); dv(arg3)=zeros(length(arg3(arg3>0)),1);
      v(arg4)=ones(length(arg4(arg4>0)),1); dv(arg4)=zeros(length(arg4(arg4>0)),1);
      Fnrm = norm(v.*g,1); 
      vfnrm(it,1) = Fnrm;

%     TEST FOR CONVERGENCE
      diff = abs(oval-val);
      if it > 1, digits = (prev_diff)/max(diff,eps); end
      vdigits(it,1) = digits; prev_diff = diff; oval = val;
      if diff < tol*(1+abs(oval))
        ex = 1
     elseif ( (overide == 0) & (diff < tol2*(1+abs(oval))) & (digits < 3.5))

        ex = 2
      elseif ((Fnrm < tol) & (posdef ==1))
        ex = 3
      end
%
      if ex == 0
%       DETERMINE M-MATRIX, RHS
        dd = abs(v); D = sparse(1:n,1:n,sqrt(dd).*sigma);
        M = D*H*D + sparse(1:n,1:n,abs(g).*dv);
        grad = D*g; vgrad(it,1) = norm(grad);
%
%       DETERMINE THE SEARCH DIRECTION (2-DIM. TRUST REGION).
        delta = max(dellow,norm(v)); delta = min(delta,delup); vdelta(it,1) = delta;
        TOT1 = flops;
          [s,posdef,Zsize,v1] = dirn2(M,D,p,grad,delta,tsub,opt);
        TOTM = TOTM + (flops-TOT1);
        vpos(it,1) = posdef; sizez(it,1) = Zsize;
%
%       DO A LINE SEARCH. UPDATE x,y,sigma.
        strg= s'*(sigma.*g); ox = x;  osig = sigma;
        vyneg(it,1) = 1;
        if posdef == 1,
           theta = Fnrm/(.99 + Fnrm);
        else
          necurve = v1'*M*v1
          vyneg(it,1) = necurve;
          ss = s/norm(s);
          necurve2 = ss'*M*ss 
           w = Fnrm - v1'*M*v1; theta = w/(.99 + w);
        end
        vtheta(it,1) = theta;
%       COMPUTE UNIT STEP
        TOT1 = flops; alpha_add = 0;
        alpha = 0;
        count = 14;
        [ox,osig,alpha_add,nstrg] = startls(s,H,b,strg,x,y,sigma,u,l,count,oval);
        strg = nstrg;
        if alpha_add == 0, nnbr = n; else, nnbr = nbr; end
        kcross = 0
        if (strg < 0) 
          [x,sigma,alpha,kcross,done] = approx_line(s,H,b,strg,theta,osig,ox,u,l,nnbr,posdef);
          KCROSS = kcross
        else
          x = ox; sigma = osig;
        end
          TOTLS = TOTLS + (flops - TOT1);
          vcross(it,1) = kcross;
          alpha = alpha + alpha_add;
          y = y + alpha*s; valpha(it,1) = alpha;
%
%         PERTURB x AND y ?
          [x,y] = perturb(x,y,sigma,u,l,del,it);
%
%         EVALUATE NEW FUNCTION VALUE, GRADIENT. 
          it = it + 1;
          w = H*x; g = w + b; val = x'*((.5*w) + b); vval(it,1) = val;
          changex(it,1) = norm(x-ox);
        end
      if it >= itbound, ex=4; end
      if strg >= 0, ex = 5; end
    end
%
%   RESCALE, UNSHIFT, AND EXIT.
    x = ds.*x;
    x(lsave > -inf) = x(lsave > -inf) + lsave(lsave > -inf);
% LAST LINE OF Sqpbox
