function[H,b,u,l,x,opt,xstart,ddiag] = indmgen(condn,n,pctbnd,degen,degen2,u,l,lbonly,fracnz,pctneg,ngrid)
%
% Generate indefinite QP, bx + 1/2xHx, subject to l <+ x <= u.
%   according to more & toraldo's method as describe in ye's paper
% If fracnz < 1 then generate a sparse problem
%
   log10=log(10);
   c=log10*condn/(n-1);
   	rcond = 1/(10^condn);
   ii = 0:1:n-1; ii = ii';
   d = c*ii;
   b=exp(d);
   maxb=max(b);
   ddiag = b/maxb;
   xd = rand(n,1);
   [xd,ind] = sort(xd);
   ddiag = ddiag(ind);
   r= rand(n,1); rsave = r;
     if pctneg > 0
        for i = 1:n
            if r(i) < pctneg
            ddiag(i) = - ddiag(i);
            end
        end
      end 
        if ngrid(3) > 0
           m = ngrid(3);
           H = grid3d(m);
        elseif ngrid(2) > 0
           m = ngrid(2);
           if ngrid(1) == 9
              H = grid9(m);
           elseif ngrid(1) == 7
              H = grid7(m);
           else
              H = grid5(m);
           end
        else
           H = sprandsym(n,fracnz,rcond,2);
        end
        H = eps*spones(H);
        H = H + sparse(1:n,1:n,ddiag);
       [I,J] = find(H);
      top = size(I);
      for k=1:top
         x = rand(2,1) -.5; x = x/norm(x);
         i = I(k); j = J(k);
         w = min(abs(ddiag(i)),abs(ddiag(j)));
         if w < abs(ddiag(i))
            w = sign(ddiag(j))*w;
         else
            w = sign(ddiag(i))*w;
          end
         H(i,j) = H(i,j) + w*x(1)*x(2); H(j,i) = H(i,j);
         H(i,i) = H(i,i) + w*x(1)*x(1);
         H(j,j) = H(j,j) + w*x(2)*x(2);
      end
   r = rand(n,1);
   w = rand(n,1);
   d=ones(n,1)./exp(degen*r*log10);
   e=ones(n,1)./exp(degen2*w*log10);
   t = ones(n,1)-2*rand(n,1);
   d=d.*t;
   d = d.*(u-l);
   r =rand(n,1);
   w = rand(n,1);
   ww = rand(n,1);
   na=pctbnd;
   x =ones(n,1)-2*rand(n,1);

   arg1 = (r <= na*ones(n,1)) & (d> 0);
   arg2 = (r <= na*ones(n,1)) & ( d<= 0);
   arg4 = (r > na*ones(n,1)) & (d > 0);
   arg5 = (r > na*ones(n,1)) & (d <= 0);
   arg7 = (r > na*ones(n,1));
   x(arg1) = l(arg1);
   x(arg2) = u(arg2);
   x(arg4) = l(arg4) +(u(arg4)-l(arg4)).*w(arg4).*e(arg4);
   x(arg5) = u(arg5) - (u(arg5)-l(arg5)).*w(arg5).*e(arg5);
   d(arg7) = zeros(length(arg7(arg7>0)),1);
   b=-H*x+d;
      DS = sparse(1:n,1:n,(u-l)/2);
   bb = DS*(H*(DS*ones(n,1))) + DS*(H*l) + DS*b;
   xx = -ones(n,1) + (2*ones(n,1)./(u-l)).*(x-l);
   y=-(DS*(H*(DS*xx))+bb);
   xxx = DS*xx;
   opt = .5*x'*H*x + b'*x;
   xstart = startx(u,l);
