function[H,b,u,l,x,opt,xstart] = mgen(condn,n,pctbnd,degen,degen2,u,l,pctinf,lbonly,fracnz,ngrid)
%
% Generate a sparse positve definite QP, bx + 1/2xHx, subject to l <+ x <= u.
% based on More & Toraldo's method.
%
   rcond = 1/(10^condn);
   log10=log(10);
   if ngrid(3) > 0
      m = ngrid(3);
      H = grid3d(m);
      H = sprandsym(H,1,rcond,3);
   elseif ngrid(2) > 0
      m = ngrid(2); 
      if ngrid(1) == 9
         H = grid9(m);
         H = sprandsym(H,1,rcond,3);
      elseif ngrid(1) == 7
         H = grid7(m);
         H = sprandsym(H,1,rcond,3);
      else
         H = grid5(m);
         H = sprandsym(H,1,rcond,3);
      end
    else 
      H = sprandsym(n,fracnz,rcond,2);
    end

   r = rand(n,1);
   w = rand(n,1);
   d=ones(n,1)./exp(degen*r*log10);
   e=ones(n,1)./exp(degen2*w*log10);
   t = ones(n,1)-2*rand(n,1);
   d=d.*t;
   d = d.*(u-l);
   r =rand(n,1);
   w = rand(n,1);
   na=pctbnd;
   x =ones(n,1)-2*rand(n,1);
   arg1 = (r <= na*ones(n,1)) & (d> 0);
   arg2 = (r <= na*ones(n,1)) & ( d<= 0);
   arg3 = (r <= na*ones(n,1)) & ( d<= 0) & (lbonly == 1);
   arg4 = (r > na*ones(n,1)) & (d > 0);
   arg5 = (r > na*ones(n,1)) & (d <= 0);
   arg6 = (r > na*ones(n,1)) & (d <= 0) & (lbonly == 1);
   arg7 = (r > na*ones(n,1));
%
   x(arg1) = l(arg1);
   x(arg2) = u(arg2);
   x(arg3) = l(arg3);
   x(arg4) = l(arg4) +(u(arg4)-l(arg4)).*w(arg4).*e(arg4);
   x(arg5) = u(arg5) - (u(arg5)-l(arg5)).*w(arg5).*e(arg5);
   x(arg6) = l(arg6) +(u(arg6)-l(arg6)).*w(arg6).*e(arg6); 
   d(arg3) = -d(arg3);
   d(arg7) = zeros(length(arg7(arg7>0)),1);
   b=-H*x+d;
   DS = sparse(1:n,1:n,(u-l)/2);
   bb = DS*(H*(DS*ones(n,1))) + DS*(H*l) + DS*b;
   xx = -ones(n,1) + (2*ones(n,1)./(u-l)).*(x-l);
   y=-(DS*(H*(DS*xx))+bb);
   xxx = DS*xx;
   opt = .5*x'*H*x + b'*x;
%
%  set some infinite bounds
   w = rand(n,1); ww = rand(n,1);
   arg1 = (w<pctinf*ones(n,1)) & (x < u);
   arg2 = (ww<pctinf*ones(n,1)) & (x > l);
   u(arg1) = inf*ones(length(arg1(arg1>0)),1);
   l(arg2) = -inf*ones(length(arg2(arg2>0)),1);
%
% set starting point
  xstart = startx(u,l);
