  function[c,xstart,u,l,ds,DS] = shiftscale(c,xstart,u,l,typx);
%
% SHIFT AND SCALE VECTORS u,l,xstart
% SO THAT THE FINITE VALUES OF u EQUAL UNITY,
% AND THE FINITE VALUES OF l EQUAL ZERO.
%
  n = length(c); ll = l; vshift = zeros(n,1);
  arg1 = (l== -inf) & (u == inf);
  arg2 = (l== -inf) & (u < inf); 
  arg3 = (l> -inf) & (u == inf);
  arg4 = (l > -inf) & (u < inf);
%
% SHIFT
  xstart(arg2) = xstart(arg2) + ones(length(arg2(arg2 > 0)),1) - u(arg2);
  vshift(arg2) = u(arg2) - ones(length(arg2(arg2 > 0)),1);
  u(arg2) = ones(length(arg2(arg2 > 0)),1);
%
  xstart(arg3) = xstart(arg3) - l(arg3);
  vshift(arg3) = l(arg3);
  l(arg3) = zeros(length(arg3(arg3 > 0)),1);
%
  xstart(arg4) = xstart(arg4) - l(arg4);
  vshift(arg4) = l(arg4);
  u(arg4) = u(arg4) - l(arg4);
  l(arg4) = zeros(length(arg4(arg4 > 0)),1);
%
  w = Hmult(vshift); c = c + w;
%
% SCALE
  ds = ones(n,1);
  ds(arg1) = max(abs(typx(arg1)),ds(arg1));
  ds(arg4) = abs(u(arg4));
  DS = sparse(1:n,1:n,ds); c = DS*c;
% u(arg4) = ones(length(arg4(arg4>0)),1);
  u = u./ds;
  xstart = xstart./ds;
%
% LAST LINE OF shiftscale

