function [s,val]=Reflect(indx,s,g,H,A,b,delta,theta)
%
%  starting from s following reflection path
%   min g's + 1/2 s'Hs
%    As <= b
%    ||s|| <= delta
%
n = length(s);

gr = H*s+g;
val0 = g'*s + 0.5*s'*H*s;
val=val0;
constr=A*s-b;

d=s; d(indx)=-d(indx);
ratio = d'*gr;
          
if (ratio >= 0|norm(s) >0.8*delta) return;end;

%compute stepsize to the constraints or the circle
active = find(constr >-1e-12);
alpha = -constr./full(A*d);
j=find(alpha<0); if (length(j) >0 ) alpha(j) = inf*ones(length(j),1); end;
alpha(active) = inf*ones(length(active),1);
[beta,indx] = min(alpha);

%
%   should the second term be s'd
%coef=[(norm(d))^2,2*sum(d),(norm(s))^2-delta^2];
coef=[(norm(d))^2,2*s'*d,(norm(s))^2-delta^2];
rts =roots(coef);
if(rts(1) <0 ) rts(1) = inf;end;
if(rts(2) <0 ) rts(2) = inf;end;
circle_alpha = min(rts);
opt_alpha = -gr'*d/(d'*H*d);
if opt_alpha <0 opt_alpha=inf;end;

if( circle_alpha < min(beta,opt_alpha) )
%   disp('stop at a point on the circle');
    beta=circle_alpha;
    constr = constr +beta*A*d;
    s=s+beta*d;
    val = g'*s + 0.5*s'*H*s;
else
    if( beta <= opt_alpha)
       s=s+beta*d;
       val=g'*s + 0.5*s'*H*s;
    else
       s=s+ opt_alpha*d;
       val=g'*s + 0.5*s'*H*s;
    end
end;
