function [ss,val,posdef,rho_c]=Solve2D(x,l,u,M,sqrtv,p,sgr,delta,tsize,theta);
%
%  two-dimensional
%
n = length(sqrtv);

[v1,posdef] = newtorneg(M,p,sgr);
%
% Newton step exists and is within the trust region 
%
[sc,val_sc,flag_sc]=Truncate(-sgr,sqrtv,sgr,M,l,u,x,delta,theta);

if posdef == 1 & norm(v1) <= delta
%  disp('Newton Step');
   [st,val]=Truncate(v1,sqrtv,sgr,M,l,u,x,delta,theta);
   rho_c = val/val_sc;
   if( rho_c > 0.1 ) ss=st; return; end;
end;
 
% solve the two dimensional trust region problem 
%
% if posdef ~= 1
%   [V,D]=eig(full(M));
%   [mineig,ii]=min(diag(D));
%   v1= V(:,ii);
% end;

Z=orth2(v1,sgr);

MM = full(Z'*M*Z);
rhs=full(Z'*sgr);

[s2,val]=trust(rhs,MM,delta);
ss= Z*s2;
   
%
% testing
posdef=1;
if posdef ~= 1
   R = dprecon(M);
   kmax = floor(n/2);
   tol = .05;   tol=0.0005;
%  [v1,s0,val0,posdef,pcgit] = pcgTR(R,M,sgr,kmax,tol,delta);
   [v1,s0,val0,posdef,pcgit] = pcgSub(R,M,sgr,kmax,tol,delta);
   if val0 < val
      ss = s0; val = val0;
   end;
end;

[st,val,flag]=Truncate(ss,sqrtv,sgr,M,l,u,x,delta,theta);

% relfection path
val_r =1;
if flag >0
   A=sparse([-speye(n);speye(n)]);
   b=[(theta*(l-x))./sqrtv;(theta*(u-x))./sqrtv];
   [sr,val_r]=Reflect(flag,st,sgr,M,A,b,delta,theta);
end;

%dogleg path
[sd,val_d]=Dogleg(st,val,sc,M,sgr);

if val_r < val_d
   val=val_r;
   ss = sr;
else
   val = val_d;
   ss = sd;
end;

rho_c = val/val_sc;

clear A
return

