function [sc,val,indx]=Truncate(ss,sqrtv,g,M,l,u,x,delta,theta);
%
% returns a truncated step satisfies the strict feasibility:
% flag = 1 means truncated due to feasibility
%
s = sqrtv.*ss; n =length(s);
indx=0; BR=inf*ones(n,1);

ii=find(abs(s)>0);
if length( ii ) > 0 
   BR(ii)=max((theta*(l(ii)-x(ii)))./(full(s(ii))),...
       (theta*(u(ii)-x(ii)))./(full(s(ii))));
end;

%BR = max(full(theta*(l-x))./(full(s)), full(theta*(u-x))./(full(s)));

ii=find(BR<0);
if (length(ii) > 0 )
   BR(ii) = inf*ones(length(ii),1);
end;

ii=find(s==0);
if (length(ii) > 0 )
    BR(ii) = inf*ones(length(ii),1);
end;

[beta,ii] = min(BR);

sTMs= ss'*M*ss;
gTs = g'*ss;
alpha_star = -gTs/sTMs; alpha_delta = delta/norm(ss);
if (alpha_star <0 )
    alpha_star = alpha_delta;
end;
if  alpha_star < min(beta,alpha_delta)
    alpha0 = alpha_star;
else
    if  beta < min(alpha_star,alpha_delta)
        alpha0=beta;
        indx=ii;
    else
        alpha0=alpha_delta;
    end
end
sc=alpha0*ss;
val= alpha0*gTs + 0.5*alpha0^2*sTMs;

if (val >= 0) val = val,keyboard;end;

return
