function [s,val]=ApprQPTrust(s,g,H,A,b,delta)
%
%  starting from s, attempts to find a local minimum or a point on the circle:
%   min g's + 1/2 s'Hs
%    As <= b
%    ||s|| <= delta
%
m = length(b);
n = length(s);

gr = H*s+g;
constr = A*s-b;
val0 = g'*s + 0.5*s'*H*s;
val=val0;
it = 0;

while it <= 10
%
%  compute a projected gradient direction
%
   it = it+1;
   old = val;
   val = g'*s + 0.5*s'*H*s;
   if( val > old ) disp('in ApprQP'); valold=[val,old], keyboard;end;
   u = zeros(m,1);
   if( ~isempty( constr > 0 ) ) disp('infeasible');end;
   active = find( constr > - 1e-10 );

   if length(active) >0 
      u(active) = A(active,:)'\gr;
      rgr = gr - A(active,:)'*u(active);
   else
      rgr = gr;
   end;

   if( norm(rgr) < 1e-10 )
       if( all(u(active) <= 0) )
           Z = diag(ones(n,1));
           if (length(active) >0 )
               Z=null(A(active,:));
           end;
           B=Z'*H*Z;
           [V,D] = eig(B);
           eigval = diag(D);
           [mineig,index]=min(eigval);

           if (mineig >= -eps) % disp('local minum 2');
               break;
           end;
           rgr = Z*V(:,index);
           if (gr'*rgr <0 ) rgr = - rgr; end;
       else 
           i = find( u(active) > 0 );
           e= zeros(length(active),1);
           ii=i(1);
           e(ii)=-1;
           rgr = A(active,:)\e;
       end;
   else
       Z = diag(ones(n,1));
       if (length(active) >0 )
           Z=null(A(active,:));
       end;
       B=Z'*H*Z;
       [V,D] = eig(B);
       eigval = diag(D);

       [mineig,index]=min(eigval);

       if mineig > 0
          rhs = Z'*gr;
          t = B\rhs;
          rgr = Z*t;
       else
          rgr = Z*V(:,index);
          if (gr'*rgr <0 ) rgr = - rgr; end;
       end;
  end;

  d=-rgr;
  ratio = d'*gr;
          
%compute stepsize to the constraints or the circle
   alpha = -constr./(A*d);
   j=find(alpha<0); if (length(j) >0 ) alpha(j) = inf*ones(length(j),1); end;
   alpha(active) = inf*ones(length(active),1);
   beta = min(alpha);

   coef=[(norm(d))^2,2*sum(d),(norm(s))^2-delta^2];
   rts =roots(coef);
   if(rts(1) <0 ) rts(1) = inf;end;
   if(rts(2) <0 ) rts(2) = inf;end;
   circle_alpha = min(rts);
   opt_alpha = -gr'*d/(d'*H*d);
   if opt_alpha <0 opt_alpha=inf;end;

   if( circle_alpha < min(beta,opt_alpha) )
       disp('stop at a point on the circle');
       beta=circle_alpha;
       constr = constr +beta*A*d;
       s=s+beta*d;
       gr = H*s+g;
       val = g'*s + 0.5*s'*H*s;
       break;
   else
       beta = min(beta,opt_alpha);
       s=s+beta*d;
       gr = H*s+g;
       constr = A*s-b;
   end;
end; % while
%val10=[val,val0];
if ( it >= 30 )disp('in ApprQP');keyboard;end;
