function [s,val] = ComputeStep(g,H,Z,delta,l,u)
%
% Approximately SOLVE THE Two-dimensional TRUST REGION PROBLEM:
%
%    min{g^Ts + 1/2 s^THs: ||s|| <= delta, l \leq Z s \leq u}
%
% THE FULL EIGEN-DECOMPOSITION IS COMPUTED. THE
%
% ON RETURN:
%
%
n = length(g); coeff(1:n,1) = zeros(n,1);

[V,D] = eig(H);
eigval = diag(D);
alpha = -V'*g;

%
% Handle the inequality constraints
%
%[s]=Feasible(g,H,Z,l,u,alpha,eigval,V);

%A=[-Z;Z];
%b=[-l;u];

%if( norm(s) < delta )
%   val = g'*s + (.5*s)'*(H*s);   
%   return;
%else
    [s,val]=BallTrust(g,H,delta,eigval,V,alpha);
%end;
