function [s]=Feasible(g,H,Z,l,u,alpha,eigval,V)
%
%  Compute the intersection of s(lambda) with the inequality constraints
%	l <= Zs <= u,     s in a two dimensional vector
%
n = length(l); z1=Z*V(:,1); z2=Z*V(:,2);
mineig = min(eigval);

coeff = zeros(n,3);
coeff(:,1) =l;
coeff(:,2) = eigval(1)*l+eigval(2)*l-alpha(1)*z1-alpha(2)*z2;
coeff(:,3) = eigval(1)*eigval(2)*l-eigval(2)*alpha(1)*z1-eigval(1)*alpha(2)*z2;

tl =(-mineig-1)*ones(2,n);
for i=1:n
    tmp = roots(coeff(i,:));
    tl(1:length(tmp),i) = tmp;
end;

i=1:n;
rl(i,1) = tl(1,i)';
rl(i+n,1) = tl(2,i)';
[ii]=find( rl < -mineig );
i=1:(2*n);
tt1 = (alpha(1)./(rl(i)+eigval(1))).^2+(alpha(2)./(rl(i)+eigval(2))).^2;
tt1(ii) = inf*ones(length(ii),1);
[rl0,il]=min(tt1);

coeff = zeros(n,3);
coeff(:,1) =u;
coeff(:,2) = eigval(1)*u+eigval(2)*u-alpha(1)*z1-alpha(2)*z2;
coeff(:,3) = eigval(1)*eigval(2)*u-eigval(2)*alpha(1)*z1-eigval(1)*alpha(2)*z2;

tu =(-mineig-1)*ones(2,n);
for i=1:n;
    tmp = roots(coeff(i,:));
    tu(1:length(tmp),i) = tmp;
end;

i=1:n;
ru(i,1) = tu(1,i)';
ru(i+n,1) = tu(2,i)';
[ii]=find( ru < -mineig );
i=1:(2*n);
tt2 = (alpha(1)./(ru(i)+eigval(1))).^2+(alpha(2)./(ru(i)+eigval(2))).^2;
tt2(ii) = inf*ones(length(ii),1);
[ru0,ju]=min(tt2);

if rl0 < ru0
   lambda = rl(il);
else
   lambda = ru(ju);
end;
  
if (lambda < -mineig) s = inf*ones(2,1); end;
if (lambda >= -mineig)
   s = alpha(1)/(lambda+eigval(1))*V(:,1)+alpha(2)/(lambda+eigval(2))*V(:,2);
end;
