function [sx,ssx,qval,gTs]=Sg_or_Trust(hatg,sqrtv,sx,ssx,x,l,u,g,B,delta,VGnorm)
%
%   choose a descent direction to be either scl2g or sx
%

n = length(x);
StepBack0 = 0; StepBack1=0;
scl2g = - sqrtv.*hatg; 

BR = max(full(l-x)./(full(scl2g)), full(u-x)./(full(scl2g)));
BR(BR<0) = inf*ones(length(BR(BR<0)),1);
beta = min(BR);

hatgTBhatg = hatg'*B*hatg;
gTscl2g = g'*scl2g;
alpha_star = -gTscl2g/hatgTBhatg; alpha_delta = delta/norm(hatg);
if (alpha_star <0 )
    alpha_star = alpha_delta;
end;
if  alpha_star < min(beta,alpha_delta)
   alpha0 = alpha_star;
else
   if  beta < min(alpha_star,alpha_delta)
       alpha0=beta;
       StepBack0=1;
   else
       alpha0=alpha_delta;
   end
end
qval0= alpha0*gTscl2g + 0.5*alpha0^2*hatgTBhatg

gTs = g'*sx;
sTBs = ssx'*B*ssx; 

BR = max(full(l-x)./(full(sx)), full(u-x)./(full(sx)));
BR(BR<0) = inf*ones(length(BR(BR<0)),1);
beta1 = min(BR);

alpha_star = - gTs/sTBs; alpha_delta = delta/norm(ssx);
if (alpha_star <0 )
    alpha_star = alpha_delta;
end;
if  alpha_star < min(beta,alpha_delta)
   alpha1 = alpha_star;
else
   if  beta1 < min(alpha_star,alpha_delta)
       alpha1= beta1;
       StepBack1=1;
   else
       alpha1=alpha_delta;
   end
end
qval1= alpha1*gTs +0.5*alpha1^2*sTBs


if qval1 <= 0.1*qval0
  disp('trust region step')
  if StepBack1 == 1
     alpha1= max(0.9,1-VGnorm)*alpha1;
  end;
   alpha1 = alpha1
   sx = alpha1*sx;
   ssx = alpha1*ssx;
   qval= alpha1*gTs +0.5*alpha1^2*sTBs
   gTs = alpha1*gTs;
else
  disp('scaled gradient step')
  if (StepBack0 == 1)
      alpha0= max(0.9,1-VGnorm)*alpha0;
  end;
  alpha0 = alpha0
  sx= alpha0*scl2g;
  ssx = -alpha0*hatg;
  qval= alpha0*gTscl2g + 0.5*alpha0^2*hatgTBhatg
  gTs =alpha0*gTscl2g;
end;

return
