function[s,ss,posdef,pcgit] = direct(H,D,DS,grad,delta,g,dv,method);
%
% DETERMINE THE SEARCH DIRECTION. IF method == 0 THEN
% A DIRECT (SPARSE) FACTORIZATION METHOD IS USED. OTHERWISE,
% AN ITERATIVE PROCEDURE IS FOLLOWED - IDENTIFIED BY
% method. 
%
% THE SEARCH DIRECTION IS s, psodef INDICATES IF NEGATIVE
% CURVATURE WAS DISCOVERED (posdef == 0 MEANS NEGATIVE CURVATURE
% WAS DISCOVERED. posdef == 1 OTHERWISE.) pcgit RECORDS THE NUMBER
% OF PRECONDITIONED CONJUGATE GRADIENT ITERATIONS WERE REQUIRED, WHEN
% CG WAS USED.
        n = length(grad); tsize = 0; pcgit = 0;
        DM = D*DS; DG = sparse(1:n,1:n,abs(g).*dv);
%
%       A DIRECT FACTORIZTION METHOD IS USED.
        if method == 0 
%[v1,posdef] = newtorneg(M,sqrtv,p,sgr);
            [v1,posdef] = newtorneg1(H,DM,DG,grad);
%
        else
 
%          A PRECONDITIONED CONJUGATE GRADIENT ROUTINE IS USED.
           R = precon(method,DM,DG);
           kmax = floor(n/2); tol = .05;
           [v1,posdef,pcgit] = pcg(R,DM,DG,grad,kmax,tol);
        end
        v1 = v1/norm(v1);
        if (posdef < 1)
             v2 = D*sign(grad);
             v2 = v2/norm(v2);
             v2 = v2 - v1*(v1'*v2);
             v2 = v2/norm(v2);
             Z(:,1) = v1; Z(:,2) = v2;
             Zsize = 2;
          else
             Z = zeros(n,2);
             Z = [v1,grad]; 
             v1 = v1/norm(v1); v2 = grad/norm(grad);
             Z(:,1) = v1; v2 = v2 - v1*(v1'*v2);
             nrmv2 = norm(v2);
             if nrmv2 > 0
                v2 = v2/nrmv2; Z(:,2) = v2; Zsize = 2;
             else
                Zsize = 1;
             end
        end
        W = DM*Z; WW = HmultLi(H,W); W = DM*WW;
        MM = Z'*W + Z'*DG*Z;
        rhs=full(Z'*grad);
        [ss,qpval,po,key,fcnt,lambda] = trust(rhs,MM,delta);
        ss = Z*ss;
        norms = norm(ss); 
        s = abs(diag(D)).*ss;
%
% LAST LINE OF direct
