function [A,c,a] = compA(sigma,r,q,T,M,N)
% compA  Sets up the finite difference matrix for implicit solution
%        A is a tridiagonal matrix.
%
%       Reference: John C Hull : Options, Futures and other derivatives, Chap 15.

dt = T/(M-1);
x = linspace(1,N-2,N-2); x=x(:);
sigma=sigma(2:N-1);

a= 0.5*(r-q)*dt*x-0.5*sigma.*sigma.*x.*x*dt;
b= 1+sigma.*sigma.*x.*x*dt+r*dt;
c= -0.5*(r-q)*dt*x-0.5*sigma.*sigma.*x.*x*dt;
A=spdiags([[a(2:N-2);0] b [0; c(1:N-3)]],-1:1,N-2,N-2);
