function [call,put] = blspricefdamsig(SO,X,r,T,sig,q,M,N)

% Set up default parameters if not provided 
if nargin < 6 q =[]; end
if nargin < 7 M =[]; end
if nargin < 8 N =[]; end
if isempty(q) q=0; end
if isempty(M) M=20; end
if isempty(N) N=20; end

N=length(sig);

functionofT=0;

call=[];
put=[];
if length(q)~=1 | length(X) ~=1 | length(r)~=1
	error('X, r, q must be scalars');
end

if length(T)==1
Tvec=linspace(0,T,M);
else
Tvec=T;
end

if length(SO)==1
Svec=linspace(0,2*SO,N);
else
if SO(1)~=0 error('The first element in stock space SO must be 0, SO(1)=0'); end
Svec=SO;
end
Svec=Svec(:);
Tvec=Tvec(:);


% The time step
dt = max(Tvec)/(M-1);


% COMPUTE the CALL value.
u=max(Svec-X,0);
count=0;

%        [A,c,a,A1,c1,a1]=compA(sig,r,q,max(Tvec),M,N);
        [A,c,a]=compA_implicit(sig,r,q,max(Tvec),M,N);
for i = dt : dt : max(max(Tvec))
        count=count+1;
        %if (functionofT) | (count==1)
	% Setup the finite-difference matrix for timestepping.
        %[A,c,a,A1,c1,a1]=compA(sig,r,q,max(max(Tvec)),M,N);
	%end
	u=timestepcallam_implicit(u,A,c,Svec,X,exp(-q*i));
end

if rem(N,2) ==0
        call=(u(N/2)+u(N/2+1))/2;
else
        call=u(N/2+1);
end

% COMPUTE the PUT value.


if nargout > 1
u=max(X-Svec,0);

count=0;
for i = dt : dt : max(max(Tvec))
        count=count+1;
        %if (functionofT) | (count==1)
	% Setup the finite-difference matrix for timestepping.
        %[A,c,a,A1,c1,a1]=compA(sig,r,q,max(max(Tvec)),M,N);
	%end
        u=timestepputam_implicit(u,A,a,Svec,X);
end
if rem(N,2) ==0
        put=(u(N/2)+u(N/2+1))/2;
else
        put=u(N/2+1);
end

end

