function call = optionblsprice(SO,X,r,T,sig,q,M,N)
% optionblsprice
%       Returns the European call option values(by considering sigma = sigma(S))
%
%               X -- the vector of strike prices
%               T -- the vector of final times
%		sig -- N-vector (independent)
%		M  --number iof timesteps
%		SO  -- current stock price
%

N=length(sig);
Tvec=linspace(0,max(T),M);Tvec=Tvec(:);
Svec=linspace(0,2*SO,N);Svec=Svec(:);
% The time step

dt = max(Tvec)/(M-1);

% Compute A once for all
[L,U]=optioncompA(sig,r,q,max(Tvec),M,N);

p=length(X);

u=max(repmat(Svec,1,p)-repmat(X',N,1),0);

for i = dt : dt : T(p)
	prevu=u;
	u=optiontimestepcallnew(u,L,U,(Svec(N)-Svec(N-1))*exp(-q*i),T,T(p)-i+dt,dt);
end

T1= ceil(T/dt)*dt;
w1=(T1-T)';
w2=dt-w1;

if rem(N,2)==0
call=(w2.*((u(N/2,:)+u(N/2+1,:))/2)+w1.*((prevu(N/2,:)+prevu(N/2+1,:))/2))./(w1+w2);
else
        call=(w2.*u((N+1)/2,:)+w1.*prevu((N+1)/2,:))./(w1+w2);
end

