function call = optionblsprice(SO,X,r,T,sig,q,M,N)
% optionblsprice
%       Returns the European call option values(by considering sigma = sigma(S))
%
%               X -- the vector of strike prices
%               T -- the vector of final times, sorted!!
%		sig -- N-vector (independent)
%		M  --number iof timesteps
%		SO  -- current stock price
%
N=size(sig,1);
M=size(sig,2);
Tvec=linspace(0,max(T),M);Tvec=Tvec(:);
Svec=linspace(0,2*SO,N);Svec=Svec(:);
% The time step
dt = max(Tvec)/(M-1);

p=length(X);

u=max(repmat(Svec,1,p)-repmat(X',N,1),0);

x = linspace(1,N-2,N-2)';
temp1=x.*x*dt;
temp2=(r-q)*dt*x;

for i = dt : dt : T(p)
	prevu=u;
        [a,b,c]=optioncompA2dnew(sig(:,round((T(p)-i+dt)/dt)),temp1,temp2,r*dt,N);
	u=optiontimestepcall2dnew(u,a,b,c,(Svec(N)-Svec(N-1))*exp(-q*i),T,T(p)-i+dt,dt);
end

T1= ceil(T/dt)*dt;
w1=(T1-T)';
w2=dt-w1;

if rem(N,2)==0

call=(w2.*((u(N/2,:)+u(N/2+1,:))/2)+w1.*((prevu(N/2,:)+prevu(N/2+1,:))/2))./(w1+w2);
else
        call=(w2.*u((N+1)/2,:)+w1.*prevu((N+1)/2,:))./(w1+w2);
end


