function [a,b,c] = compA(sigma,temp1,temp2,rdt,N)
% compA  Sets up the finite difference matrix for implicit solution
%        A is a tridiagonal matrix.
%
%       Reference: John C Hull : Options, Futures and other derivatives, Chap 15.

sigma=sigma(2:N-1);
temp1=sigma.*sigma.*temp1;
a= 0.5*(temp2-temp1);
b= 1+temp1+rdt;
c= -0.5*(temp1+temp2);
a=[a(2:N-2);-1;0];
b=[b;1];
c=[0; c(1:N-2)];
