echo on

%
% Example of european call option where sigma =sigma(S)
%


%Initialise
S0=100;
r=0.1;
q=0;

% Timesteps for PDE solution
numtimesteps=20;

% Two options with different maturity and strike price.
% These vectors should be sorted w.r.t. increasing maturity time

T=[1;0.32];
K=[100;80];

Extra.S0=S0;
Extra.r=r;
Extra.q=q;
Extra.numtimesteps=numtimesteps;
Extra.T=T;
Extra.K=K;

% Number of points in stock space, and define sigma as a vector in that space
n=20;

% The volatility vector sigma = sigma(S)
sigma=.2*ones(n,1);

% compute Jacobian of option values
[f,J]=optionJ(sigma,Extra);
J

% compute J*ones(n,1) of  option value
[f,JV]=optionJV(sigma,ones(n,1),Extra);
JV


