function y = optionfun(sigma,Extra)
% OPTIONFUN 
%       Returns the option values-observed values
%
%
%	sigma is a vector of size >= 5.
%	
%
N=length(sigma);
if N < 5 error('Sigma should be a big vector for a good discretized approximation'); end

S0=Extra.S0;
r=Extra.r; 
q=Extra.q; 
M=Extra.numtimesteps;
T=Extra.T;
K=Extra.K;

y=optionblsprice(S0,K,r,T,sigma,q,M);
