function y = optionfun(sigma,Extra)
% OPTIONFUN 
%       Returns the option values-observed values
%
%
%	sigma is a vector of size >= 5.
%	
%	Extra has the following format :
%		Extra(1) = S0
%		Extra(2) = r
%		Extra(3) = q
%		Extra(4) = M -- The number of timesteps from 0: max(T)
%		Extra(5:4+m) = T -- The vector of final times;
%		Extra(5+m:4+2*m) = K -- the vector of strike prices
%
N=length(sigma);
if N < 5 error('Sigma should be a big vector for a good discretized approximation'); end

S0=Extra(1); r=Extra(2); q=Extra(3); 
M=Extra(4);
num=(length(Extra)-4)/2;
T=Extra(5:4+num);
K=Extra(5+num:4+2*num);
y=optionblspriceam(S0,K,r,T,sigma,q,M);
