function u1 = timestep(u,A,dSdiv)
% TIMESTEP  computes one timestep of the implicit finite difference computation
%	 For european call options.
%
%       Reference: John C Hull : Options, Futures and other derivatives, Chap 15.


N=length(u);
u1=zeros(N,1);
q=[u(2:N-1);dSdiv];
u1(2:N)=A\q;
