function u1 = timestep(u,L,U,dSdiv,T,currT,dt)
% TIMESTEP  computes one timestep of the implicit finite difference computation
%	 For european call options.
%
%       Reference: John C Hull : Options, Futures and other derivatives, Chap 15.

N=size(u,1);
p=length(T);
u1=zeros(N,p);
index=find(T>currT-dt);
index=index(1);
q=[u(2:N-1,index:p);dSdiv*ones(1,p-index+1)];

u1(2:N,index:p)=U\(L\q);
if index > 1 u1(:,1:index-1)=u(:,1:index-1); end

