function sigma = quadrvol(c,s,t);
%
%  compute Jacobian (with respect to c) of sigma
%  sigma = c_0 + c_1 s + c_2 t + c_3 s t + c_4 s^2 + c_5 t^2 
%  given the discretization, this should be a constant matrix
%
%sigma = c(0) + c(1)*s + c(2)*t+ c(3)*(s.*t) + c(4)* s.^2 + c(5)*t.^2;

m = length(s);
J = zeros(m,5);
J=[ones(m,1), s, t, s.*t, s.^2, t.^2];
