function sigma = sigmay(y,x,S0,N)
%
% Constructs sigma as a function of S in the space -- linspace(0,2*S0,N);
%
% x, y are m-vectors defining the splines.
%
% MUST use  x(1) = 0,  x(m) = 2*S0
%

[a,b,c,d]=CubicSpline(x,y);
S=linspace(0,2*S0,N);
sigma=pwCEval(a,b,c,d,x,S);
sigma=sigma(:);
