function sigma = sigmay(y,x,S0,N)
%
% Constructs sigma as a function of S in the space -- linspace(0,2*S0,N);
%
% x, y are m-vectors defining the splines.
%
% MUST use  x(1) = 0,  x(m) = 2*0S
%

[a,b,c,d]=CubicSpline(x,y);
S=linspace(0,2*S0,N);
for j=1:N
i=find(S(j)<=x);
if (i(1)>1) i=i(1)-1; else i=i(1); end
sigma(j)=a(i) + b(i)*(S(j)-x(i)) + c(i)*(S(j)-x(i))^2 + d(i)*(S(j)-x(i))^2*(S(j)-x(i+1));
end
sigma=sigma(:);
