echo on
%
% Example of european call option where sigma =sigma(S)
%

%Initialise
global OBSERVED
S0=100;
r=0.05;
q=0.02;
C=15;

m=22;
T=[0.5*ones(m/2,1);ones(m/2,1)];
K=[(90:2:110)';(90:2:110)'];

N=31;                % number of stock steps
numtimesteps=11;      % number of time steps

Extra.S0=S0;
Extra.r=r;
Extra.q=q;
Extra.numtimesteps=numtimesteps;
Extra.T=T;
Extra.K=K;

S=linspace(0,200,N)';
sigma = zeros(N,1);
sigma(2:N) = C*(ones(N-1,1)./S(2:N));
OBSERVED = optionfun(sigma,Extra);
OBSERVED = OBSERVED';

numspline=m;
ystart=0.15*ones(numspline,1);
knots=linspace(0,200,numspline)';

Extra.S0=S0;
Extra.r=r;
Extra.q=q;
Extra.numtimesteps=numtimesteps;
Extra.T=T;
Extra.K=K;
Extra.N=N;
Extra.knotS=knots;

ystart=0.15*ones(numspline,1); tol = 0.5*10^(-3); itbound = 20;

l = zeros(numspline,1);
u = inf*ones(numspline,1);
time0 = cputime;
fun='funopt';
[y,it,gc,val]=Main(fun,tol,itbound,ystart,u,l,Extra)

[a,b,c,d]=CubicSpline(knots,y);
s = linspace(75,125);
Cvals = pwCEval(a,b,c,d,knots,s);
plot(s,Cvals,'g');
hold on

Evals = C*(ones(size(s))./s); 
plot(s,Evals,'r');
title 'Analytic VS computed volatility'
