function [u1,ind] = timestepput(u,A,c,S,X)
% TIMESTEP  computes one timestep of the implicit finite difference computation
%        For put options.
%
%       Reference: John C Hull : Options, Futures and other derivatives, Chap 15.


N=length(u);
u1=zeros(N,1);
u1(1)=X;
q=u(2:N-1);
q(1)=q(1)-c(1)*u1(1);
u1(2:N-1)=A\q;
ind=find(u1 > X-S );
ind=ind(1)-1;
u1=max(u1,X-S);
