function s= derivtape(a)
%
%
% DERIVTAPE  --  Construct DERIVTAPE Objects
%
%   S=derivtape(a) constructs the object S, of class derivtape from a.
%   If the input argument is a numerical scalar or matrix, the 
%   result is a deriv object having the same value.
%   Derivtape objects are constructed in preparation for the reverse 
%   mode of Automatic Differentiation, where we need to store the
%   intermediate values. These objects get assigned a unique
%   idenitifer number, in order to effectively store them on tape.
%
%   If input is a derivtape object, it is returned as it is.
%
%   Also see getval, getydot, deriv, derivspj, derivsph
%
global globp;
global tape;
global tapecounter;
global varcounter;
if nargin==0
    s.val=0;
    s.varcount=varcounter;
    s=class(s,'derivtape');
tape(tapecounter).op=0;
tape(tapecounter).val=s.val;
tape(tapecounter).varcount=s.varcount;
tape(tapecounter).arg1vc=0;
tape(tapecounter).arg2vc=0;
varcounter=varcounter+1;
tapecounter=tapecounter+1;
elseif isempty(a)
   s.val=[];
   s.varcount=varcounter;
  s=class(s,'derivtape');
tape(tapecounter).op=0;
tape(tapecounter).val=s.val;
tape(tapecounter).varcount=s.varcount;
tape(tapecounter).arg1vc=0;
tape(tapecounter).arg2vc=0;
varcounter=varcounter+1;
tapecounter=tapecounter+1;
elseif isa(a,'derivtape')
    s=a;
elseif isa(a,'derivtapeH')
    error('Cannot be derivtapeH variable');
else
   s.val=a;
   s.varcount=varcounter;
   s=class(s,'derivtape');
tape(tapecounter).op=0;
tape(tapecounter).val=s.val;
tape(tapecounter).varcount=s.varcount;
tape(tapecounter).arg1vc=0;
tape(tapecounter).arg2vc=0;
varcounter=varcounter+1;
tapecounter=tapecounter+1;
end
