function [argout1,argout2,argout3,argout4,argout5]= feval(fun,x,Extra,options)
global currfun
n=length(x);
if nargin < 4 
	options.JPI=[]; options.HPI=[]; options.func=[]; options.V=[]; options.W=[];
	options.EJPI=[]; options.EHPI=[]; options.fdata=[];
end
if nargin < 3 Extra=[];end

if isequal(currfun.fun,fun.fun) fun=currfun; end

if isequal(fun.n,n)
        if ~isempty(Extra)
                fun.Extra=Extra;
        elseif ~isempty(fun.Extra)
                Extra=fun.Extra;
        end
        if ~isempty(options.fdata)
                fun.fdata=options.fdata;
        end
end


if isempty(fun.class)

if isempty(options.func)
if fun.scalar ==0
% Jacobian problem
	if nargout == 1
		argout1=feval(fun.fun,x,Extra);
	else
		if n > 20	
		JPI=[];
		if length(x)~=1
        	if (isequal(fun.n,n) & ~isempty(fun.JPI))
			JPI=fun.JPI;
        	end
        	if isempty(JPI)
                	if ~isempty(options.JPI) JPI=options.JPI;
                	else
                		JPI=getJPI(fun.fun,[],n,Extra);
			end
                	fun.JPI=JPI;
        	end
		end
		[argout1,argout2]=evalJ(fun.fun,x,Extra,[],JPI);
		else
		[argout1,argout2]=forwprod(fun.fun,x,eye(n),Extra);
		end
	end

else
% Hessian Problem
	if nargout == 1
		argout1=feval(fun.fun,x,Extra);
	elseif nargout==2
		[argout1,argout2]=funcval(fun.fun,x,Extra);
	else
		if n <= 10
		[argout1,argout2]=funcval(fun.fun,x,Extra);
		argout3=HtimesV(fun.fun,x,eye(length(x)),Extra);
		else
		HPI=[];
		if ~isequal(length(x),1)
        	if (isequal(fun.n,n) & ~isempty(fun.HPI))
               		 HPI=fun.HPI;
        	end
        	if isempty(HPI)
                	if ~isempty(options.HPI) HPI=options.HPI;
                	else
                		HPI=getHPI(fun.fun,n,Extra);
                	end
                	fun.HPI=HPI;
        	end
		end
		[argout1,argout2,argout3]=evalH(fun.fun,x,Extra,HPI);
		end
	end

end
else
% User might want to do some other function -- e.g HV, JV, WJ, sparsity pattern

if isequal(options.func,'forwprod')
[argout1,argout2]=forwprod(fun.fun,x,options.V,[],Extra);
elseif isequal(options.func,'revprod')
[argout1,argout2]=revprod(fun.fun,x,options.W,Extra);
elseif isequal(options.func,'htimesv')
argout1=HtimesV(fun.fun,x,options.V,Extra);
elseif isequal(options.func,'jacsp')
argout1=jacsp(fun.fun,[],n,Extra);
else
%hesssp
argout1=hesssp(fun.fun,n,Extra);
end
end


else

%%%% Extended Functions

if isempty(options.func)
if fun.scalar ==0
% Jacobian problem
        if nargout == 1
                argout1=funcvalJExt(fun.class,fun.fun,x,fun.fdata);
        else
	        EJPI=[];
                if (isequal(fun.n,n) & ~isempty(fun.EJPI))
                        EJPI=fun.EJPI;
                end
                if isempty(EJPI)
                        if ~isempty(options.EJPI) EJPI=options.EJPI;
                        else
                                EJPI=GetExtJPI(fun.class,fun.fun,n,fun.fdata);
                        end
                        fun.EJPI=EJPI;
                end

        if nargout == 2
		[argout1,argout2]=evalJExt(fun.class,fun.fun,x,fun.fdata,EJPI);
        elseif nargout == 3
		[argout1,argout2,argout3]=evalJExt(fun.class,fun.fun,x,fun.fdata,EJPI);
        else
		[argout1,argout2,argout3,argout4]=evalJExt(fun.class,fun.fun,x,fun.fdata,EJPI);
        end
	end

else
% Hessian Problem
        if nargout == 1
                argout1=funcvalExt(fun.class,fun.fun,x,fun.fdata);
        else
                        EHPI=[];
                if (isequal(fun.n,n) & ~isempty(fun.EHPI))
                        EHPI=fun.EHPI;
                end
                if isempty(EHPI)
                        if ~isempty(options.EHPI) EHPI=options.EHPI;
                        else
                                EHPI=GetExtHPI(fun.class,fun.fun,n,fun.fdata);
                        end
                        fun.EHPI=EHPI;
                end
	if nargout == 2
                [argout1,argout2]=evalHExt(fun.class,fun.fun,x,fun.fdata,EHPI);
        elseif nargout == 3
                [argout1,argout2,argout3]=evalHExt(fun.class,fun.fun,x,fun.fdata,EHPI);
        elseif nargout == 4
                [argout1,argout2,argout3,argout4]=evalHExt(fun.class,fun.fun,x,fun.fdata,EHPI);
        else
                [argout1,argout2,argout3,argout4,argout5]=evalHExt(fun.class,fun.fun,x,fun.fdata,EHPI);
        end

	end
end

else

if isequal(options.func,'forwprod')
[argout1,argout2]=ExtJV(fun.class,fun.fun,x,options.V,fun.fdata);
elseif isequal(options.func,'revprod')
[argout1,argout2]=ExtWJ(fun.class,fun.fun,x,options.W,fun.fdata);
elseif isequal(options.func,'htimesv')
[argout1,argout2]=ExtHV(fun.class,fun.fun,x,options.V,fun.fdata);
else isequal(options.func,'vhtimesv')
[argout1,argout2]=ExtVHV(fun.class,fun.fun,x,options.V,fun.fdata);
end

end


end



fun.n=n;
currfun=fun;
