function sout=mldivide(s1,s2)
%function sout=mldivide(denominator,numerator)
global globp;
%This is equivalent to "s2/s1" if both are scalars
%reviewed by CLV, sept 2004
sout.val=getval(s1)\getval(s2);%equivalent to "s2/s1"
if ~isempty(sout.val)
    if ~isa(s1,'deriv') %if denominator s1 is NOT of class 'deriv' (i.e., it is a constant)
        [m,n]=size(s2.val);
        if (n==1) %is a vector
            sout.deriv=s1\s2.deriv;
        else
            for i=1:globp
                sout.deriv(:,:,i)=s1\s2.deriv(:,:,i);
            end
        end
        
    elseif ~isa(s2,'deriv') %if numerator s2 is NOT of class 'deriv' (i.e., it is a constant)
        [m,n]=size(s1);
        if (n==1)|(m==1)|(globp==1)
            sout.deriv=s1.val\(-s1.deriv*sout.val); %equivalent to (1/s1)*(-s1')*(s2/s1)
        else
            for i=1:globp
                sout.deriv(:,i)=s1.val\(-s1.deriv(:,:,i)*sout.val);%equivalent to (1/s1)*(-s1')*(s2/s1)
            end
        end
        
    else
        %Both are of class 'deriv'
        %Analize the numerator
        [m,n]=size(s2.val);
        if (n==1) %scalar numerator, of class 'deriv'
            if globp==1 %deriving against scalar variable ; n=1 and globp=1
                sout.deriv=s1.val\(s2.deriv-s1.deriv*sout.val);%equivalent to (1/s1)*[s2'-s1'*(s2/s1)]
            else
                %clv start
                %Original code follows -------
                %                 for i=1:globp
                %                     sout.deriv(:,i)=s1.val\(s2.deriv(:,i)-s1.deriv(:,:,i)*sout.val);
                %                 end
                %Up to here--------------------
                
                %There are more components to specify
                for i=1:globp
                    sout.deriv(:,i)=s1.val\(s2.deriv(:,i)-s1.deriv(:,:,i)*sout.val);
                end
                
            end
        else
            %n>1; vector or matrix numerator, of class 'deriv'
            if m==1  %column vector numerator, of class 'deriv'
                for i=1:globp
                    sout.deriv(:,i)=s1.val\(s2.deriv(:,i)'-s1.deriv(:,i)*sout.val);
                end
            else
                %Vector or matrix numerator, of class 'deriv'
                for i=1:globp
                    sout.deriv(:,:,i)=s1.val\(s2.deriv(:,:,i)-s1.deriv(:,:,i)*sout.val);
                end
            end
        end
        
    end
    %Recover original class
    sout=class(sout,'deriv');
else
    sout=[];
end
