%-----------------------------------------------------------------------
%
%  Kreiselbeispiel, Hauptprogramm
%
%-----------------------------------------------------------------------

%-----------------------------------------------------------------------
%  Auswahl der Parametervariante
disp('Programm kreisel ...');
pNr = input('Parametervariante? [1/2/3] : ');
switch pNr
  case 1
    p = [ 600.0, 700.0, 0.2, 6.0, 9810.0, 15.0, 180.0, 0.0, 0.01];
    ausgabename = 'kreisel.1.dat';
  case 2
    p = [ 800.0, 700.0, 0.2, 6.0, 9810.0, 15.0, 180.0, 0.0, 0.01];
    ausgabename = 'kreisel.2.dat';
  case 3
    p = [1000.0, 700.0, 0.2, 6.0, 9810.0, 15.0, 180.0, 0.0, 0.01];
    ausgabename = 'kreisel.3.dat';
  otherwise
    error('ABBRUCH wegen fehlerhafter Eingabe!');
end

%-----------------------------------------------------------------------
%  Oeffnen der Ausgabedatei
ausgabe = fopen(ausgabename,'w');    

%-----------------------------------------------------------------------
%  Berechnung an verschiedenen Argumenten mit Ausgabe
disp('         theta        kreisel_fun ');
disp('------------------------------');
for i = 0:200
  % Auslenkungswinkel
  th = i*pi/100.0;
  % kreisel_fun
  Extra.p=p;
  e = kreisel_fun(th,Extra);
  % Ausgabe 
  fprintf(' %14.6e %14.6e\n',th,e);
  fprintf(ausgabe,' %14.6e %14.6e\n',th,e);
end

%-----------------------------------------------------------------------
%  Oeffnen der Ausgabedatei
fclose(ausgabe);    


disp('         theta        kreisel_fun   sensitivity');
disp('--------------------------------------------');
for i = 1:200
  % Auslenkungswinkel
  %thi=pi/100;
  th = i*pi/100.0;
  % kreisel_fun
    Extra.p=p;  
    [e,JV] = forwprod('kreisel_fun',th,ones(length(th)),[],Extra);
    %JV1=(feval('kreisel_fun',th+thi,Extra)-feval('kreisel_fun',th-thi,Extra))/2/thi;
  % Ausgabe 
  fprintf(' %14.6e %14.6e %14.6e\n',th,e,JV);

end

% Exercise for later
% [e,J] = evalJ('kreisel_fun',p,th);













