%-----------------------------------------------------------------------
%
% Kreiselbeispiel, Energiefunktion
%
%-----------------------------------------------------------------------

function e = energie(th,Extra)
%-----------------------------------------------------------------------
%   th  Auslenkungswinkel theta
%   p   Parametervektor bestehend aus
%        p(1) = I     Traegheitsmoment
%        p(2) = I3    ...
%        p(3) = eps   Exzentrizitaet
%        p(4) = m     Masse
%        p(5) = g     Schwerkraft
%        p(6) = r     Radius
%        p(7) = psp0  Anfangsgeschwindigkeiten psi_0'
%        p(8) = php0  ...                      phi_0'
%        p(9) = th0   Anfangsauslenkung theta_0(Stoerung)
p=Extra.p;
  k =   p(1).*p(8).*sin(p(9)).*sin(p(9)) ...
      + p(2).*(p(7)+p(8).*cos(p(9))).*(cos(p(9))-p(3));
  n = p(1).*sin(th).*sin(th) + p(2).*(cos(th)-p(3)).*(cos(th)-p(3));
  e = k.*k./(2.0.*n) + p(4).*p(5).*p(6)*(1.0-p(3).*cos(th));
%-----------------------------------------------------------------------
