%-----------------------------------------------------------------------
%
%  Kreiselbeispiel, Hauptprogramm
%
%-----------------------------------------------------------------------

%-----------------------------------------------------------------------
%  Auswahl der Parametervariante
disp('Programm kreisel ...');
pNr = input('Parametervariante? [1/2/3] : ');
switch pNr
  case 1
    p = [ 600.0, 700.0, 0.2, 6.0, 9810.0, 15.0, 180.0, 0.0, 0.1];
    ausgabename = 'kreisel.1.dat';
  case 2
    p = [ 800.0, 700.0, 0.2, 6.0, 9810.0, 15.0, 180.0, 0.0, 0.1];
    ausgabename = 'kreisel.2.dat';
  case 3
    p = [1000.0, 700.0, 0.2, 6.0, 9810.0, 15.0, 180.0, 0.0, 0.1];
    ausgabename = 'kreisel.3.dat';
  otherwise
    error('ABBRUCH wegen fehlerhafter Eingabe!');
end

%-----------------------------------------------------------------------
%  Oeffnen der Ausgabedatei
ausgabe = fopen(ausgabename,'w');    

%-----------------------------------------------------------------------
%  Berechnung an verschiedenen Argumenten mit Ausgabe
disp('         theta        energie ');
disp('------------------------------');
for i = 0:200
  % Auslenkungswinkel
  th = i*pi/100.0;
  % Energie
    Extra.p=p;
  e = kreisel_fun(th,Extra);
  % Ausgabe 
  fprintf(' %14.6e %14.6e\n',th,e);
  fprintf(ausgabe,' %14.6e %14.6e\n',th,e);
end

%-----------------------------------------------------------------------
%  Oeffnen der Ausgabedatei
fclose(ausgabe);    


disp('         theta        energie    reverse sensitivity ');
disp('--------------------------------------------');
for i = 0:200
  % Auslenkungswinkel
  th = i*pi/100.0;
  % Energie
    Extra.p=p;
  [e,WJ] = revprod('kreisel_fun',th,1,Extra);
  
  % execute following statement to see the space required
  % spacerequired
  
  
  % Ausgabe 
  fprintf(' %14.6e %14.6e %14.6e\n',th,e,JV);

end

% % sparse Jacobian computation - later
% [e,J] = evalJ('kreisel_fun',p,Extra);













