function z = chris1(x,extra)

% The evaluation of this function depends on integrating a
% function.  The input x provides the interval of integration:

%                     /\ x(2)
%                    |
%  chris1(x)   =     |  t dt  
%                    |
%                   \/ x(1)
%

% This script calls the function identity.m, which is the
% function f(t) = t

choice = 1;

if choice == 1

% Method 1: Set up as an equivalent ODE and integrate:

%     ds
%    ---- = t
%     dt

disp('ode routine')
[t,s] = ode23('identity',[x(1) x(2)],0);
z = s(length(s));

% evalJ cannot compute J for this



else

% Method 2:  Quadrature

disp('quadrature')
z = quad('identity',x(1),x(2));

end

% evalJ does compute J correctly here

