function [ierrr]=derivcalc();
% Matlab function that tests and times calculation of 
% jacobian and Hessian of generalised Rosenbrock function
% f(x) = sum_{i=1,n} 10(x(i+1)-x(i)^2)^2+(x(i)-1)^2
%

disp('DERIVCAL')
disp('========')
disp(' ')
disp('Tests and times calculation of jacobian and Hessian')
disp('of generalised Rosenbrock function')
disp('f(x) = sum_{i=1,n} 10(x(i+1)-x(i)^2)^2+(x(i)-1)^2')

disp('Hit any key to continue')
pause
clc

% check ADMAT
global ADhess
ADMAT=getenv('ADMAT');
if isempty(ADMAT) | isempty(ADhess)
  disp('Practical needs ADMAT properly initialised')
  disp('From a terminal window (not Matlab) type')
  disp(' ')
  disp('setenv ADMAT /home/forth/SOFTWARE/ADMAT')
  disp(' ')
  disp('If you have a matlab startup file')
  disp(' ')
  disp('~/matlab/startup.m')
  disp(' ')
  disp('then append the contents of  ')
  disp(' ')
  disp('/home/forth/matlab/startup.m')
  disp(' ')
  disp('to your startup file.')
  disp('If you do not have a startup file then copy ')
  disp(' ')
  disp('/home/forth/matlab/startup.m')
  disp(' ')
  disp('to')
  disp(' ')
  disp('~/matlab/startup.m')
  disp(' ')
  disp('then restart this practical')
  disp('Hit any key to continue')
  exit
end

% get data
n=-1;
while n~=0
  disp(' ')
  disp(' ')
  disp('For generalised Rosenbrock function')
  disp(' ')
  disp('f(x) = sum_{i=1,n} 10(x(i+1)-x(i)^2)^2+(x(i)-1)^2')
  disp(' ')
  temp=input(['Enter dimension n > 0 of system [',int2str(n),'] 0 to exit '])
  if ~isempty(temp)
         n=temp;
  end
  if n<0
         disp('n must be > 0')
  elseif n>0
         % main menu loop
         x=0.5*ones(n,1);
         fexact=[];
         gexact=[];
         hexact=[];
         imenu=-1;
         clc
         while imenu~=0
                disp(' Main menu')
                disp('1 calculate exact derivatives')
                disp('2 calculate gradient using finite-differences')
                disp('3 calculate Hessian using finite-differences')
                disp('4 calculate gradient using Forward AD')
                disp('5 calculate gradient using Reverse AD')
                disp('0 exit')
                imenu=[];
                while isempty(imenu)
                  imenu=input('Enter menu option ');
                end
                if imenu==1
                  [fexact,gexact,hexact]=exactderivs(x)
                elseif imenu==2
                  % obtain analytic gradient for comparison
                  if isempty(gexact)
                         [fexact,gexact,hexact]=exactderivs(x)
                  end
                  gradfd=fdgrad(x)
                  gradfderr=norm(gradfd-gexact,inf)
                elseif imenu==3
                  % obtain analytic Hessian for comparison
                  if isempty(hexact)
                         [fexact,gexact,hexact]=exactderivs(x)
                  end
                  hessfd=fdhess(x)
                  hessfderr=norm(hessfd-hexact,inf)
                elseif imenu==4
                  % obtain analytic gradient for comparison
                  if isempty(gexact)
                         [fexact,gexact,hexact]=exactderivs(x)
                  end
                  gradfad=fadgrad(x)
                  gradfaderr=norm(gradfad-gexact,inf)
                elseif imenu==5
                  % obtain analytic gradient for comparison
                  if isempty(gexact)
                         [fexact,gexact,hexact]=exactderivs(x)
                  end
                  gradrad=radgrad(x)
                  gradraderr=norm(gradrad-gexact,inf)
                end
         end
         
  end
end

