function [gfd]=fdgrad(x)
% calculates gradient by finite differences
n=size(x,1);
sqrteps=sqrt(eps); % square root of machine relative precision
f0=rosenfunc(x);
for j=1:n
  h=sqrteps*max(abs(x(j)),1);
  x(j)=x(j)+h;
  gfd(j)=(rosenfunc(x)-f0)./h;
  x(j)=x(j)-h;
end

