function [hfd]=fdhess(x)
% calculates hessian by finite differences
n=size(x,1);
curteps=eps^(1/3); % cube root of machine relative precision
f0=rosenfunc(x);
for j=1:n
  hj=curteps*max(abs(x(j)),1);
  x(j)=x(j)+hj;
  fj=rosenfunc(x);
  x(j)=x(j)-hj;
  for k=1:j
         hk=curteps*max(abs(x(k)),1);
         x(k)=x(k)+hk;
         fk=rosenfunc(x);
         x(j)=x(j)+hj;
         fjk=rosenfunc(x);
         hfd(j,k)=(fjk-fj-fk+f0)/(hj*hk);
         x(j)=x(j)-hj;
         x(k)=x(k)-hk;
  end
end
% add in other entries
for j=1:n
  for k=1:j
         hfd(k,j)=hfd(j,k);
  end
end

