function [res]=flux(q,ewt)
% matlab function to calculate Euler flux
%
%      set gas parameters
%      ------------------
       gam  = 1.4;
       gm1i = 1/(gam-1);
       gg   = gam*gm1i;

%
%      get face area and normal
%      ------------------------
       nx = ewt(1);
       ny = ewt(2);
       nz = ewt(3);
       aa = sqrt(nx.^2 + ny.^2 + nz.^2);
       nx = nx ./ aa;
       ny = ny ./ aa;
       nz = nz ./ aa;
%
%      set variables
%      -------------
       r  = q(1);
       u  = q(2);
       v  = q(3);
       w  = q(4);
       p  = q(5);
%
       un  = u*nx + v*ny + w*nz;
       run = r*un;
       qq  = 0.5*(u.^2+v.^2+w.^2);
%
       res(1,1) = aa*( run              );
       res(2,1) = aa*( run*u  +    p*nx );
       res(3,1) = aa*( run*v  +    p*ny );
       res(4,1) = aa*( run*w  +    p*nz );
       res(5,1) = aa*( run*qq + gg*p*un );
