function [f]=rosenfunc(x)
% generalised rosenbrock's function for column vector x
global tape
global varcounter
n=size(x,1);
f=0;
for j=1:n-1
  f=f+(10.*(x(j+1)-x(j).^2)).^2+(x(j)-1).^2;
end

function [g]=rosengrad(x)
% gradient of generalised rosenbrock's function for column vector x
n=size(x,1);
j=1;
g(j)=-400.*(x(j+1)-x(j).^2).*x(j)+2.*(x(j)-1);
for j=2:n-1
  g(j)=-400.*(x(j+1)-x(j).^2).*x(j)+2.*(x(j)-1)+200*(x(j)-x(j-1).^2);
end
j=n;
g(j)=200.*(x(j)-x(j-1)^2);

function [h]=rosenhess(x)
% hessian of generalised rosenbrock's function for column vector x
n=size(x,1);
h=zeros([n n]);
j=1;
h(1,1)=-400.*(x(j+1)-3*x(j).^2)+2;
h(1,2)=-400.*x(j);
for j=2:n-1
  h(j,j)=-400.*(x(j+1)-3*x(j).^2)+2+200;
  h(j,j-1)=-400*x(j-1);
  h(j,j+1)=-400.*x(j);
end
j=n;
h(j,j)=200;
h(j,j-1)=-400.*x(j-1);


