function miou = Rsolver(nbp,z,m,zi,Phiinfi);

% Airfoil matrix

     X1=m(:,1)*ones(1,nbp);
     X2=m(:,2)*ones(1,nbp);
     A1 = ones(nbp,1)*z(2:nbp+1,1)' - X1;
     B1 = ones(nbp,1)*z(1:nbp,1)' - X1;
     A2 = ones(nbp,1)*z(2:nbp+1,2)' - X2;
     B2 = ones(nbp,1)*z(1:nbp,2)' - X2;


     nAtnB = sqrt((A1.^2+A2.^2).*(B1.^2+B2.^2));

     ps = A1.*B2-A2.*B1;

     cosbeta = (A1.*B1+A2.*B2)./(nAtnB);

         Ckf = -sign(ps)./(2.*pi).*acos(cosbeta);
for i=1:nbp Ckf(i,i)=0.5; end	

% Wake contribution

  A1 = z(1,1) - m(:,1);
  B1 = zi(1,1) - m(:,1);
  A2 = z(1,2) - m(:,2);
  B2 = zi(1,2) - m(:,2);
  
  ps = A1.*B2 - A2.*B1;

  nAtnB = sqrt((A1.^2+A2.^2).*(B1.^2+B2.^2));

  cosbeta = (A1.*B1+A2.*B2)./(nAtnB);

  Ckf(:,nbp+1) = -sign(ps)./(2.*pi).*acos(cosbeta);


% Substitution of the kutta condition 

Ckf2 = Ckf(:,1:nbp);
Ckf2(:,nbp) =Ckf(:,nbp) - Ckf(:,nbp+1);
Ckf2(:,1) =  Ckf(:,1)+Ckf(:,nbp+1);

% Computation of the solution

miou = Ckf2\Phiinfi;

