function miou = Rsolver(nbp,z,m,zi,Phiinfi);

% Airfoil matrix
for ii = 1:nbp
   for jj= 1:nbp

     A = z(jj+1,:) - m(ii,:);
     B = z(jj,:) - m(ii,:);

     nAtnB = sqrt((A(1).^2+A(2).^2).*(B(1).^2+B(2).^2));

     ps = A(1).*B(2)-A(2).*B(1);

     cosbeta = (A(1).*B(1)+A(2).*B(2))./(nAtnB);

     if ii~=jj
         Ckf(ii,jj) = -sign(ps)./(2.*pi).*acos(cosbeta);
     else
         Ckf(ii,jj) = cosbeta - cosbeta +0.5;
     end;

   end
end

% Wake contribution

for ii = 1:nbp

  A = z(1,:) - m(ii,:);
  B = zi(1,:) - m(ii,:);
  
  ps = A(1)*B(2) - A(2)*B(1);

  nAtnB = sqrt((A(1).^2+A(2).^2).*(B(1).^2+B(2).^2));

  cosbeta = (A(1).*B(1)+A(2).*B(2))./(nAtnB);

  Ckf(ii,nbp+1) = -sign(ps)./(2.*pi).*acos(cosbeta);

end;

% Substitution of the kutta condition 

Ckf2 = Ckf(:,1:nbp);
Ckf2(:,nbp) =Ckf(:,nbp) - Ckf(:,nbp+1);
Ckf2(:,1) =  Ckf(:,1)+Ckf(:,nbp+1);

% Computation of the solution

miou = Ckf2\Phiinfi;

