function z  = zshape(x,Extra);

% Decoding arguments
eps = x(1)./100;
p = x(2)./10;
to = x(3)./100;
nbpo2 = Extra(1);
c = Extra(2);

% x distribution   
beta = (0:(pi./nbpo2):pi).'; 
xc = c.*(1-.5.*(1-cos(beta)));   
    
% Thickness distribution = f(x)
thdis=5.*to.*c.*(0.2969.*sqrt(xc./c)-0.126.*xc./c-0.3537.*(xc./c).^2 +0.2843.*(xc./c).^3-0.1015.*(xc./c).^4);

% Camberline = f(x)
if p~=0 & eps~=0 
   for ii=1:nbpo2+1
       if xc(ii)<=p.*c  
          camberline(ii,1) = (eps.*xc(ii))./(p.^2).*(2.*p-xc(ii)./c);
       elseif xc(ii)>p.*c 
          camberline(ii,1) = (eps.*(c-xc(ii)))./(1-p).^2.*(1+xc(ii)./c-2.*p);
       end;
   end; 
end;

% Airfoil = camberline and thickness
if p==0 | eps==0
    xupper =  xc;
    yupper =  thdis;
    xlower =  xc;
    ylower = -thdis;
else
    for ii = 1:nbpo2+1      
      if xc(ii)<=p.*c
         theta(ii,1) = atan(2.*eps./p.*(-xc(ii)./(c.*p)+1));
      elseif xc(ii)>p.*c 
         theta(ii,1) = atan(2.*eps./(1-p.^2).*(p-(xc(ii)./c)));
      end;
    end;

    xupper = xc         - thdis.*sin(theta);
    yupper = camberline + thdis.*cos(theta);
    xlower = xc         + thdis.*sin(theta);
    ylower = camberline - thdis.*cos(theta); 

end;
    
z = [xupper yupper ; xlower(nbpo2:-1:1,1) ylower(nbpo2:-1:1,1)];

