function [f,JV] = forwprod(fun,x,V,m,Extra)
%
%forwprod
%
%	Computes forward mode product J*V using ADOLC 
%
%       The user's function is identified by a unique identifier
%       fun. See ADMIT users manual for detail.
%
%       [f,JV]=forwprod(fun,x,V) computes J*V at point x.
%
%       Please refer to ADMIT users manual for complete reference.
%
%       ALSO SEE revprod, jacsp
%
%
%       ******************************************************************
%       *              ADMIT Project   10-1-96                           *
%       *              Copyright (c) 1996 Cornell University.            *
%       ******************************************************************
global globp;
n=length(x); 
fun=deblank(fun);
if nargin < 5 Extra=[]; end
if nargin < 4 m=[]; end
if isempty(m) m=n; end

[p,q]=size(x);
if ((p==1) | (q==1)) globp=size(V,2);
else
    globp=size(V,3); 
end

fun=deblank(fun);
if globp==1
    xx=derivS(x,V);
else
    xx=deriv(x,V);
end
y=feval(fun,xx,Extra);
JV=getydot(y);
f=getval(y);
