function Fvec = nlsf3(x,dummy);
%NLSF3	Test function
%
%  Evaluate a ``structured'' vector function Fvec,
%
%     Fvec = F(A^{-1}*F(x))
%  
%  where F is a nonlinear square mapping,
%  with tridiagonal Jacobian, and A = A(x)
%  is a symmetric positive definite matrix.
%
%
%  Fvec is the vector function evaluated at x, dx is the newton step,
%  J is reurned as an array containing the sparse Jacobian ``components''.
%  The array J can be used with function nlsmm3 to compute corresponding
%  matrix-vector products. Note that the Jacobian of Fvec is
%  never explicity computed.
%
   n=length(x);
%
%  Evaluate F(x) = nlsf1(x), and the corresponding Jacobian matrix.
   y1=nlsf3b(x);
%
%  Evaluate matrix A, SPD
%
%  Get S, the structure of the matrix A
   load nlsdat3
%
%  Evaluate A
   A=compa(x,S);
%  
%  Determine MDO of A, sparse Cholesky factor
%   p = symmmd(A); p = p';
%   R = chol(A(p,p));
%
%  Solve for A^{-1}*F(x).
%   w = R'\y1(p); y2(p,1) = R\w;
    y2=A\y1;
%
%  Compute the vector function Fvec and the Jacobian of F with respect to
%  the argument y2 (tri-diagonal) 
   Fvec=nlsf3b(y2);
