function fvec = nlsf3b(x,dummy);
%
% Evaluate  nonlinear equations test function.
%
% INPUT:
%     x - The current point (column vector).
% dummy - dummy variable.
%
% OUTPUT:
%  fvec - The (vector) function value at x.
%  A    - The (sparse) rectangular Jacobian matrix.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Evaluate the vector function
  n = length(x);
  i=2:(n-1); fvec=zeros(n,1);
  fvec(i)= (3-2*x(i).^3).*x(i)-x(i-1)-2*x(i+1)+ones(n-2,1);
  fvec(n)= (3-2*x(n).^3).*x(n)-x(n-1)+1;
  fvec(1)= (3-2*x(1).^3).*x(1)-2*x(2)+1;
