function [value, grad] = tbroy(x,dummy)
%TBROY Test problem
  n=length(x);
  p=7/3; y=zeros(n,1);
  i=2:(n-1);
  y(i,1)= abs((3-2*x(i,1)).*x(i,1)-x(i-1,1)-x(i+1,1)+ones(n-2,1)).^p;
  y(n,1)= abs((3-2*x(n,1)).*x(n,1)-x(n-1,1)+1).^p;
  y(1,1)= abs((3-2*x(1,1)).*x(1,1)-x(2,1)+1).^p;
  j=1:(n/2); z=zeros(length(j),1);
  z(j,1)=abs(x(j,1)+x(j+n/2,1)).^p;
  value=1+sum(y)+sum(z);
%
% Evaluate the gradient.
  if nargout > 1
     p=7/3; n=length(x); g = zeros(n,1);
     i=2:(n-1);
     t(i,1)=(3-2*x(i,1)).*x(i,1)-x(i-1,1)-x(i+1,1)+ones(n-2,1);
     g(i,1)= p*abs(t(i,1)).^(p-1).*sign(t(i,1)).*(3-4*x(i,1));
     g(i-1,1)=g(i-1,1)-p*abs(t(i,1)).^(p-1).*sign(t(i,1));
     g(i+1,1)=g(i+1,1)-p*abs(t(i,1)).^(p-1).*sign(t(i,1));
     tt = (3-2*x(n,1)).*x(n,1)-x(n-1,1)+1;
     g(n,1)=g(n,1)+p*abs(tt).^(p-1).*sign(tt).*(3-4*x(n,1));
     g(n-1,1)=g(n-1,1)-p*abs(tt).^(p-1).*sign(tt);
     tt=(3-2*x(1,1)).*x(1,1)-x(2,1)+1;
     g(1,1)=g(1,1)+p*abs(tt).^(p-1).*sign(tt).*(3-4*x(1,1));
     g(2,1)=g(2,1)-p*abs(tt).^(p-1).*sign(tt);
     j=1:(n/2); t(j,1)=x(j,1)+x(j+n/2,1);
     g(j,1) = g(j,1)+p*abs(t(j,1)).^(p-1).*sign(t(j,1));
     jj=j+(n/2);
     g(jj,1) = g(jj,1)+p*abs(t(j,1)).^(p-1).*sign(t(j,1));
     grad = g;
  end
