function argout=guioption(action,arg)
%
% ADMIT-2 Graphical User Interface
%
global K
global r
global q
global T
global M
global N
global TV
global S
global u
global V
global sigma

if nargin < 1
	action='initialize';
end

fig=findobj(get(0,'Children'),'Tag','OPTIONSGUI');
fig2=findobj(get(0,'Children'),'Tag','SETUPWIN');

if strcmp(action,'initialize')==1
K=95; 
r=0.1; 
q=0; 
T=0.25; 
N=20;
M=20;
sigma =0.5.*ones(N,1);

%initialize
	if isempty(fig)
		fig = figure('NumberTitle','off');
		set(fig,'Tag','OPTIONSGUI');
		setup=uimenu(fig,'Label','Setup Parameters','CallBack',['gui(''setupfun'')']);
		set(setup,'Tag','SETUP');
		setupopt=uimenu(fig,'Label','Optimization Parms');
		set(setupopt,'Tag','SETUPOPT');
		setupsens=uimenu(fig,'Label','sensitivities');
		set(setupsens,'Tag','SETUPOPT');
		method=uimenu(fig,'Label','Methods');
		set(method,'Tag','METHOD');
		misc=uimenu(fig,'Label','View');
		set(misc,'Tag','VIEW');
	end
class_fun1=uimenu(setupopt,'Label','fun1','Separator','on','CallBack','check(1)');
class_fun2=uimenu(setupopt,'Label','fun2','Separator','on','CallBack','check(2)');
class_fun3=uimenu(setupopt,'Label','fun3','Separator','on','CallBack','check(3)');
class_fun4=uimenu(setupopt,'Label','fun4','Separator','on','CallBack','check(4)');
class_fun5=uimenu(setupopt,'Label','fun5','Separator','on','CallBack','check(5)');
set(class_fun1,'Tag','Class_fun1');
set(class_fun2,'Tag','Class_fun2');
set(class_fun3,'Tag','Class_fun3');
set(class_fun4,'Tag','Class_fun4');
set(class_fun5,'Tag','Class_fun5');

method_config=uimenu(method,'Label','config','CallBack','gui(''config'');');
method_solve=uimenu(method,'Label','solve','CallBack','gui(''solve'');');

sigmasens=uimenu(setupsens,'Label','sigma scalar','CallBack','gui(''sigmasens'');');
sigmasens=uimenu(setupsens,'Label','sigma vector(exploiting str)','CallBack','gui(''sigmasensext'');');
rsens=uimenu(setupsens,'Label','I.rate','CallBack','gui(''rsens'');');
dsens=uimenu(setupsens,'Label','D.rate','CallBack','gui(''dsens'');');


misc_view=uimenu(misc,'Label','View final plot','CallBack','gui(''viewres'');');
misc_view2=uimenu(misc,'Label','View surface','CallBack','gui(''viewres3d'');');
enable3d=uimenu(misc,'Label','enable-3d-rot','Separator','on','CallBack','gui(''enable3d'')');

elseif strcmp(action,'sigmasensext')==1
if isa(sigma,'deriv')
out=solveoptieext(sigma,r,q);
else
out=solveoptieext(deriv(sigma,ones(N,1)),r,q);
end
plot(S,getydot(out));
title 'Sigma vector'
xlabel 'Asset Price'
ylabel 'DV(0)/d sigma'


elseif strcmp(action,'sigmasens')==1
if isa(sigma,'deriv')
out=solveoptie(sigma,r,q);
else
out=solveoptie(deriv(sigma,ones(N,1)),r,q);
end
plot(S,getydot(out));
title 'Sigma scalar'
xlabel 'Asset Price'
ylabel 'DV(0)/d sigma'



elseif strcmp(action,'rsens')==1
out=solveoptie(sigma,deriv(r,1),q);
plot(S,getydot(out));
xlabel 'Asset Price'
ylabel 'DV(0)/d I.rate'



elseif strcmp(action,'dsens')==1
out=solveoptie(sigma,r,deriv(q,1));
plot(S,getydot(out));
xlabel 'Asset Price'
ylabel 'DV(0)/d D.rate'




elseif strcmp(action,'viewres')==1
plot(S,u);
xlabel 'Asset Price'
ylabel 'Option Value'
elseif strcmp(action,'viewres3d')==1
surf(TV,S,V);
xlabel 'Time'
ylabel 'Asset Price'
zlabel 'Option Value'

elseif strcmp(action,'enable3d')==1
rotate3d;

elseif strcmp(action,'solve')==1
solveoptie(sigma,r,q);

elseif strcmp(action,'config')==1
argout=JPI;

elseif strcmp(action,'setupfun')==1
if ~isempty(fig2) close(fig2); end
fig2 = figure('NumberTitle','off');
set(fig2,'Tag','SETUPWIN');
	GUIsetup(fig2);
end
